# modified by wizzard <wizzard@ni-te.de>
# original "RoundBar" by Michele Albanese

# task support added in by Ari Steinberg, with help from OSXDocker
# ari's todo: 
#	fix crash on load without xmms
#	option to set # zoom frames
#	add generic readouts (cpu, mem, etc.)
#	smarter icon finding
#	improve configuration

# IMPORTANT: requires PyXMMS module
# get it at http://www.via.ecp.fr/~flo/index.en.html

#this import statement allows access to the karamba functions

import karamba
import glob
import string
import os
import os.path
import xmms

#Path to your favorite iconset and to the standard icon path
iconThemes = [ "/usr/share/icons/Noia KDE 0.95/", "/usr/share/icons/default.kde/" ]

#Path to link files (can be absolute or relative)
linkfilesPath = "/home/ari/karamba/AriDynBar/Files/"

selectedTextTask = -1

#Space on the left/right side (clock, pager...)
spaceL = 150 #150 if using examples from theme file
spaceR = 0

currText = [ ] 

#Times to "blink" when clicking icon
blink = 1

#XMMS controls
#-1 disabled / 0 enabled
#xmmsBar = 0

bar = [ ]

names = [ ]
icons = [ ]
tasks = [ ]
niceTaskNames = [ ]
running = [ ]
commands = [ ]
# keep track of alternate names for apps like mozilla or xmms which are identified by an alternate name (Navigator or XMMS_Player)
# (use "AltName = Navigator" in your *.desktop file)
altnames = [ ]
arrows = [ ]

iconCount = 0
permIconCount = 0

iconZoomed = -1

currentTask = -1

songname = 0

currDesktop = 1

iconTypes = [ "actions/", "apps/", "devices/", "filesystems/", "mimetypes/" ]

#Autodetect the resolution, thanks to Adam Geitgey!
havexwi = os.system("which xwininfo")

if (havexwi == 0):
	pass
else:
	print "\nCan't find xwininfo in your path."

fp = os.popen("xwininfo -root -stats")
output = fp.read()
output = output.splitlines()
i = 0
for x in output:
	param = x.split()
	if (len(param) > 1):
		if param[0].find("Width:") != -1:
			print param[1]
			resX = int(param[1])
		if param[0].find("Height:") != -1:
			print param[1]
			resY = int(param[1])


def createIcon(widget, name, iconNum, path):
	global iconPath, iconThemes
	global iconTypes
	global icons
	global arrows

	found = 0

	if path:
		pathSmall = path
		pathBig = path
		found = 1
	else:
		for iconTheme in iconThemes:
			for thisType in iconTypes:
				if len(glob.glob(iconTheme + "64x64/" + thisType + name + ".png")) > 0:
					print "found icon " + iconTheme + "64x64/" + thisType + name + ".png" + " for " + name
					path = iconTheme + "64x64/" + thisType + name + ".png"
					found = 1
					break
			if found:
				break
	if found:
		if iconNum == len(icons):
			icons.append(karamba.createImage(widget, 32+spaceL+(iconNum*64), 0, path))
			arrows.append(karamba.createImage(widget, 32+spaceL+(iconNum*64)+28, 55, "Pics/arrow.png"))
		else:
			icons.insert(iconNum, karamba.createImage(widget, 32+spaceL+(iconNum*64), 0, path))
			arrows.insert(iconNum, karamba.createImage(widget, 32+spaceL+(iconNum*64)+28, 55, "Pics/arrow.png"))

		ResizeIcon(widget, iconNum, 48, 1)
		karamba.hideImage(widget, arrows[iconNum])
		karamba.resizeImage(widget, arrows[iconNum], 9, 5)

	else:
		print "icon not found for " + name
		if name == "xapp":
			print "sorry...giving up, try to find an icon set which includes \"x.png\" or \"xapp.png\""
		elif name == "x":
			createIcon(widget, "xapp", iconNum, "")
		else:
			createIcon(widget, "x", iconNum, "")
	pass

def ResizeIcon(widget, icon, size, smooth):
	global icons

	offset = (64-size)/2
	if smooth:
		karamba.resizeImageSmooth(widget, icons[icon], size, size)
	else:
		karamba.resizeImage(widget, icons[icon], size, size)
	karamba.moveImage(widget, icons[icon], 32+spaceL+(icon)*64+offset, offset)
	pass
	

def Initialize(widget):
	global iconThemes
	global iconPath
	global kickerPath
	global resX
	global resY
	global bar
	global enableBg, bgLeft, bgMiddle, bgRight
	global names
	global icons
	global commands
	global altnames
	global iconCount
	global permIconCount
	global xmmsBar
	global running
	global tasks
	global niceTaskNames
	global songname

	#hide images
	for i in range(iconCount):
		karamba.hideImage(widget, icons[i])
		karamba.hideImage(widget, arrows[i])

	names = [ ]
	icons = [ ]
	running = [ ]
	tasks = [ ]
	niceTaskNames = [ ]
	commands = [ ]
	altnames = [ ]
	iconCount = 0
	permIconCount = 0
	iconZoomed = -1


	if bar == [ ]:
		#bar.append(karamba.createImage(widget, 0, 0, "Pics/head-left.png"))
		#bar.append(karamba.createImage(widget, 32, 0, "Pics/middle.png"))
		#bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 0, "Pics/head-right.png"))
		if xmmsBar >= 0:
			bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 0, "Pics/xmms-handle.png"))
			bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 40, "Pics/xmms-controls.png"))
			bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 30, "Pics/xmms-bar.png"))
			bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR+100, 25, "Pics/volume-buttons.png"))
			songname = karamba.createText(widget, 32+spaceL+(iconCount*64)+spaceR, 10, 125, 20, xmms.get_playlist_title(xmms.get_playlist_pos()))
			karamba.changeTextColor(widget, songname, 255, 255, 255)
			karamba.changeTextSize(widget, songname, 6)

	names.append("")
	running.append(0)
	tasks.append([ ])
	niceTaskNames.append([ ])
	commands.append("dcop kicker kicker popupKMenu 0")
	altnames.append( [ ] ) 
	createIcon(widget, "kmenu", iconCount, "")
	iconCount +=1
	permIconCount +=1
	fileList = glob.glob(linkfilesPath+"*")
	fileList.sort() # Thanks to genneth
	for fileName in fileList:
		print "-----------------------------"
		print fileName
		if os.path.isfile(fileName) != 1:
			continue
		file = open(fileName, 'r')
		line = file.readline()
		foundName = 0
		foundExec = 0
		foundIcon = 0
		altnames.append( [ ] )
		if string.count(line, "[Desktop Entry]"):
			for line in file.readlines():
				if line[:4] == "Name" and not foundName:
					strPos = string.find(line, "=") + 1
					names.append(line[strPos:-1])
					foundName = 1
					print line[:strPos]+names[iconCount]
				if line[:4] == "Exec" and not foundExec:
					strPos = string.find(line, "=") + 1
					commands.append(line[strPos:-1])
					foundExec = 1
					#if not showtext:
						#karamba.createClickArea(widget, 32+spaceL+(iconCount*64), 8, 64, 64, line[strPos:-1])
					print line[:strPos]+commands[iconCount]
				if line[:4] == "Icon" and not foundIcon:
					line = string.replace(line, ".png", '')
					strPos = string.find(line, '=') + 1
					if glob.glob(line[strPos:-1]+".png") != []:
						createIcon(widget, line[strPos:-1], iconCount, line[strPos:-1]+".png")
					else:
						createIcon(widget, line[strPos:-1], iconCount, "")
					foundIcon = 1
				if line[:7] == "AltName":
					strPos = string.find(line, "=") + 1
					altnames[iconCount].append(line[strPos:-1])
					print line[:-1]
			# assume there is a name and icon for everything, not necessarily the other fields though:
			if not foundName:
				print "Warning: no Name= line found in " + fileName
				names.append("")
			if not foundExec:
				print "Warning: no Exec= line found in " + fileName
				commands.append("")
			if not foundIcon:
				if foundName:
					createIcon(widget, names[iconCount], iconCount, "")
				else:
					print "No Icon= line found in " + fileName + "; using default X icon"
					createIcon(widget, "x", iconCount, "")
			running.append(0)
			tasks.append([ ])
			niceTaskNames.append([ ])
			iconCount += 1
			permIconCount +=1

	karamba.createClickArea(widget, 32+spaceL, 8, iconCount*64, 64, "")
	if enableBg:
		karamba.resizeImage(widget, bgMiddle, spaceL+(iconCount*64)+spaceR, 70)
		karamba.moveImage(widget, bgRight, 32+spaceL+(iconCount*64)+spaceR, 0)
	if xmmsBar >= 0:
		karamba.moveImage(widget, bar[0], 32+spaceL+(iconCount*64)+spaceR, 0)
		karamba.moveImage(widget, bar[1], 32+spaceL+(iconCount*64)+spaceR+10, 40)
		karamba.moveImage(widget, bar[2], 32+spaceL+(iconCount*64)+spaceR, 30)
		karamba.moveImage(widget, bar[3], 32+spaceL+(iconCount*64)+spaceR+100, 25)
		karamba.moveText(widget, songname, 32+spaceL+(iconCount*64)+spaceR, 10)
		karamba.showImage(widget, bar[0])
		karamba.hideImage(widget, bar[1])
		karamba.hideImage(widget, bar[2])
		karamba.hideText(widget, songname)


	karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32, 64)
	karamba.moveWidget(widget, (resX-32-spaceL-(iconCount*64)-spaceR-32)/2, resY-70)

	karamba.redrawWidget(widget)

	pass

def initWidget(widget):
	global enableBg, bgLeft, bgMiddle, bgRight
	global showtext, smoothZoom, xmmsBar
	
	karamba.addMenuConfigOption(widget, "disabletext", "Disable text?")
	karamba.addMenuConfigOption(widget, "disablezoom", "Disable smooth zoom?")
	karamba.addMenuConfigOption(widget, "disablebg", "Disable background? (requires reload)")
	karamba.addMenuConfigOption(widget, "enablexmms", "Enable XMMS? (requires reload)")
	showtext = 1 - karamba.readMenuConfigOption(widget, "disabletext")
	smoothZoom = 1 - karamba.readMenuConfigOption(widget, "disablezoom")
	enableBg = 1 - karamba.readMenuConfigOption(widget, "disablebg")
	xmmsBar = karamba.readMenuConfigOption(widget, "enablexmms") - 1

	bgLeft = karamba.getThemeImage(widget, "bgLeft")
	bgMiddle = karamba.getThemeImage(widget, "bgMiddle")
	bgRight = karamba.getThemeImage(widget, "bgRight")
	if not enableBg:
		karamba.deleteImage(widget, bgLeft)
		karamba.deleteImage(widget, bgMiddle)
		karamba.deleteImage(widget, bgRight)
	if xmmsBar == 0:
		if not xmms.is_running():
			xmmsBar = -1
			print "WARNING: xmms not running; disabling xmms bar (restart with XMMS running to re-enable bar)"
	
	Initialize(widget)
	pass

def widgetUpdated(widget):
	global linkfilesPath
	global icons
	global running
	global iconCount
	global commands
	global altnames
	global tasks
	global niceTaskNames
	global bar
	global enableBg, bgLeft, bgMiddle, bgRight
	global arrows
	global songname

	changed = 0

	# clear running status of everything
	for i in range(iconCount):
		running[i] = 0
		tasks[i] = [ ]
		niceTaskNames[i] = [ ]
		karamba.hideImage(widget, arrows[i])

	# find the ones running
	taskList = karamba.getTaskList(widget)
	taskInfo = [ ]
	for task in taskList:
		taskInfo.append(karamba.getTaskInfo(widget, task))
		taskName = karamba.getTaskInfo(widget, task)[2]
		niceTaskName = karamba.getTaskInfo(widget, task)[0]
		#print karamba.getTaskInfo(widget, task)
		found = 0
		for i in range(iconCount):
			if taskName == commands[i]:
				#print "found: " + taskName
				running[i] = 1
				tasks[i].append(task)
				niceTaskNames[i].append(niceTaskName)
				karamba.showImage(widget, arrows[i])
				found = 1
				break
			else:
				for j in range(len(altnames[i])):
					if taskName == altnames[i][j]:
						#print "found: " + taskName
						running[i] = 1
						tasks[i].append(task)
						niceTaskNames[i].append(niceTaskName)
						karamba.showImage(widget, arrows[i])
						found = 1
						break
				if found:
					break
		if not found:
			# assign a new button
			#print "inserting button for " + karamba.getTaskInfo(widget, task)[2]
			changed = 1
			createIcon(widget, taskName, iconCount, "")
			running.append(1)
			tasks.append( [ task ] )
			niceTaskNames.append( [ niceTaskName ] )
			names.append(taskName)
			commands.append(taskName)
			altnames.append( [ taskName ] )
			karamba.showImage(widget, arrows[i])
			#if not showtext:
				#karamba.createClickArea(widget, 32+spaceL+(iconCount*64), 8, 64, 64, commands[iconCount])
			iconCount += 1

	# remove non-running, non-permanent buttons
	deleted = 0
	for i in range(iconCount - permIconCount):
		if not deleted:
			if not running[i + permIconCount]:
				deleted = 1
				changed = 1
				karamba.deleteImage(widget, icons[i+permIconCount])
				karamba.deleteImage(widget, arrows[i+permIconCount])
				del running[i+permIconCount]
				del icons[i+permIconCount]
				del arrows[i+permIconCount]
				del commands[i+permIconCount]
				del altnames[i+permIconCount]
				del names[i+permIconCount]
				del niceTaskNames[i+permIconCount]
				iconCount -= 1
				#print "deleted: "
				#print i + permIconCount
		# it seems the range doesn't get updated, so let's check again...
		if deleted and i < iconCount - permIconCount:
			#print "moving back one: " + commands[i+permIconCount]
			#print i + permIconCount
			karamba.moveImage(widget, icons[i+permIconCount], 32+spaceL+(i+permIconCount)*64+8, 8)
			karamba.moveImage(widget, arrows[i+permIconCount], 32+spaceL+(i+permIconCount)*64+28, 55) 

	if xmmsBar > 0:
		karamba.changeText(widget, songname, xmms.get_playlist_title(xmms.get_playlist_pos()))

	if changed:
		if enableBg:
			karamba.moveImage(widget, bgRight, 32+spaceL+(iconCount*64)+spaceR, 0)
			karamba.resizeImage(widget, bgMiddle, spaceL+(iconCount*64)+spaceR, 70)
		if xmmsBar >= 0:
			karamba.moveImage(widget, bar[0], 32+spaceL+(iconCount*64)+spaceR, 0)
			karamba.moveImage(widget, bar[1], 32+spaceL+(iconCount*64)+spaceR+10, 40)
			karamba.moveImage(widget, bar[2], 32+spaceL+(iconCount*64)+spaceR, 30)
			karamba.moveImage(widget, bar[3], 32+spaceL+(iconCount*64)+spaceR+100, 25)
			karamba.moveText(widget, songname, 32+spaceL+(iconCount*64)+spaceR, 10)
			karamba.showImage(widget, bar[0])
			karamba.hideImage(widget, bar[1])
			karamba.hideImage(widget, bar[2])
			karamba.hideText(widget, songname)

		#karamba.createClickArea(widget, 32+spaceL, 4, iconCount*64, 56, "")
	
		karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32, 64)
		karamba.moveWidget(widget, (resX-32-spaceL-(iconCount*64)-spaceR-32)/2, resY-70)
	
		karamba.redrawWidget(widget)
	pass

def widgetClicked(widget, x, y, button):
	global iconCount
	global spaceL
	global commands
	global altnames
	global blinks
	global icons
	global tasks
	global currentTask
	global showtext
	global selectedTextTask
	global songname
	
	icon = (x-32-spaceL) / 64

	if button == 4 and 0 <= icon < iconCount and running[icon]:
		if currentTask < 0:
			currentTask = len(tasks[icon])-1
		else:
			currentTask -= 1
			currentTask = currentTask % len(tasks[icon])
		karamba.performTaskAction(widget, tasks[icon][currentTask], 8)
	elif button == 5 and 0 <= icon < iconCount and running[icon]:
		if currentTask < 0:
			currentTask = 0
		else:
			currentTask += 1
			currentTask = currentTask % len(tasks[icon])
		karamba.performTaskAction(widget, tasks[icon][currentTask], 8)
	elif button == 2:
		os.system("kstart konqueror "+linkfilesPath)
	elif button == 1 and 32+spaceL <= x <= 32+spaceL+(iconCount*64) and 8 <= y <= 60:
		#if icon == 0:
			#os.system(commands[icon]+" &")
		if 0 <= icon < iconCount:
			if showtext:
				if selectedTextTask < 0:
					os.system(commands[icon]+" &")
					print "Execute: "+commands[icon]
					for i in range(blink):
						mouseOver(widget, -1, -1)
						mouseOver(widget, icon, -1)
				else:
					karamba.performTaskAction(widget, tasks[icon][selectedTextTask], 8)
			else:
				os.system(commands[icon]+" &")
				print "Execute: "+commands[icon]
				for i in range(blink):
					mouseOver(widget, -1, -1)
					mouseOver(widget, icon, -1)
	elif button == 1 and 32+spaceL+(iconCount*64)+spaceR+14 <= x <= 32+spaceL+(iconCount*64)+spaceR+14+52 and 40 <= y <= 48:
		if xmmsBar:
			control = (x-32-spaceL-(iconCount*64)-spaceR-14)/11
			if control == 0:
				if xmms.is_pl_win():
					x = 0
				else:
					x = 1
				xmms.pl_win_toggle(x)
			if control == 1:
				xmms.playlist_prev()
				karamba.changeText(widget, songname, xmms.get_playlist_title(xmms.get_playlist_pos()))
			if control == 2:
				xmms.stop()
			if control == 3:
				xmms.play_pause()
			if control == 4:
				xmms.playlist_next()
				karamba.changeText(widget, songname, xmms.get_playlist_title(xmms.get_playlist_pos()))
	elif button == 1 and 32+spaceL+(iconCount*64)+spaceR+100 <= x <= 32+spaceL+(iconCount*64)+spaceR+100+24 and 25 <= y <= 49:
		if xmmsBar:
			control = (y-25)/12
			if control == 0:
				xmms.set_main_volume(xmms.get_main_volume()+5)
			if control == 1:
				xmms.set_main_volume(xmms.get_main_volume()-5)
	pass


def mouseOver(widget, icon, y):
	global iconZoomed
	global icons
	global smoothZoom
	global currText
	global niceTaskNames
	global showtext
	global selectedTextTask

	changed = 0

	if icon != iconZoomed:
		if smoothZoom:
			if iconZoomed > -1:
				ResizeIcon(widget, iconZoomed, 60, 0)
			if icon > -1:
				ResizeIcon(widget, icon, 52, 0)
			karamba.redrawWidget(widget)

			if iconZoomed > -1:
				ResizeIcon(widget, iconZoomed, 56, 0)
			if icon > -1:
				ResizeIcon(widget, icon, 56, 0)
			karamba.redrawWidget(widget)

			if iconZoomed > -1:
				ResizeIcon(widget, iconZoomed, 52, 0)
			if icon > -1:
				ResizeIcon(widget, icon, 60, 0)
			karamba.redrawWidget(widget)

		if iconZoomed > -1:
			ResizeIcon(widget, iconZoomed, 48, 1)
			changed = 1
		if icon > -1:
			ResizeIcon(widget, icon, 64, 1)
			changed = 1
		if showtext:
			if iconZoomed > -1:
				for i in range(len(currText)):
					karamba.deleteText(widget, currText[i])
			currText = [ ]
		currentTask = -1
	
	if showtext and icon > -1:
		changed = 1
		numTasks = len(niceTaskNames[icon])
		if numTasks + 1 != len(currText):
			for i in range(len(currText)):
				karamba.deleteText(widget, currText[i])
			currText = [ ]
			currText.append(karamba.createText(widget, 32+spaceL+(icon*64)-13, 50 - numTasks*10, 90, 20, names[icon]))
			for i in range(len(niceTaskNames[icon])):
				currText.append(karamba.createText(widget, 32+spaceL+(icon*64)-13, 60 - (numTasks-i)*10, 90, 20, niceTaskNames[icon][i]))
		selectedTextTask = -1
		for i in range(len(currText)):
			karamba.changeTextSize(widget, currText[i], 9)
			if i == 0:
				karamba.changeTextColor(widget, currText[i], 255, 0, 0)
			else:
				karamba.changeTextColor(widget, currText[i], 255, 255, 255)
			if 50-(numTasks-i)*10 <= y < 60-(numTasks-i)*10:
				selectedTextTask = i - 1
				karamba.changeTextColor(widget, currText[i], 0, 255, 0)

	if changed:
		karamba.redrawWidget(widget)

	iconZoomed = icon
	pass

def widgetMouseMoved(widget, x, y, button):
	global iconZoomed
	global icons
	global xmmsBar
	global enableBg, bgLeft, bgMiddle, bgRight
	global bar
	global currentTask
	global songname

	if 32+spaceL <= x < 32+spaceL+(iconCount*64) and 8 <= y <= 60:
		icon = (x-32-spaceL) / 64
		mouseOver(widget, icon, y)
	elif iconZoomed > -1:
		mouseOver(widget, -1, y)

	if 32+spaceL+(iconCount*64)+spaceR <= x < 32+spaceL+(iconCount*64)+spaceR+32+120 and 4 <= y <= 60:
		if xmmsBar == 0:
			karamba.changeText(widget, songname, xmms.get_playlist_title(xmms.get_playlist_pos()))
			karamba.showText(widget, songname)
			karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32+120, 64)
			if enableBg:
				karamba.resizeImage(widget, bgMiddle, spaceL+(iconCount*64)+spaceR+120, 70)
				karamba.moveImage(widget, bgRight, 32+spaceL+(iconCount*64)+spaceR+120, 0)
			karamba.hideImage(widget, bar[0])
			karamba.showImage(widget, bar[1])
			karamba.showImage(widget, bar[2])
			karamba.redrawWidget(widget)
			xmmsBar = 1
	elif xmmsBar == 1:
		if enableBg:
			karamba.resizeImage(widget, bgMiddle, spaceL+(iconCount*64)+spaceR, 70)
			karamba.moveImage(widget, bgRight, 32+spaceL+(iconCount*64)+spaceR, 0)
		karamba.showImage(widget, bar[0])
		karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32, 64)
		karamba.hideImage(widget, bar[1])
		karamba.hideImage(widget, bar[2])
		karamba.hideText(widget, songname)
		karamba.redrawWidget(widget)
		xmmsBar = 0
	pass

def menuOptionChanged(widget, key, value):
	global showtext
	global smoothZoom
	global enableBg
	global xmmsBar

	showtext = 1 - karamba.readMenuConfigOption(widget, "disabletext")
	smoothZoom = 1 - karamba.readMenuConfigOption(widget, "disablezoom")
	enableBg = 1 - karamba.readMenuConfigOption(widget, "disablebg")
	xmmsBar = karamba.readMenuConfigOption(widget, "enablexmms") - 1

	pass
	

# This will be printed when the widget loads.
print "Loaded my python extension!"
