#!/bin/bash
#
## ${1} = netjuke_path
## ${2} = id3_src
## ${3} = info_dump_path


db_netjuke="netjuke"
tbl_netjuke_tracks="netjuke_tracks"
netjuke_id=""
netjuke_pwd=""
netjuke_host="localhost"


########################################################
## Finished checking and setting defaults

########################################################

## Only allow editing of file when XMMS is playing the file before editing
## We want to make sure the right file is used when writing back any changes.
if xmmsctrl playing; then

   if [ "${2}" = "internal_v1" ]; then
      echo "ID3v1 editing (currently not implemented)"  > ${3}
      exit
   elif [ "${2}" = "internal_v2" ]; then
      echo "ID3v2 editing (currently not implemented)"  > ${3}
      exit
   elif [ "${2}" = "netjuke" ]; then
      #tag_type=`kdialog --combobox "Select ID3 Tag to edit:" "Track Title" "Artist Name" "Comments" "Album Name" "Genre" "Year" "Album Img URL" "Artist Img URL" "Lyrics" "License"`
      tag_type=`kdialog --combobox "Select ID3 Tag to edit:" "Comments" "Track Title" "Year" "Lyrics" "License"`

      tr_id=`mysql -BN -e "SELECT id FROM $tbl_netjuke_tracks WHERE location = '${1}';" $db_netjuke`
      ar_id=`mysql -BN -e "SELECT ar_id FROM $tbl_netjuke_tracks WHERE id = '$tr_id';" $db_netjuke`
      al_id=`mysql -BN -e "SELECT al_id FROM $tbl_netjuke_tracks WHERE id = '$tr_id';" $db_netjuke`
      ge_id=`mysql -BN -e "SELECT ge_id FROM $tbl_netjuke_tracks WHERE id = '$tr_id';" $db_netjuke`

      if [ $? = 0 ]; then
         if [ "$tag_type" = "Track Title" ]; then
            table=$tbl_netjuke_tracks; column="name"; target="$tr_id"
         elif [ "$tag_type" = "Artist Name" ]; then
            #table=$tbl_netjuke_artists; column="name"; target="$ar_id"
            echo -e "Not available!\nNo changes were made"  > ${3}
            exit
         elif [ "$tag_type" = "Comments" ]; then
            table=$tbl_netjuke_tracks; column="comments"; target="$tr_id"
         elif [ "$tag_type" = "Album Name" ]; then
            #table=$tbl_netjuke_albums; column="name"; target="$al_id"
            echo -e "Not available!\nNo changes were made"  > ${3}
            exit
         elif [ "$tag_type" = "Genre" ]; then
            #table=$tbl_netjuke_genres; column="name"; target="$ge_id"
            echo -e "Not available!\nNo changes were made"  > ${3}
            exit
         elif [ "$tag_type" = "Year" ]; then
            table="netjuke_tracks"; column="year"; target="$tr_id"
            #tag_item="tr_year"
         elif [ "$tag_type" = "Album Img URL" ]; then
            #table=$tbl_netjuke_albums; column="img_src"; target="$al_id"
            echo -e "Not available!\nNo changes were made"  > ${3}
            exit
         elif [ "$tag_type" = "Artist Img URL" ]; then
            #table=$tbl_netjuke_artists; column="img_src"; target="$ar_id"
            echo -e "Not available!\nNo changes were made"  > ${3}
            exit
         elif [ "$tag_type" = "Lyrics" ]; then
            table=$tbl_netjuke_tracks; column="lyrics"; target="$tr_id"
         elif [ "$tag_type" = "License" ]; then
            table="netjuke_tracks"; column="license"; target="$tr_id"
         else
            echo "Operation cancelled\nNo changes were made"  > ${3}
            exit
         fi
      else
         echo "Operation cancelled\nNo changes were made"  > ${3}
         exit
      fi

      cur_id3_str=`mysql -BN -e "SELECT $column FROM $table WHERE id = '$target';" $db_netjuke`
      new_tag_str=`kdialog --title "ID3 Tag editing" --inputbox "Enter / change ID3 tag:    ( \".~\" - clears the tag)" "$cur_id3_str"`

      if [ $? = 0 ]; then
         if [ "$new_tag_str" = ".$HOME" ]; then
            mysql -BN -e "UPDATE $table SET $column = '' WHERE id = '$target';" $db_netjuke
            ## S A V I N G    T a g s    t o    f i l e    V I A    N e t j u k e  ___ NOT WORKING___
            #url="$netjuke_serv_path/admin/tr-edit.php?netjuke_login=$netjuke_id&netjuke_password=$netjuke_pwd&do=save&tr_id=$tr_id&$tag_item=$cur_id3_str"
            #kfmclient exec $url
            echo -e $tag_type " tag has been cleared"  > $HOME/.superkaramba/info-str
         else
            mysql -BN -e "UPDATE $table SET $column = '$new_tag_str' WHERE id = '$target';" $db_netjuke
            ## S A V I N G    T a g s    t o    f i l e    V I A    N e t j u k e  ___ NOT WORKING___
            #url="$netjuke_serv_path/admin/tr-edit.php?netjuke_login=$netjuke_id&netjuke_password=$netjuke_pwd&do=save&tr_id=$tr_id&$tag_item=$cur_id3_str"
            #kfmclient exec $url
            echo -e $tag_type " tag has been changed to:  \""$new_tag_str"\""  > ${3}
         fi
      else
         echo -e "Operation cancelled\nNo changes were made"  > ${3}
         exit
      fi

   else
      echo -e "Operation cancelled\nNo ID3 tag source is set."  > ${3}
      exit
   fi

else

   echo "No Track is being played...\n \nPlease click on Play-button and re-select."  > ${3}
   exit

fi