#!/bin/bash

# ${1} - media_type
# ${2} - track_path
# ${3} - info_dump_path

if [ "${1}" = "mp3" ]; then
   ar="Artist:\t\t"`id3 -lR ${2} | grep "Artist:" | cut -d':' -f2`
   ti="Title:\t\t"`id3 -lR ${2} | grep "Title:" | cut -d':' -f2`
   al="Album:\t\t"`id3 -lR ${2} | grep "Album:" | cut -d':' -f2`"\t[Track: "`id3 -lR ${2} | grep "Track" | cut -d':' -f2`"]"
   ge="Genre:\t\t"`id3 -lR ${2} | grep "Genre:" | cut -d':' -f2`
   ye="Year:\t\t"`id3 -lR ${2} | grep "Year:" | cut -d':' -f2`
   co="Comment:\t"`id3 -lR ${2} | grep "Comment:" | cut -d':' -f2`
else
   ar="Artist:\t\t"`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ARTIST=" | cut -d'=' -f2`
   ti="Title:\t\t"`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "TITLE=" | cut -d'=' -f2`
   al="Album:\t\t"`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ALBUM=" | cut -d'=' -f2`"\t[Track: "`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "TRACKNUMBER=" | cut -d'=' -f2`"]"
   ge="Genre:\t\t"`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "GENRE=" | cut -d'=' -f2`
   ye="Year:\t\t"`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "DATE=" | cut -d'=' -f2`
   co="Comment:\t"`ogginfo ${2} | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "COMMENTS=" | cut -d'=' -f2`
fi

echo -e "$ar\n$ti\n$al\n$ge\n$ye\n$co\n" > ${3}