#!/bin/bash
#
#  ${1} =  track_path
#  ${2} =  id3_src
#  ${3} =  tag_item
#  ${4} =  media_type

if [ "${4}" = "mp3" ]; then
   if [ "${2}" = "internal_v1" ]; then
      if [ "${3}" = "artist" ]; then
         echo `id3 -lR "${1}" | grep "Artist:" | cut -d':' -f2`
      elif [ "${3}" = "title" ]; then
         echo `id3 -lR "${1}" | grep "Title:" | cut -d':' -f2`
      elif [ "${3}" = "album" ]; then
         echo `id3 -lR "${1}" | grep "Album:" | cut -d':' -f2`
      elif [ "${3}" = "genre" ]; then
         echo `id3 -lR "${1}" | grep "Genre:" | cut -d':' -f2`
      elif [ "${3}" = "year" ]; then
         echo `id3 -lR "${1}" | grep "Year:" | cut -d':' -f2`
      elif [ "${3}" = "comments" ]; then
         echo `id3 -lR "${1}" | grep "Comment:" | cut -d':' -f2`
      else
         exit
      fi
   elif [ "${2}" = "internal_v2" ]; then
      if [ "${3}" = "artist" ]; then
         echo `id3info "${1}" | grep "=== TPE1" | sed 's/^.*: //g'`
      elif [ "${3}" = "title" ]; then
         echo `id3info "${1}" | grep "=== TIT2" | sed 's/^.*: //g'`
      elif [ "${3}" = "album" ]; then
         echo `id3info "${1}" | grep "=== TALB" | sed 's/^.*: //g'`
      elif [ "${3}" = "genre" ]; then
         echo `id3info "${1}" | grep "=== TCON" | sed 's/^.*: //g'`
      elif [ "${3}" = "year" ]; then
         echo `id3info "${1}" | grep "=== TYER" | sed 's/^.*: //g'`
      elif [ "${3}" = "comments" ]; then
         echo `id3info "${1}" | grep "(Track Comments)" | sed 's/^.*: //g'`
      else
         exit
      fi
   else
      exit
   fi

elif [ "${4}" = "ogg" ]; then
   if [ "${3}" = "artist" ]; then
      echo `ogginfo "${1}" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ARTIST=" | cut -d'=' -f2`
   elif [ "${3}" = "title" ]; then
      echo `ogginfo "${1}" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "TITLE=" | cut -d'=' -f2`
   elif [ "${3}" = "album" ]; then
      echo `ogginfo "${1}" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ALBUM=" | cut -d'=' -f2`
   elif [ "${3}" = "genre" ]; then
      echo `ogginfo "${1}" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "GENRE=" | cut -d'=' -f2`
   elif [ "${3}" = "year" ]; then
      echo `ogginfo "${1}" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "DATE=" | cut -d'=' -f2`
   elif [ "${3}" = "comments" ]; then
      echo `ogginfo "${1}" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "COMMENTS=" | cut -d'=' -f2`
   else
      exit
   fi
else
   exit
fi
