#!/bin/bash

## ${1} = cur_artist
## ${2} = info_dump_path
## ${3} = cur_title
## ${4} = cur_album
## ${5} = iconGracenote

icon=${5}

cur_artist=`echo ${1} | sed s/' '/'+'/g`
cur_title=`echo ${3} | sed s/' '/'+'/g`
cur_album=`echo ${4} | sed s/' '/'+'/g`
hitspp="25"

action=`kdialog --miniicon "$icon" --combobox "Select a combination to search for:" "search any field" "Artist + Song + Album" "Artist + Song" "Artist only" "Song only" "Album only"`

if [ "$action" = "search any field" ]; then
   anyfield=`kdialog --miniicon "$icon" --inputbox "Enter text to search for:"`
elif [ "$action" = "Artist + Song + Album" ]; then
   artist=`kdialog --miniicon "$icon" --inputbox "Enter Artist name:" "${1}"`
   title=`kdialog --miniicon "$icon" --inputbox "Enter Song title:" "${3}"`
   album=`kdialog --miniicon "$icon" --inputbox "Enter Album name:" "${4}"`
elif [ "$action" = "Artist + Song" ]; then
   artist=`kdialog --miniicon "$icon" --inputbox "Enter Artist name:" "${1}"`
   title=`kdialog --miniicon "$icon" --inputbox "Enter Song title:" "${3}"`
   album=""
elif [ "$action" = "Artist + Album" ]; then
   artist=`kdialog --miniicon "$icon" --inputbox "Enter Artist name:" "${1}"`
   title=""
   album=`kdialog --miniicon "$icon" --inputbox "Enter Album name:" "${4}"`
elif [ "$action" = "Song + Album" ]; then
   artist=""
   title=`kdialog --miniicon "$icon" --inputbox "Enter Song title:" "${3}"`
   album=`kdialog --miniicon "$icon" --inputbox "Enter Album name:" "${4}"`
elif [ "$action" = "Artist only" ]; then
   artist=`kdialog --miniicon "$icon" --inputbox "Enter Artist name:" "${1}"`
   title=""
   album=""
elif [ "$action" = "Song only" ]; then
   artist=""
   title=`kdialog --miniicon "$icon" --inputbox "Enter Song title:" "${3}"`
   album=""
elif [ "$action" = "Album only" ]; then
   artist=""
   title=""
   album=`kdialog --miniicon "$icon" --inputbox "Enter Album name:" "${4}"`
fi

xmatch=`kdialog --title "Search Gracenote" --yesno "Search for exact match?"`
if [ $? = 0 ]; then
   xartist="&xa=on"
   xtitle="&xt=on"
   xalbum="&xd=on"
else
   xartist=""
   xtitle=""
   xalbum=""
fi

hitspp=`kdialog --miniicon "$icon" --combobox "Number of hits shown:" "10" "25"`

qartist=`echo ${artist} | sed s/' '/'+'/g`
qtitle=`echo ${title} | sed s/' '/'+'/g`
qalbum=`echo ${album} | sed s/' '/'+'/g`


url="http://www.gracenote.com/music/search-adv.html?q=${anyfield}$xartist&qartist=${qartist}$xalbum&qdisc=${qalbum}$xtitle&qtrack=${qtitle}&n=$hitspp&x=51&y=11"
# q=ABBA&qartist=&qdisc=&qtrack=&n=10&x=54&y=12
lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=100 -tagsoup -nolist | sed '/ *Displaying Disc */,/ *\[cleardot.gif\] */!d' | sed '/ *Displaying Disc .*/a\ ' | sed 's/^   *//g' | head -n 30 | sed '0,1i\
\
Matched Albums  @  Gracenote\
' > ${2}
