#!/bin/bash

## ${1} = cur_artist
## ${2} = cur_title
## ${3} = info_dump_path
## ${4} = iconCharts

iconCharts="${4}"
action=`kdialog --miniicon "$iconCharts" --combobox "Search or consult Charts?" "Search" "Consult"`
if [ "$action" = "Search" ]; then
   songpart=`kdialog --miniicon "$iconCharts" --combobox "Search Artist or Title?" "Artist" "Title"`
   if [ "$songpart" = "Artist" ]; then
      songpart="artiest"
      search_str=`kdialog --miniicon "$iconCharts" --title "Search the Charts" --inputbox "Enter Artist/Band name to search for:" "${1}"`
   else
      songpart="titel"
      search_str=`kdialog --miniicon "$iconCharts" --inputbox "Enter Title to search for:" "${2}"`
   fi

   filter=`kdialog --miniicon "$iconCharts" --combobox "Sort results by: " "Artist" "Title" "Weeks" "Position" "Date"`
   if [ "$filter" = "Artist" ]; then
      filter="artiest"
   elif [ "$filter" = "Title" ]; then
      filter="titel"
   elif [ "$filter" = "Weeks" ]; then
      filter="weken"
   elif [ "$filter" = "Position" ]; then
      filter="positie"
   elif [ "$filter" = "Date" ]; then
      filter="datum"
   else
      filter="datum"
   fi

   search_str=`echo $search_str | sed 's/ /+/g'`

   url="overzicht.php?$songpart=$search_str&l=1&order=$filter&ad=DESC"

elif [ "$action" = "Consult" ]; then

   consulttype=`kdialog --miniicon "$iconCharts" --combobox "Listing or Release Charts?" "List" "Release"`
   if [ "$consulttype" = "List" ]; then
      listtype=`kdialog --miniicon "$iconCharts" --radiolist "Select a Chart to view:" "topxxx" "Top Charts per year" "off" "top100" "Top 100 per year" "off" "toppos" "Positions per year" "off"`
      if [ "$listtype" = "topxxx" ]; then
         top_aantal=`kdialog --miniicon "$iconCharts" --combobox "Choose Chart's size:" "10" "25" "50" "100" "150" "200" "250" "500"`
         top_jaar=`kdialog --miniicon "$iconCharts" --combobox "Choose year:" "1965" "1966" "1967" "1968" "1969" "1970" "1971" "1972" "1973" "1974" "1975" "1976" "1977" "1978" "1979" "1980" "1981" "1982" "1983" "1984" "1985" "1986" "1987" "1988" "1989" "1990" "1991" "1992" "1993" "1994" "1995" "1996" "1997" "1998" "1999" "2000" "2001" "2002" "2003"`
         url="overzicht.php?top_aantal=$top_aantal&top_jaar=$top_jaar"
      elif [ "$listtype" = "top100" ]; then
         jaren=`kdialog --miniicon "$iconCharts" --radiolist "Select a Chart to view:" "196" "Top 100 of the 60's" "off" "197" "Top 100 of the 70's" "off" "198" "Top 100 of the 80's" "off" "199" "Top 100 of the 90's" "off" "200" "Top 100 of the New Millenium" "off"`
         url="overzicht.php?jaren=$jaren"
      elif [ "$listtype" = "toppos" ]; then
         nummer=`kdialog --miniicon "$iconCharts" --combobox "Choose position:" "1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "11" "12" "13" "14" "15" "16" "17" "18" "19" "20" "21" "22" "23" "24" "25" "26" "27" "28" "29" "30" "31" "32" "33" "34" "35" "36" "37" "38" "39" "40"`
         nummer_jaar=`kdialog --miniicon "$iconCharts" --combobox "Choose year:" "1965" "1966" "1967" "1968" "1969" "1970" "1971" "1972" "1973" "1974" "1975" "1976" "1977" "1978" "1979" "1980" "1981" "1982" "1983" "1984" "1985" "1986" "1987" "1988" "1989" "1990" "1991" "1992" "1993" "1994" "1995" "1996" "1997" "1998" "1999" "2000" "2001" "2002" "2003"`
         url="overzicht.php?nummer=$nummer&nummer_jaar=$nummer_jaar"
      else
         exit
      fi

   elif [ "$consulttype" = "Release" ]; then
      listtype=`kdialog --miniicon "$iconCharts" --combobox "Show releases on a specific date or by year?" "Date" "Year"`
      if [ "$listtype" = "Date" ]; then
         dag=`kdialog --miniicon "$iconCharts" --combobox "Choose day:" "1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "11" "12" "13" "14" "15" "16" "17" "18" "19" "20" "21" "22" "23" "24" "25" "26" "27" "28" "29" "30" "31"`
         maand=`kdialog --miniicon "$iconCharts" --combobox "Choose month:" "1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "11" "12"`
         filter=`kdialog --miniicon "$iconCharts" --combobox "Sort results by: " "Artist" "Title" "Weeks" "Position" "Date"`
         if [ "$filter" = "Artist" ]; then
            filter="artiest"
         elif [ "$filter" = "Title" ]; then
            filter="titel"
         elif [ "$filter" = "Weeks" ]; then
            filter="weken"
         elif [ "$filter" = "Position" ]; then
            filter="positie"
         elif [ "$filter" = "Date" ]; then
            filter="datum"
         else
            filter="datum"
         fi
         url="overzicht.php?dag_maand=$maand&dag_dag=$dag&order=$filter&ad=DESC"
      elif [ "$listtype" = "Year" ]; then
         release_jaar=`kdialog --miniicon "$iconCharts" --combobox "Choose year:" "1965" "1966" "1967" "1968" "1969" "1970" "1971" "1972" "1973" "1974" "1975" "1976" "1977" "1978" "1979" "1980" "1981" "1982" "1983" "1984" "1985" "1986" "1987" "1988" "1989" "1990" "1991" "1992" "1993" "1994" "1995" "1996" "1997" "1998" "1999" "2000" "2001" "2002" "2003"`
                  filter=`kdialog --miniicon "$iconCharts" --combobox "Sort results by: " "Artist" "Title" "Weeks" "Position" "Date"`
         if [ "$filter" = "Artist" ]; then
            filter="artiest"
         elif [ "$filter" = "Title" ]; then
            filter="titel"
         elif [ "$filter" = "Weeks" ]; then
            filter="weken"
         elif [ "$filter" = "Position" ]; then
            filter="positie"
         elif [ "$filter" = "Date" ]; then
            filter="datum"
         else
            filter="datum"
         fi
         url="overzicht.php?release_jaar="$release_jaar"&l=0&order=$filter&ad=ASC"
      else
         exit
      fi

   else
      exit
   fi

else

exit

fi


url="http://www.walravens.info/$url"

curl $url | html2text -width 110 -nobs | sed s/'_'/' '/g | sed '/progress*/d' | sed '/.   .   l   o   a   d   i   n   g/d' | sed '/Een moment geduld a\.u\.b\./d' | sed '/Bezig met het verzamelen van de juiste hits/d' | sed '/DATUM/a\ ' | sed '/ARTIEST/i\ ' | sed 's/\/strong>/\t/g' | sed '0,1i\
\
Veronica`s Top40  @  http://www.walravens.info' > ${3}