# modified by wizzard <wizzard@ni-te.de>
# original "RoundBar" by Michele Albanese

#this import statement allows access to the karamba functions

import karamba
import glob
import string
import os
import os.path

#Path to your favorite iconset and to the standard icon path
iconTheme = "/home/wizzard/.kde/share/icons/crystal/"
iconPath = "/usr/share/icons/hicolor/"

#Path to link files
linkfilesPath = "/home/wizzard/Karamba/DynBar/Files/"

#Space on the left/right side (clock, pager...)
spaceL = 0 #150 if using examples from theme file
spaceR = 0

# Use "smooth" zoom?
smoothZoom = 1

#Times to "blink" when clicking icon
blink = 1

#XMMS controls
#-1 disabled / 0 enabled
xmmsBar = 0

bar = [ ]

names = [ ]
icons = [ ]
iconsBig = [ ]
iconsZoom52 = [ ]
iconsZoom56 = [ ]
iconsZoom60 = [ ]
commands = [ ]

iconCount = 0

iconZoomed = -1

dirState = 0

init = 0

#Autodetect the resolution, thanks to Adam Geitgey!
havexwi = os.system("which xwininfo")

if (havexwi == 0):
	pass
else:
	print "\nCan't find xwininfo in your path."

fp = os.popen("xwininfo -root -stats")
output = fp.read()
output = output.splitlines()
i = 0
for x in output:
	param = x.split()
	if (len(param) > 1):
		if param[0].find("Width:") != -1:
			print param[1]
			resX = int(param[1])
		if param[0].find("Height:") != -1:
			print param[1]
			resY = int(param[1])



def Initialize(widget):
	global iconTheme
	global iconPath
	global kickerPath
	global resX
	global resY
	global bar
	global names
	global icons
	global iconsBig
	global iconsZoom52
	global iconsZoom56
	global iconsZoom60
	global commands
	global iconCount
	global xmmsBar
	global dirState
	global init

	if init == 0:

		#hide images
		for i in range(iconCount):
			karamba.hideImage(widget, icons[i])
			karamba.hideImage(widget, iconsBig[i])
		names = [ ]
		icons = [ ]
		iconsBig = [ ]
		iconsZoom52 = [ ]
		iconsZoom56 = [ ]
		iconsZoom60 = [ ]
		commands = [ ]
		iconCount = 0
		iconZoomed = -1

		names.append("")
		commands.append("dcop kicker kicker popupKMenu 0")
		icons.append(iconTheme+"48x48/apps/kmenu.png")
		iconsBig.append(iconTheme+"64x64/apps/kmenu.png")
		iconCount +=1

		fileList = glob.glob(linkfilesPath+"*")
		fileList.sort() # Thanks to genneth
		for fileName in fileList:
			print "-----------------------------"
			print fileName
			if os.path.isfile(fileName) != 1:
				continue
			file = open(fileName, 'r')
			line = file.readline()
			if string.count(line, "[Desktop Entry]"):
				for line in file.readlines():
					names.append("")
					icons.append("")
					iconsBig.append("")
					commands.append("")
					if line[:4] == "Name":
						strPos = string.find(line, "=") + 1
						names[iconCount] = line[strPos:-1]
						print line[:strPos]+names[iconCount]
					if line[:4] == "Exec":
						strPos = string.find(line, "=") + 1
						commands[iconCount] = line[strPos:-1]
						print line[:strPos]+commands[iconCount]
					if line[:4] == "Icon":
						line = string.replace(line, ".png", '')
						strPos = string.find(line, '=') + 1
						if glob.glob(line[strPos:-1]+".png") != []:
							icons[iconCount] = line[strPos:-1]+".png"
							iconsBig[iconCount] = line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/apps/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/apps/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/apps/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/apps/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/apps/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/apps/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/devices/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/devices/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/devices/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/devices/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/devices/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/devices/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/actions/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/actions/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/actions/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/actions/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/actions/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/actions/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/filesystems/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/filesystems/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/mimetypes/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/mimetypes/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png"
						else:
							icons[iconCount] = iconPath+"48x48/apps/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconPath+"64x64/apps/"+line[strPos:-1]+".png"
						print line[:strPos]+icons[iconCount]
				iconCount += 1

		if bar == [ ]:
			bar.append(karamba.createImage(widget, 0, 0, "Pics/head-left.png"))
			bar.append(karamba.createImage(widget, 32, 0, "Pics/middle.png"))
			karamba.resizeImage(widget, bar[1], spaceL+(iconCount*64)+spaceR, 70)
			karamba.createClickArea(widget, 32+spaceL, 4, iconCount*64, 56, "")
			bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 0, "Pics/head-right.png"))
			if xmmsBar >= 0:
				bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 0, "Pics/xmms-handle.png"))
				bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR+12, 40, "Pics/xmms-controls.png"))
				bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR, 30, "Pics/xmms-bar.png"))
				bar.append(karamba.createImage(widget, 32+spaceL+(iconCount*64)+spaceR+88, 20, "Pics/volume-buttons.png"))
				karamba.hideImage(widget, bar[4])
				karamba.hideImage(widget, bar[5])
		else:
			karamba.createClickArea(widget, 32+spaceL, 8, iconCount*64, 64, "")
			karamba.resizeImage(widget, bar[1], spaceL+(iconCount*64)+spaceR, 70)
			karamba.moveImage(widget, bar[2], 32+spaceL+(iconCount*64)+spaceR, 0)
			if xmmsBar >= 0:
				karamba.moveImage(widget, bar[3], 32+spaceL+(iconCount*64)+spaceR, 0)
				karamba.moveImage(widget, bar[4], 32+spaceL+(iconCount*64)+spaceR+12, 40)
				karamba.moveImage(widget, bar[5], 32+spaceL+(iconCount*64)+spaceR, 30)
				karamba.moveImage(widget, bar[6], 32+spaceL+(iconCount*64)+spaceR+88, 20)
				karamba.showImage(widget, bar[3])
				karamba.hideImage(widget, bar[4])
				karamba.hideImage(widget, bar[5])

		for i in range(iconCount):
			iconsZoom52.append(iconsBig[i])
			iconsZoom56.append(iconsBig[i])
			iconsZoom60.append(iconsBig[i])

			icons[i] = karamba.createImage(widget, 32+spaceL+(i*64)+8, 8, icons[i])
			karamba.resizeImage(widget, icons[i], 48, 48)
			iconsBig[i] = karamba.createImage(widget, 32+spaceL+(i*64), 0, iconsBig[i])
			karamba.hideImage(widget, iconsBig[i])
			karamba.resizeImage(widget, iconsBig[i], 64, 64)

			iconsZoom52[i] = karamba.createImage(widget, 32+spaceL+(i*64)+6, 6, iconsZoom52[i])
			karamba.hideImage(widget, iconsZoom52[i])
			karamba.resizeImage(widget, iconsZoom52[i], 52, 52)

			iconsZoom56[i] = karamba.createImage(widget, 32+spaceL+(i*64)+4, 4, iconsZoom56[i])
			karamba.hideImage(widget, iconsZoom56[i])
			karamba.resizeImage(widget, iconsZoom56[i], 56, 56)

			iconsZoom60[i] = karamba.createImage(widget, 32+spaceL+(i*64)+2, 2, iconsZoom60[i])
			karamba.hideImage(widget, iconsZoom60[i])
			karamba.resizeImage(widget, iconsZoom60[i], 60, 60)

			karamba.addImageTooltip(widget, icons[i], names[i])

		karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32, 64)
		karamba.moveWidget(widget, (resX-32-spaceL-(iconCount*64)-spaceR-32)/2, resY-70)

		karamba.redrawWidget(widget)

		dirState = glob.glob(linkfilesPath+"*")

		init = 1

def initWidget(widget):
	pass

def widgetUpdated(widget):
	global linkfilesPath
	global dirState
	global iconsBig
	global smoothZoom
	global init
                 
	if dirState != glob.glob(linkfilesPath+"*"):
		init = 0
	Initialize(widget)
	pass

def widgetClicked(widget, x, y, button):
	global iconCount
	global spaceL
	global commands
	global blinks
	global icons
	global iconsBig
	global iconsZoom52
	global iconsZoom56
	global iconsZoom60
	global smoothZoom

	if button == 2:
		os.system("kstart konqueror "+linkfilesPath)
	elif button == 1 and 32+spaceL <= x <= 32+spaceL+(iconCount*64) and 8 <= y <= 56:
		icon = (x-32-spaceL) / 64
		if 0 <= icon < iconCount:
			os.system(commands[icon]+" &")
			print "Execute: "+commands[icon]
			for i in range(blink):
				karamba.hideImage(widget, iconsBig[icon])
				if smoothZoom:
					karamba.showImage(widget, iconsZoom60[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsBig[icon])
					karamba.showImage(widget, iconsZoom60[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom60[icon])
					karamba.showImage(widget, iconsZoom56[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom56[icon])
					karamba.showImage(widget, iconsZoom52[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom52[icon])
				karamba.showImage(widget, icons[icon])
				karamba.redrawWidget(widget)

				karamba.hideImage(widget, icons[icon])

				if smoothZoom:
					karamba.showImage(widget, iconsZoom52[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom52[icon])
					karamba.showImage(widget, iconsZoom56[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom56[icon])
					karamba.showImage(widget, iconsZoom60[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom60[icon])

				karamba.showImage(widget, iconsBig[icon])
				karamba.redrawWidget(widget)
	elif button == 1 and 32+spaceL+(iconCount*64)+spaceR+16 <= x <= 32+spaceL+(iconCount*64)+spaceR+16+52 and 40 <= y <= 48:
		if xmmsBar:
			control = (x-32-spaceL-(iconCount*64)-spaceR-16)/11
			if control == 0:
				os.system("xmms-shell -e 'window playlist show' || xmms-shell -e 'window playlist hide' &")
			if control == 1:
				os.system("xmms --rew &")
			if control == 2:
				os.system("xmms --stop &")
			if control == 3:
				os.system("xmms --play-pause &")
			if control == 4:
				os.system("xmms --fwd &")
	elif button == 1 and 32+spaceL+(iconCount*64)+spaceR+88 <= x <= 32+spaceL+(iconCount*64)+spaceR+88+24 and 20 <= y <= 44:
		if xmmsBar:
			control = (y-20)/12
			if control == 0:
				os.system("xmms-shell -e '+' &")
			if control == 1:
				os.system("xmms-shell -e '-' &")
	pass

def widgetMouseMoved(widget, x, y, button):
	global iconZoomed
	global Kicon
	global KiconBig
	global icons
	global iconsBig
	global iconsZoom52
	global iconsZoom56
	global iconsZoom60
	global smoothZoom
	global xmmsBar

	if 32+spaceL <= x <= 32+spaceL+(iconCount*64) and 8 <= y <= 56:
		icon = (x-32-spaceL) / 64
		if 0 <= icon < iconCount and icon != iconZoomed:
			if iconZoomed > -1:
				karamba.hideImage(widget, iconsBig[iconZoomed])
			karamba.hideImage(widget, icons[icon])
			if smoothZoom:
				if iconZoomed > -1:
					karamba.showImage(widget, iconsZoom60[iconZoomed])
				karamba.showImage(widget, iconsZoom52[icon])
				karamba.redrawWidget(widget)

				if iconZoomed > -1:
					karamba.hideImage(widget, iconsZoom60[iconZoomed])
					karamba.showImage(widget, iconsZoom56[iconZoomed])
				karamba.hideImage(widget, iconsZoom52[icon])
				karamba.showImage(widget, iconsZoom56[icon])
				karamba.redrawWidget(widget)

				if iconZoomed > -1:
					karamba.hideImage(widget, iconsZoom56[iconZoomed])
					karamba.showImage(widget, iconsZoom52[iconZoomed])
				karamba.hideImage(widget, iconsZoom56[icon])
				karamba.showImage(widget, iconsZoom60[icon])
				karamba.redrawWidget(widget)

				if iconZoomed > -1:
					karamba.hideImage(widget, iconsZoom52[iconZoomed])
				karamba.hideImage(widget, iconsZoom60[icon])

			if iconZoomed > -1:
				karamba.showImage(widget, icons[iconZoomed])
			karamba.showImage(widget, iconsBig[icon])
			karamba.redrawWidget(widget)

			iconZoomed = icon
	elif iconZoomed > -1:
		karamba.hideImage(widget, iconsBig[iconZoomed])
		if smoothZoom:
			karamba.showImage(widget, iconsZoom60[iconZoomed])
			karamba.redrawWidget(widget)

			karamba.hideImage(widget, iconsZoom60[iconZoomed])
			karamba.showImage(widget, iconsZoom56[iconZoomed])
			karamba.redrawWidget(widget)

			karamba.hideImage(widget, iconsZoom56[iconZoomed])
			karamba.showImage(widget, iconsZoom52[iconZoomed])
			karamba.redrawWidget(widget)

			karamba.hideImage(widget, iconsZoom52[iconZoomed])
		karamba.showImage(widget, icons[iconZoomed])
		karamba.redrawWidget(widget)
		iconZoomed = -1

	if 32+spaceL+(iconCount*64)+spaceR <= x < 32+spaceL+(iconCount*64)+spaceR+32+100 and 4 <= y <= 60:
		if xmmsBar == 0:
			karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32+100, 64)
			karamba.resizeImage(widget, bar[1], spaceL+(iconCount*64)+spaceR+100, 70)
			karamba.moveImage(widget, bar[2], 32+spaceL+(iconCount*64)+spaceR+100, 0)
			karamba.hideImage(widget, bar[3])
			karamba.showImage(widget, bar[4])
			karamba.showImage(widget, bar[5])
			karamba.redrawWidget(widget)
			xmmsBar = 1
	elif xmmsBar == 1:
		karamba.resizeImage(widget, bar[1], spaceL+(iconCount*64)+spaceR, 70)
		karamba.moveImage(widget, bar[2], 32+spaceL+(iconCount*64)+spaceR, 0)
		karamba.showImage(widget, bar[3])
		karamba.resizeWidget(widget, 32+spaceL+(iconCount*64)+spaceR+32, 64)
		karamba.hideImage(widget, bar[4])
		karamba.hideImage(widget, bar[5])
		karamba.redrawWidget(widget)
		xmmsBar = 0
	pass


# This will be printed when the widget loads.
print "Loaded my python extension!"
