import karamba
from os.path import exists
import os

# configuration variables

icondir = "/home/tomas/.kde/share/icons/crystal/"

perc = 0.80

prefTaskWidth = 120

fontColor = [ 0, 0, 0 ]

fontSize = 12

fontFamily = "Lucida Grande"


#########################################################

resolution = 1024

offIcon = None
dIcon = None
head = None
head_b = None
head_s = None
tail_b = None
tail = None
myTray = None

taskWidth = 0
lastMeterClicked = -1

taskList = []
task_i = []
task_t = []
task_b = []
task_s = []

menu = None
menuItems = []
menuNames = ["close"]
menuIcons = [icondir + "16x16/actions/fileclose.png"]
removing = 0
curr_desktop = None
SCDTO = 0

##########################################################
# Superkaramba API functions                             #
##########################################################
#this is called when you widget is initialized
def initWidget(widget):
	global offIcon
	global dIcon
	global middle
	global tail
	global tail_b
	global head
	global head_b
	global icondir
	global maxwidth
	global perc
	global menu
	global resolution
	global curr_desktop
	global SCDTO
	global removing

	removing = 0

	# We create the menuConfig options.
	karamba.addMenuConfigOption(widget, "SCDTO" , "Show Current Desktop Tasks Only")

	# we get the desktop we are in
	fp = os.popen ("dcop kwin KWinInterface currentDesktop")
	curr_desktop = int(fp.read())
	fp.close()

	# let's catch the configuration option.
	SCDTO = karamba.readMenuConfigOption (widget, "SCDTO")

	# we get the resolution mean the xwininfo tool.
	if (os.system ("which xwininfo") == 0):
		fd = os.popen ("xwininfo -root -stats | grep Width")
		line = fd.read()
		words = line.split()
		resolution = int(words[1])
		fd.close()
	else:
		print "xwininfo not found, using", resolution, "as the default width (change it if your resolution differ from showed)"

	#We calculate the size of the screen we re gonna use.
	maxwidth = (int) (resolution * perc)

	karamba.moveWidget (widget, 0, 0)
	karamba.resizeWidget (widget, maxwidth, 20)

	position = 0

	head = karamba.createImage (widget, position, 0, "images/left.png")

	position = position + 10

	head_b = karamba.createImage (widget, position, 0, "images/middle.png")

	karamba.resizeImage (widget, head_b, 20, 20)

	offIcon = karamba.createImage (widget, position, 2, icondir + "16x16/actions/exit.png")
	karamba.attachClickArea (widget, offIcon, "dcop kdesktop KDesktopIface logout", "", "")
	#karamba.addImageTooltip (widget, offIcon, "Log Out")

	position = position + 20

	head_s = karamba.createImage (widget, position, 0, "images/separator.png")

	position = position + 1

	# here we call to the method that initializes the aplicacions already launched
	position = getAllRunning ( widget, position )

	#We load the tail of the taskbar.
	tail_b = karamba.createImage (widget, position, 0, "images/middle.png")

	karamba.resizeImage (widget, tail_b, 20, 20)

	dIcon = karamba.createImage (widget, position + 3, 2, icondir + "16x16/filesystems/desktop.png")
	karamba.attachClickArea (widget, dIcon, "", "", "")
	#karamba.addImageTooltip (widget, dIcon, "Show Desktop")

	position = position + 20

	tail = karamba.createImage (widget, position, 0, "images/right.png")

	menu = karamba.createMenu (widget)

	for i in range(len (menuNames)):
		menuItems.append (karamba.addMenuItem (widget, menu, menuNames[i], menuIcons[i]))

	# We finally update the taskbar.
	updateTaskBar ( widget )


#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
	global taskList
	global task_t
	global task_b
	global task_s
	global task_i
	global removing
	global curr_desktop

	if (removing == 1):
		return 0

	desktop = -1

	if (SCDTO == 1):
		fp = os.popen ("dcop kwin KWinInterface currentDesktop")
		desktop = int(fp.read())
		fp.close()

	if (desktop != curr_desktop) and (SCDTO == 1):
		while len (task_b) > 0:
			karamba.deleteImage (widget, task_b[-1])
			karamba.deleteImage (widget, task_s[-1])
			karamba.deleteImage (widget, task_i[-1])
			karamba.deleteText (widget, task_t[-1])
			del task_i[-1]
			del task_b[-1]
			del task_t[-1]
			del task_s[-1]
			del taskList[-1]
		curr_desktop = desktop

		pos = getAllRunning (widget, 31)

		karamba.moveImage(widget, tail_b, taskWidth * len(taskList) + 31 , 0)
		karamba.moveImage(widget, tail  , taskWidth * len(taskList) + 31 + 20 , 0)
		karamba.moveImage(widget, dIcon , taskWidth * len(taskList) + 31 + 3 , 2)

		#karamba.addImageTooltip (widget, dIcon, "Show Desktop")
		updateTaskBar ( widget )
	else:
		i = 0

		for x in taskList:
			x1 = karamba.getTaskInfo (widget, x[8])

			if x[0] != x1[0]:
				x[0] = x1[0]
				karamba.changeText (widget, task_t[i], x[0])

			if x[3] != x1[3]:
				taskRemoved (widget, x[8])

			i = i + 1

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
	#Warning:  Don't do anything too intensive here
	#You don't want to run some complex piece of code everytime the mouse moves
	pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
	global lastMeterClicked
	global taskList

	if (id == menuItems[0]):
		if (lastMeterClicked != -1):
			karamba.performTaskAction (widget, taskList[lastMeterClicked][8], 4)
			lastMeterClicked = -1


#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
	global SCDTO
	global curr_desktop

	SCDTO = value

	if SCDTO == 1:
		fp = os.popen ("dcop kwin KWinInterface currentDesktop")
		curr_desktop = int(fp.read())
		fp.close()

	while len (task_b) > 0:
		karamba.deleteImage (widget, task_b[-1])
		karamba.deleteImage (widget, task_s[-1])
		karamba.deleteImage (widget, task_i[-1])
		karamba.deleteText (widget, task_t[-1])
		del task_i[-1]
		del task_b[-1]
		del task_t[-1]
		del task_s[-1]
		del taskList[-1]

	pos = getAllRunning (widget, 31)

	karamba.moveImage(widget, tail_b, taskWidth * len(taskList) + 31 , 0)
	karamba.moveImage(widget, tail  , taskWidth * len(taskList) + 31 + 20 , 0)
	karamba.moveImage(widget, dIcon , taskWidth * len(taskList) + 31 + 3 , 2)

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
	pass

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
	pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.
def startupAdded(widget, startup):
	pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.
def startupRemoved(widget, startup):
	pass

def newWidth ( numTasks ):
	global prefTaskWidth
	global maxwidth

	if ((numTasks * prefTaskWidth + 61) < maxwidth):
		return prefTaskWidth
	else:
		return (int) ((maxwidth - 62) / numTasks)

def resizeAllTasks ( widget ):
	global taskList
	global task_b
	global task_i
	global task_t
	global task_s

	i = 0

	for x in taskList:
		karamba.resizeImage (widget, task_b[i], taskWidth - 1, 20)
		karamba.deleteText (widget, task_t[i])

		posTemp = i*taskWidth

		task_t[i] = karamba.createText (widget, posTemp + 31 + 20, 3, taskWidth - 25, 16, x[0] )
		karamba.changeTextColor (widget, task_t[i], fontColor[0], fontColor[1], fontColor[2])
		karamba.changeTextSize  (widget, task_t[i], fontSize )
		karamba.changeTextFont  (widget, task_t[i], fontFamily )

		karamba.moveImage (widget, task_b [i], posTemp + 31, 0)
		karamba.moveImage (widget, task_i[i], posTemp + 31 + 2, 2)
		karamba.moveImage (widget, task_s[i], posTemp + 31 + taskWidth - 1, 0)
		i = i + 1

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
	global taskWidth
	global taskList
	global task_b
	global task_s
	global task_t
	global tail
	global tail_b
	global dIcon
	global fontColor
	global fontSize
	global fontFamily
	global icondir

	taskInfo = karamba.getTaskInfo (widget, task)

	if (SCDTO == 1 and taskInfo[3] != curr_desktop):
		return 0

	found = 0

	for x in taskList:
		if x[8] == task:
			found = 1

	if (found == 0):

		tempWidth = newWidth ( len (taskList) + 1)

		if (tempWidth != taskWidth):
			taskWidth = tempWidth
			resizeAllTasks ( widget )

		taskList.append ( taskInfo )

		pos = 31 + (len(taskList) - 1)*taskWidth

		task_b.append (karamba.createImage (widget, pos, 0, "images/middle.png"))
		karamba.resizeImage (widget, task_b[-1], taskWidth - 1, 20)
		karamba.attachClickArea (widget, task_b[-1], "", "", "")

		iconpath = icondir + "/16x16/apps/" + taskList[-1][2] + ".png"

		if (exists(iconpath)== 0):
			print taskList[-1][2]
			iconpath = icondir + "/16x16/actions/exec.png"

		task_i.append (karamba.createImage (widget, pos + 2, 2, iconpath))
		#karamba.addImageTooltip (widget, task_i[-1], taskList[-1][0])

		text = karamba.createText(widget, pos + 20, 3, taskWidth - 25, 16, taskList[-1][0])
		karamba.changeTextColor (widget, text, fontColor[0], fontColor[1], fontColor[2])
		karamba.changeTextSize  (widget, text, fontSize )
		karamba.changeTextFont  (widget, text, fontFamily )
		task_t.append (text)

		task_s.append (karamba.createImage (widget, pos + taskWidth - 1, 0, "images/separator.png"))

		pos = pos + taskWidth

		karamba.moveImage(widget, tail_b, taskWidth * len(taskList) + 31 , 0)
		karamba.moveImage(widget, tail  , taskWidth * len(taskList) + 31 + 20 , 0)
		karamba.moveImage(widget, dIcon , taskWidth * len(taskList) + 31 + 3 , 2)

		#karamba.addImageTooltip (widget, dIcon, "Show Desktop")

		karamba.redrawWidget(widget)

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.
def taskRemoved(widget, task):
	global taskWidth
	global taskList
	global task_b
	global task_s
	global task_t
	global tail
	global tail_b
	global dIcon

	found = 0
	i = 0
	index = 0

	for x in taskList:
		if x[8] == task:
			found = 1
			index = i
		i = i + 1

	if found:

		del taskList[index]

		karamba.deleteImage ( widget, task_b[index] )
		del task_b[index]
		karamba.deleteImage ( widget, task_s[index] )
		del task_s[index]
		karamba.deleteText ( widget, task_t[index] )
		del task_t[index]
		karamba.deleteImage (widget, task_i[index] )
		del task_i[index]

		tempWidth = newWidth ( len (taskList) )

		if (tempWidth != taskWidth):
			taskWidth = tempWidth
			resizeAllTasks ( widget )

		while index < len(taskList):
			karamba.moveImage(widget, task_b[index], taskWidth * index + 31 , 0)
			karamba.moveImage(widget, task_s[index], taskWidth * index + 31 + taskWidth - 1 , 0)
			karamba.moveText (widget, task_t[index], taskWidth * index + 31 + 20 , 3)
			karamba.moveText (widget, task_i[index], taskWidth * index + 31 + 2 , 2)
			index = index + 1

		karamba.moveImage(widget, tail_b, taskWidth * len(taskList) + 31 , 0)
		karamba.moveImage(widget, tail  , taskWidth * len(taskList) + 31 + 20 , 0)
		karamba.moveImage(widget, dIcon , taskWidth * len(taskList) + 31 + 3 , 2)

		#karamba.addImageTooltip (widget, dIcon, "Show Desktop")

		karamba.redrawWidget(widget)

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
	global taskList

	i = 0

	for x in taskList:
		if x[8] == task:
			taskList[i] = karamba.getTaskInfo( widget, task )
		else:
			taskList[i][7] = 0

		i = i + 1

	updateTaskBar ( widget )

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked (widget, meter, button):
	global task_b
	global dIcon
	global offIcon
	global taskList
	global menu
	global lastMeterClicked

	if meter == dIcon :
		karamba.toggleShowDesktop (widget)
	elif meter != offIcon:
		if (button == 2):
			i = 0
			for x in task_b:
				if x == meter:
					lastMeterClicked = i
					karamba.popupMenu( widget, menu, 16 + i*taskWidth, 20 )
					return 0
				i = i + 1
		else:
			i = 0

			for x in task_b:
				if x != meter:
					taskList[i][7] = 0
				i = i + 1

			i = 0

			for x in task_b:
				if x == meter:
					taskList[i][7] = 1
					karamba.performTaskAction(widget, taskList[i][8], 8)
				i = i + 1
def getTaskListMine ( widget ):
	aList = []

	taskRefs = karamba.getTaskList (widget)

	for ref in taskRefs:
		taskInfo = karamba.getTaskInfo(widget, ref)

		if (taskInfo[3] == curr_desktop) or (SCDTO == 0):
			aList.append (taskInfo)

	return aList

def getAllRunning ( widget, pos ):
	global taskWidth
	global taskList
	global task_i
	global task_t
	global task_b
	global task_s
	global icondir
	global curr_desktop
	global SCDTO

	taskList = getTaskListMine (widget)

	taskWidth = newWidth( len (taskList) )

	for task in taskList:
		task_b.append (karamba.createImage (widget, pos, 0, "images/middle.png"))
		karamba.resizeImage (widget, task_b[-1], taskWidth - 1, 20)
		karamba.attachClickArea (widget, task_b[-1], "", "", "")

		iconpath = icondir + "/16x16/apps/" + task[2] + ".png"

		if (exists(iconpath)== 0):
			iconpath = icondir + "/16x16/actions/exec.png"

		task_i.append (karamba.createImage (widget, pos + 2, 2, iconpath))
		#karamba.addImageTooltip (widget, task_i[-1], taskList[-1][0])

		text = karamba.createText(widget, pos + 20, 3, taskWidth - 25, 16, task[0])
		karamba.changeTextColor (widget, text, fontColor[0], fontColor[1], fontColor[2])
		karamba.changeTextSize  (widget, text, fontSize )
		karamba.changeTextFont  (widget, text, fontFamily )
		task_t.append (text)

		task_s.append (karamba.createImage (widget, pos + taskWidth - 1, 0, "images/separator.png"))
		pos = pos + taskWidth

	return pos


def updateTaskBar ( widget ):
	global task_b
	global taskList

	i = 0

	for x in task_b:
		if taskList[i][7] == 1:
			karamba.changeImageIntensity(widget, x, -1, 0)
		else:
			karamba.changeImageIntensity(widget, x, 1, 0)
		i = i + 1

	karamba.redrawWidget(widget)

def widgetClosed ( widget ):
	global task_b
	global task_i
	global task_t
	global task_s
	global offIcon
	global dIcon
	global tail_b
	global tail
	global head_b
	global head
	global head_s
	global menu
	global menuItems
	global removing

	removing = 1

	i = 0

	while i < len (task_b):
		print karamba.deleteImage (widget, task_b[i])
		print karamba.deleteImage (widget, task_s[i])
		print karamba.deleteImage (widget, task_i[i])
		print karamba.deleteText (widget, task_t[i])
		i = i + 1

	i = 0

	while i < len (menuItems):
		print karamba.removeMenuItem (widget, menu, menuItems[i])
		i = i + 1

	print karamba.deleteMenu (widget, menu)

	print karamba.deleteImage (widget, offIcon)
	print karamba.deleteImage (widget, dIcon)
	print karamba.deleteImage (widget, tail)
	print karamba.deleteImage (widget, tail_b)
	print karamba.deleteImage (widget, head)
	print karamba.deleteImage (widget, head_b)
	print karamba.deleteImage (widget, head_s)

