# Glas-mldonkey theme, part of the SuperKaramba Glas-Bar Theme v0.2 by GeniusR13
#
# background, titlebar and global refresh timing are setup in the .theme file, all the rest
# should be modified here

import karamba                           # import needed modules
import socket
import re

Host = "127.0.0.1"                       # host where your mldonkey runs
Port = "4000"                            # mldonkeys telnet port
Pass = "test"                            # telnet password (currently not used)

idle_color = [0,0,0]                     # r/g/b text color for idle downloads
down_color = [0,64,0]                    # r/g/b text color for active downloads (default dark green)

text_x = 3                               # x/y coordinates where the text starts
text_y = 27




Sock = None

file_list = []
rate_list = []
down_list = []
full_list = []
bar_list = []
bartext_list = []
maxlines = 13

def initWidget(widget):
   global Host
   global Port
   global Pass
   global Sock
   global text_x
   global text_y
   global file_list
   global rate_list
   global bar_list
   global maxlines
   global idle_color
   global down_color

   # connect to mldonkey
   for res in socket.getaddrinfo(Host, Port, socket.AF_UNSPEC, socket.SOCK_STREAM):
      print "connecting"
      af, socktype, proto, canonname, sa = res
      try:
         s = socket.socket(af, socktype, proto)
      except socket.error, msg:
         s = None
         continue
      try:
         s.connect(sa)
      except socket.error, msg:
         s.close()
         s = None
         continue

      break

   if s is None:
      print 'could not open socket'
      sys.exit(1)

   print "connected"

   Sock = s

   Sock.send('\n')
   for x in range(10):
      data = Sock.recv(1024)
      if( len(data) < 1024 ):
         break

   # build display
   title = karamba.createText(widget,50,5,400,25,"MLdonkey Downloads")
   karamba.changeTextColor(widget,title,196,196,196)

   ypos = text_y
   for x in range(maxlines):
      this_thing = karamba.createText(widget, text_x, ypos, 200, 12,"")
      karamba.changeTextColor(widget,this_thing,0,0,0)
      karamba.changeTextSize(widget,this_thing,7)
      karamba.changeTextFont(widget,this_thing,"arial")
      file_list.append(this_thing)

      this_thing = karamba.createText(widget, 200, ypos, 25, 12, "")
      karamba.changeTextColor(widget,this_thing,0,0,0)
      karamba.changeTextSize(widget,this_thing,7)
      karamba.changeTextFont(widget,this_thing,"arial")
      rate_list.append(this_thing)

      this_thing = karamba.createText(widget, 225, ypos, 30, 12, "")
      karamba.changeTextColor(widget,this_thing,0,0,0)
      karamba.changeTextSize(widget,this_thing,7)
      karamba.changeTextFont(widget,this_thing,"arial")
      down_list.append(this_thing)

      this_thing = karamba.createText(widget, 255, ypos, 30, 12, "")
      karamba.changeTextColor(widget,this_thing,0,0,0)
      karamba.changeTextSize(widget,this_thing,7)
      karamba.changeTextFont(widget,this_thing,"arial")
      full_list.append(this_thing)

      this_thing = karamba.createImage(widget, 330, ypos, "Glas/donkey-bar2.png")
      karamba.hideImage(widget,this_thing)
      bar_list.append(this_thing)

      this_thing = karamba.createText(widget, 367, ypos, 25, 12, "")
      karamba.changeTextColor(widget,this_thing,0,0,0)
      karamba.changeTextSize(widget,this_thing,7)
      karamba.changeTextFont(widget,this_thing,"arial")
      bartext_list.append(this_thing)

      ypos = ypos + 12

   pass



def widgetUpdated(widget):
   global Sock
   global text_x
   global text_y
   global maxlines


   Sock.send('vd\n')
   data = Sock.recv(5120)
   data = data.splitlines()

   x = 0
   for i in range(maxlines):
      if( i >= len(data) ):
         karamba.changeText(widget, file_list[i], "")
         karamba.changeText(widget, rate_list[i], "")
         karamba.changeText(widget, down_list[i], "")
         karamba.changeText(widget, full_list[i], "")
         karamba.changeText(widget, bartext_list[i], "")
         karamba.hideImage(widget, bar_list[i])
         continue

      line = data[i]
      linecolor = idle_color

      if( line.find("[Donkey") != -1 ):
         fields = re.split(r" {2,100}", line)
         if( fields[7] != "-" ):
            linecolor = down_color

         karamba.changeTextColor(widget, file_list[x], linecolor[0], linecolor[1], linecolor[2])
         karamba.changeTextColor(widget, rate_list[x], linecolor[0], linecolor[1], linecolor[2])
         karamba.changeTextColor(widget, down_list[x], linecolor[0], linecolor[1], linecolor[2])
         karamba.changeTextColor(widget, full_list[x], linecolor[0], linecolor[1], linecolor[2])

         karamba.changeText(widget, file_list[x], fields[2])
         karamba.changeText(widget, rate_list[x], fields[7])
         karamba.changeText(widget, down_list[x], str(int(fields[4])/1048576) + " MB")
         karamba.changeText(widget, full_list[x], str(int(fields[5])/1048576) + " MB")
         karamba.changeText(widget, bartext_list[x], str(fields[3]) + " %")

         width = int(float(fields[3]))      # weired ? YES, but otherwise u get conversion errors :-(

         if( karamba.getImageWidth(widget, bar_list[x]) != width ):    # resize bar only if necessary
            karamba.resizeImage(widget, bar_list[x], width, 10)

         karamba.showImage(widget, bar_list[x])
         x = x + 1
         
   pass



def widgetClicked(widget, x, y, button):
   pass



def widgetMouseMoved(widget, x, y, button):
   pass


# This will be printed when the widget loads.
print "Loaded my python extension!"

