# Script by Ivica Ico Bukvic (SlipStreamScapes)
# http://meowing.ccm.uc.edu/~ico/
# Distributed under the GPL license
# Version 0.1 (June 2004)
# Based on Dynsysbar by Tomas Galvez (THoMaSiN)
# (l) 2004

import karamba
import time
import os

# width of the desktop, width of the opened menu, and padding of the retracted menu
desktop = 1280
width = 144
padding = 36

######################################

height = 32
vector = 0
retracted = 0
current = 0

fx = []
desk = []
name = []

this = "desks"

def writeConfigEntryNow(widget, string, replace):
	filename = os.path.expanduser("~") + "/.superkaramba/" + this + ".rc"
	file = open( filename, "r")
	output = file.read()
	file.close()
	output = output.splitlines()
	
	i = 0
	desktop = ""
	for i in output:
		param = i.split()
		if param and param[0].find(string) != -1:
			desktop = desktop + string + "=" + replace + "\n"
		else:
			desktop = desktop + i +"\n"
	
	file = open( filename, "w")
	file.write(desktop)
	file.close

def prettyText(widget, size, font, r, g, b, textname):
    karamba.changeTextSize(widget, textname, size)
    karamba.changeTextFont(widget, textname, font)
    karamba.changeTextColor(widget, textname, r, g, b)

def highlightIcon(widget, num):
	global desk
	global fx
	global current
	
	if ( current != num ):
		karamba.changeImageIntensity(widget, desk[num], 0.1, 0)
		fx[num] = 1
		karamba.redrawWidget(widget)

def restoreIcon(widget, num):
	global desk
	global fx
	global current
	
	if ( current != num ):
		karamba.removeImageEffects(widget, desk[num])
		fx[num] = 0
		karamba.redrawWidget(widget)
	
def gotoDesktop(widget, num):
	global current
	
	if ( current != num ):
		karamba.changeTextColor (widget, name[1], 0, 0, 0)
		karamba.changeTextColor (widget, name[2], 0, 0, 0)
		karamba.changeTextColor (widget, name[3], 0, 0, 0)
		karamba.changeTextColor (widget, name[4], 0, 0, 0)
		karamba.changeTextColor (widget, name[num], 255, 255, 255)
		current = num

###############################################################################
## Function:    
##   detectResolution ( )
## 
## 
## Description: 
##   Runs xwininfo and sets the current XFree86 resolution to the golbal
##   variables resolutionX and resolutionY
## 
##  Thanks to Adam Geitgey for this code!
###############################################################################
def detectResolution():
	global desktop
	
	havexwininfo = os.system("which xwininfo >/dev/null")
	if (havexwininfo == 0):
		pass
	
	fp = os.popen("xwininfo -root -stats")
	output = fp.read()
	output = output.splitlines()
	
	i = 0
	for i in output:
		param = i.split()
		if (len(param) > 1):
			if param[0].find("Width:") != -1:
				desktop = int(param[1])

def detectCurrentDesktop():
	
	fp = os.popen("dcop kwin KWinInterface currentDesktop")
	output = fp.read()
	output = output.splitlines()

	i = 0
	for i in output:
		param = i.split()
		num = int(param[0])

	print num
	return num

##########################################################
# Superkaramba API functions                             #
##########################################################
#this is called when you widget is initialized
def initWidget(widget):
	global desk
	global name
	global retracted
	global current

	detectResolution()

	if karamba.readConfigEntry (widget, "retracted") == None:
		retracted = 0
		karamba.writeConfigEntry (widget, "retracted", str(retracted))
	else:
		retracted = karamba.readConfigEntry (widget, "retracted")
	
	#desk0 = karamba.createImage(widget, 5, 0, "img/desktop_22x22_bw.png")
	#name0 = karamba.createText(widget,19, 11, 10, 10, "?")
	#prettyText(widget, 8, "nimbus sans l", 255, 255, 255, name0)
	desk.append(0)
	name.append(0)

	desk.append(karamba.createImage(widget, 36, 5, "img/desktop_22x22.png"))
	name.append(karamba.createText(widget,45, 11, 10, 10, "1"))
	prettyText(widget, 8, "nimbus sans l", 0, 0, 0, name[1])

	desk.append(karamba.createImage(widget, 60, 5, "img/desktop_22x22.png"))
	name.append(karamba.createText(widget,69, 11, 10, 10, "2"))
	prettyText(widget, 8, "nimbus sans l", 0, 0, 0, name[2])

	desk.append(karamba.createImage(widget, 84, 5, "img/desktop_22x22.png"))
	name.append(karamba.createText(widget,93, 11, 10, 10, "3"))
	prettyText(widget, 8, "nimbus sans l", 0, 0, 0, name[3])

	desk.append(karamba.createImage(widget, 108, 5, "img/desktop_22x22.png"))
	name.append(karamba.createText(widget,117, 11, 10, 10, "4"))
	prettyText(widget, 8, "nimbus sans l", 0, 0, 0, name[4])
	
	for i in range( 0, 5 ):
		fx.append( 0 )

	tmp = detectCurrentDesktop()
	highlightIcon(widget, tmp)
	gotoDesktop(widget, tmp)

	(x, y) = karamba.getWidgetPosition(widget)
	y = karamba.readConfigEntry (widget, "widgetPosY")
	if ( retracted == 1 ):
		karamba.hideSystray(widget)
		if ( desktop - x != padding ):
			karamba.moveWidget(widget, desktop - padding, y)
	elif ( desktop - x != width ):
		karamba.moveWidget(widget, desktop - width, y)

def widgetUpdated(widget):
	global retracted

	if ( retracted != 1 ):
		pass

#def activeTaskChanged(widget, task):
#	tmp = detectCurrentDesktop()
#	highlightIcon(widget, tmp)
#	gotoDesktop(widget, tmp)
#	widgetMouseMoved(widget,0, 0, 0)

def widgetMouseMoved(widget, x, y, button):
	global desk
	global fx
			
	#if (x >= 10) and (x < 31) and (y >= 8) and (y < 25):
	#	highlightIcon(widget, desk0, 0)
	#elif ( fx[0] == 1 ):
	#	restoreIcon(widget, desk0, 0)
	
	if (x >= 37) and (x < 57) and (y >= 8) and (y < 25):
		highlightIcon(widget, 1)
	elif ( fx[1] == 1 ):
		restoreIcon(widget, 1)

	if (x >= 61) and (x < 81) and (y >= 8) and (y < 25):
		highlightIcon(widget, 2)
	elif ( fx[2] == 1 ):
		restoreIcon(widget, 2)

	if (x >= 85) and (x < 105) and (y >= 8) and (y < 25):
		highlightIcon(widget, 3)
	elif ( fx[3] == 1 ):
		restoreIcon(widget, 3)

	if (x >= 109) and (x < 129) and (y >= 8) and (y < 25):
		highlightIcon(widget, 4)
	elif ( fx[4] == 1 ):
		restoreIcon(widget, 4)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	global desktop
	global padding
	global height
	global width
	global retracted
	
	if (button == 1):
		if (x >= 37) and (x < 57) and (y >= 8) and (y < 25):
			gotoDesktop(widget, 1)
		elif (x >= 61) and (x < 81) and (y >= 8) and (y < 25):
			gotoDesktop(widget, 2)
		elif (x >= 85) and (x < 105) and (y >= 8) and (y < 25):
			gotoDesktop(widget, 3)
		elif (x >= 109) and (x < 129) and (y >= 8) and (y < 25):
			gotoDesktop(widget, 4)
		else:
			(x, y) = karamba.getWidgetPosition(widget)
			if (x >= desktop - padding ):
				karamba.resizeWidget( widget, width, height )
				time.sleep(0.1)
				for i in range( width - padding ):
					x = x - 1
					karamba.moveWidget (widget, x, y)
				retracted = 0
			else:
				for i in range( width - padding ):
					x = x + 1
					karamba.moveWidget (widget, x, y)
				time.sleep(0.1)
				retracted = 1
				karamba.resizeWidget( widget, padding, height )
			writeConfigEntryNow(widget, "widgetWidth", str(width))
			writeConfigEntryNow(widget, "widgetPosX", str(x))
			writeConfigEntryNow(widget, "widgetPosY", str(y))
			writeConfigEntryNow(widget, "retracted", str(retracted))
			karamba.redrawWidget(widget)
			karamba.redrawWidgetBackground(widget)
