#based on eye.on theme script, modified and comment by Aristo...
#this import statement allows access to the karamba functions
import karamba
import os

init = 0
entire_playlist = []
display_lines = []
first_displayed_line = 0
last_song = 0

refresh_counter = 0

def getpos():
	fp = os.popen("xmmsctrl getpos")
	output = fp.read()
	output = output.splitlines()
	if (len(output) > 0):
		return int(output[0])-1
	else:
		return 0
def setpos(songnum):
	os.system("xmmsctrl track " + str(songnum+1))
	
def redispPlaylist(widget):
	global entire_playlist
	global first_displayed_line
	global display_lines
	global refresh_counter

	refresh_counter = refresh_counter + 1

	if refresh_counter >= 5:
		print "doing heavy refresh"
		refresh_counter = 0
		entire_playlist = []
		fp = os.popen("xmmsctrl playlist")
		output = fp.read()
		output = output.splitlines()
		i = 0
		for x in output:
			i=i+1
			playlist = x.split()
			songtitle = playlist[1:]
			texttitle = ""
			for word in songtitle:
				texttitle = texttitle + " " + word
			entire_playlist.append(texttitle)

    	#range value, is the number of songs in playlist...
	for i in range(5):
		text = display_lines[i]
		karamba.changeText(widget, text, "")

	for i in range(first_displayed_line, len(entire_playlist)):
		if i < (first_displayed_line + 5):
			text = display_lines[i-first_displayed_line]
			texttitle = entire_playlist[i]
		if len(texttitle) > 35:
			texttitle = texttitle[0:32] + "..."
		karamba.changeText(widget, text, texttitle)
		karamba.changeTextFont(widget, text, 'Fixed')
		karamba.changeTextColor(widget, text, 0, 0, 0)
		karamba.changeTextSize(widget, text, 10)

	pos = getpos()
	if (first_displayed_line <= pos < (5 + first_displayed_line)):
		karamba.changeTextColor(widget, display_lines[pos-first_displayed_line], 5, 25, 75)
		karamba.changeTextSize(widget, display_lines[pos-first_displayed_line], 10)
		
#this is called when you widget is initialized
def initWidget(widget):
	global m
	m = 0
	
#icons... path="pics/"
	global aPod, grid, up, down, play, pause, stop, reverse, forward

	aPod = karamba.createBackgroundImage(widget, 1, 1, "pics/iPod.png")
	grid = karamba.createImage(widget, 60, 3, "pics/grid.png")
	
	up = karamba.createImage(widget, 25, 80, "pics/up.png")
	down = karamba.createImage(widget, 25, 105, "pics/down.png")
	
	reverse = karamba.createImage(widget, 115, 51, "pics/Reverse.png")
	play = karamba.createImage(widget, 140, 50, "pics/Play.png")
	pause = karamba.createImage(widget, 165, 50, "pics/Pause.png")
	stop = karamba.createImage(widget, 190, 50, "pics/stop.png")
	forward = karamba.createImage(widget, 215, 51, "pics/Forward.png")
	
# actual title slide display
	global actualtitle #label
	
	#label = karamba.createText(widget, 80, 5, 180, 15,'--aPod XMMS control--')
	#karamba.changeTextFont(widget, label, 'neuropol')
	#karamba.changeTextSize(widget, label, 12)
	#karamba.changeTextColor(widget, label, 0, 0, 0)
	
	actualtitle = karamba.createText(widget, 70, 10, 195, 26, "")
	karamba.changeTextFont(widget, actualtitle, 'Fixed')
	karamba.changeTextSize(widget, actualtitle, 14)
	karamba.changeTextColor(widget, actualtitle, 5, 25, 75)
	
#playback bar
	global timebar, hidden
	hidden = 0
	
	timebar = karamba.createImage(widget, 60, 43, "pics/barmeter.png")
	
#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
	global init
	global first_displayed_song
	global last_song
	global entire_playlist

	if init == 0:

		init = 1

		havexctrl = os.system("which xmmsctrl")

		if (havexctrl == 0):
			print "\nFound xmmsctrl, so this theme should work."
		else:
			os.system("kdialog --error \"xmmsctrl could not be found!  Please install it to use this theme.\" --title \"aPod Error...!\"")
			print "\nCan't find xmmsctrl in your path.  Please install it to make this work.  "

		fp = os.popen("xmmsctrl playlist")
		output = fp.read()
		output = output.splitlines()
		i = 0
		for x in output:
			i=i+1
			playlist = x.split()
			songtitle = playlist[1:]
			texttitle = ""
			for word in songtitle:
				texttitle = texttitle + " " + word
			entire_playlist.append(texttitle)

		for i in range(len(entire_playlist)):
			if i < 5:  #number of songs in playlist...
				texttitle = entire_playlist[i]
				if len(texttitle) > 35:
					texttitle = texttitle[0:32] + "..."
							#(widget, x , (i*d )+D,  w, h, value)
							#where d --> distance between song's title in playlist..
							#      D --> distance from the top of our widget...
				text = karamba.createText(widget, 60, (i*10)+80, 0, 0, texttitle)
				display_lines.append(text)
				karamba.changeTextColor(widget, text, 0, 0, 0)
				karamba.changeTextFont(widget, text, 'fixed')
				karamba.changeTextSize(widget, text, 10)
		if len(display_lines) < 5: #number of songs in playlist...
			print "padding display_lines"
			lower = len(display_lines)
			for x in range(lower, 34):
				text = karamba.createText(widget, 60, (x*10)+80, 0, 0, (""))
				display_lines.append(text)

		pos = getpos()
		if (0 < pos < 5): #number of songs in playlist...
			karamba.changeTextColor(widget, display_lines[pos], 5, 25, 75)
			karamba.changeTextSize(widget, display_lines[pos], 9)
#		karamba.redrawWidget(widget)

	redispPlaylist(widget)
	
	#shows playback and length...	
	global playback,length
	
	playback = karamba.getThemeText(widget, "playback")
	print "playback"
	karamba.changeTextFont(widget, playback, 'Neuropol')
	karamba.changeTextSize(widget, playback, 11)
	karamba.changeTextColor(widget, playback, 0, 0, 0)
	
	length = karamba.getThemeText(widget, "length")
	print "length"
	karamba.changeTextFont(widget, length, 'Neuropol')
	karamba.changeTextSize(widget, length, 11)
	karamba.changeTextColor(widget, length, 0, 0, 0)
	

# slide actual title
	global actual
	global actualtitle
	global m

	if ( len(entire_playlist) > 0 ):
		pos = getpos()
		actual = ""
		actual = entire_playlist[pos]
		if ( m == len(actual) ):
			m = 0
		if ( m < len(actual) ):
			actual = actual[( 0 + m ):len(actual)] + "  " + actual + "  " + actual
			m = m + 1
	if ( len(entire_playlist) == 0 ):
		actual = ""
	karamba.changeText(widget, actualtitle, actual)
	
#playback bar... 
#this will increase your processor load...
	global time, timebar, hidden
	
	if init == 1:
		fv = os.popen("xmmsctrl print %p | sed -e 's/\.*%//'")
		time = fv.read()
		print time
		
		if ( time == ""):
			karamba.hideImage(widget, timebar)
			hidden = 1
		else:
			if ( hidden == 1 ):
				karamba.showImage(widget, timebar)
				hidden = 0
			karamba.resizeImage(widget, timebar, ((220 * int(time))/100),4)
			
			
##This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
# This will be printed when the widget loads.
def widgetClicked(widget, x, y, button):

	global last_song
	global first_displayed_line

	selected_song = first_displayed_line + (y-75)/13

	if (x > 60) and (x <= 285) and (first_displayed_line <= selected_song < 5 + first_displayed_line) and (button == 1): 
		last_song = getpos()
		setpos(selected_song)
		redispPlaylist(widget)
		
	if (y > 73) and (y < 127 ) and (button == 4):
		first_displayed_line = first_displayed_line -2
		if first_displayed_line < 0:
			first_displayed_line = 0
		redispPlaylist(widget)

	if (y > 73) and (y < 127 ) and (button == 5):
		first_displayed_line = first_displayed_line + 2
		if first_displayed_line > len(entire_playlist):
			first_displayed_line = len(entire_playlist)-1
		redispPlaylist(widget)

	if (x >= 25) and (x < 47) and (y >= 80) and (y < 102) and (button == 1):
		first_displayed_line = first_displayed_line - 4
		if first_displayed_line < 0:
			first_displayed_line = 0
		redispPlaylist(widget)

	if (x >= 25) and (x < 47) and (y >= 105) and (y < 127) and (button == 1):
		first_displayed_line = first_displayed_line + 4
		if first_displayed_line < 0:
			first_displayed_line = 0
		redispPlaylist(widget)
		
	if (x >= 115) and (x < 133) and (y >= 51) and (y < 70) and (button == 1):
			os.system('xmmsctrl previous')
			
	if (x >= 140) and (x < 151) and (y >= 50) and (y < 72) and (button == 1):
			os.system('xmmsctrl play')
			
	if (x >= 165) and (x < 177) and (y >= 50) and (y < 72) and (button == 1):
			os.system('xmmsctrl pause')
			
	if (x >= 190) and (x < 212) and (y >= 50) and (y < 72) and (button == 1):
			os.system('xmmsctrl stop')
			
	if (x >= 215) and (x < 237) and (y >= 51) and (y < 70) and (button == 1):
			os.system('xmmsctrl next')

print "aPod theme loaded...!"