# ***********************************
# * MonBar Superkaramba Theme
# * (C) Sean Brown
# * email: seanbrownstuff@hotmail.com
# * License: BSD - please see the included LICENCE file
# *
# * Version: 0.2
# ************************************

import karamba, poplib, time

#Set these as strings, enclose them in '' ie- mailuser='username'
mailuser='mailuser'
mailpasswd='mailpassword'
mailserver='mailserver'
deskno = 6

#You shouldn't need to change these
nomailicon='imgs/no_mail.png'
mailicon='imgs/mail.png'
mailimg=None

try:
 import dcop, dcopext, pager
 dflag = 1
except ImportError:
 dflag = 0

#Where to start drawing the Pager, the default value(5) starts drawing it
#5 pixels from the eddge of the screen
start = 10

def checkMail(mailserver, mailuser, mailpasswd):
 messages = poplib.POP3(mailserver)
 try:
  messages.user(mailuser)
  messages.pass_(mailpasswd)
  n = messages.stat()
  num = n[0]
 except (poplib.error_proto):
  num = 0
 
 messages.quit()
 if (num > 0):
  return num,255,0,0
 else:
  return num,255,255,255
  

def initWidget(widget):
 global mailCount, mailimg, desks

 mailCount = karamba.createText(widget, 1132, 15, 20, 25, "0")
 karamba.changeTextSize(widget, mailCount, 10)
 karamba.changeTextColor(widget, mailCount, 255,255,255)
 karamba.changeTextFont(widget, mailCount, "venus rising")

 mail = checkMail(mailserver, mailuser, mailpasswd)
 
 if(int(mail[0]) > 0):
  karamba.changeText(widget, mailCount, str(mail[0]))
  karamba.changeTextColor(widget, mailCount, int(mail[1]), int(mail[2]), int(mail[3]))
  mailimg = karamba.createImage(widget, 1100, 6, mailicon)
 else:
  mailimg = karamba.createImage(widget, 1100, 6, nomailicon)
  
 if(dflag):
  desks = pager.myPager(widget, deskno, start)
 


def widgetUpdated(widget):
 global mailimg
 
 t = time.localtime()
 if ( (int(t[4]) % 10) == 0):
  if (29 < int(t[5]) < 32):
   mail = checkMail(mailserver, mailuser, mailpasswd)
   if(int(mail[0]) > 0):
    karamba.deleteImage(widget, mailimg)
    mailimg = karamba.createImage(widget, 1100, 6, mailicon)
    karamba.changeText(widget, mailCount, str(mail[0]))
    karamba.changeTextColor(widget, mailCount, int(mail[1]), int(mail[2]), int(mail[3]))
   else:
    karamba.deleteImage(widget, mailimg)
    mailimg = karamba.createImage(widget, 1100, 6, nomailicon)
    karamba.changeText(widget, mailCount, str(mail[0]))
    karamba.changeTextColor(widget, mailCount, int(mail[1]), int(mail[2]), int(mail[3]))
 karamba.redrawWidget(widget)


def meterClicked(widget, meter, button):
 if(button == 1):
  for i in range(0, deskno):
   if (meter == desks[i]):
    pager.changeDesktop(int(i+1))
