# ***********************************
# *	Python Pager
# *	(C) Sean Brown
# *	email: seanbrownstuff@hotmail.com
# *	License: BSD - please see the included LICENCE file
# *
# *	Version: 0.1
# ************************************

import karamba, dcop, dcopext

def getWallpapers():	
	backgrounds = []
	dc = dcop.DCOPClient()
	dc.attach()
	dc.registerAs('monbar')
	d = dcopext.DCOPApp ("kdesktop", dc)
	for x in range(1,7):
		a,b = d.KBackgroundIface.currentWallpaper(x)
		backgrounds.append(str(b))
	return backgrounds

def changeDesktop(start=5, x=10, button=1):
	out = 1
	dc = dcop.DCOPClient()
	dc.attach()
	dc.registerAs('monbar')
	d = dcopext.DCOPApp ("kwin", dc)
	
	if(x < start):
		out = 0
	elif(start < (start+x) < (start+55)):
		desk = 1
	elif((start+55) < (start+x) < (start+55+60)):
		desk = 2
	elif((start+55+60) < (start+x) < (start+55+120)):
		desk = 3
	elif((start+55+120) < (start+x) < (start+55+180)):
		desk = 4
	elif((start+55+180)  < (start+x) < (start+55+240)):
		desk = 5
	elif((start+55+240) < (start+x) < (start+55+300)):
		desk = 6
	else:
		out = 0
	
	if(out):
		d.KWinInterface.setCurrentDesktop(desk)
	else:
		pass


def myPager(widget, pos=5):
	bk = getWallpapers()
	
	d1 = karamba.createImage(widget, 0+pos,0, bk[0])
	karamba.resizeImage(widget, d1, 55, 40)

	d2 = karamba.createImage(widget, 60+pos,0, bk[1])
	karamba.resizeImage(widget, d2, 55, 40)

	d3 = karamba.createImage(widget, 120+pos,0, bk[2])
	karamba.resizeImage(widget, d3, 55, 40)

	d4 = karamba.createImage(widget, 180+pos,0, bk[3])
	karamba.resizeImage(widget, d4, 55, 40)
	
	d5 = karamba.createImage(widget, 240+pos,0, bk[4])
	karamba.resizeImage(widget, d5, 55, 40)
	
	d6 = karamba.createImage(widget, 300+pos,0, bk[5])
	karamba.resizeImage(widget, d6, 55, 40)

