# ***********************************
# * Python Pager
# * (C) Sean Brown
# * email: seanbrownstuff@hotmail.com
# * License: BSD - please see the included LICENCE file
# *
# * Version: 0.2
# ************************************

import karamba, dcop, dcopext

def getWallpapers(desks): 
 backgrounds = []
 dc = dcop.DCOPClient()
 dc.attach()
 dc.registerAs('monbar')
 d = dcopext.DCOPApp ("kdesktop", dc)
 for x in range(1, (desks+1)):
  a,b = d.KBackgroundIface.currentWallpaper(x)
  backgrounds.append(str(b))
 return backgrounds

#This is the old changeDesktop method, its not used anymore
def changeDesktop(start=5, x=10, button=1):
 out = 1
 dc = dcop.DCOPClient()
 dc.attach()
 dc.registerAs('monbar')
 d = dcopext.DCOPApp ("kwin", dc)
 
 if(x < start):
  out = 0
 elif(start < (start+x) < (start+55)):
  desk = 1
 elif((start+55) < (start+x) < (start+55+60)):
  desk = 2
 elif((start+55+60) < (start+x) < (start+55+120)):
  desk = 3
 elif((start+55+120) < (start+x) < (start+55+180)):
  desk = 4
 elif((start+55+180)  < (start+x) < (start+55+240)):
  desk = 5
 elif((start+55+240) < (start+x) < (start+55+300)):
  desk = 6
 else:
  out = 0
 
 if(out):
  d.KWinInterface.setCurrentDesktop(desk)
 else:
  pass

#This is the New changeDesktop method
def changeDesktop(desk):
 out = 1
 dc = dcop.DCOPClient()
 dc.attach()
 dc.registerAs('monbar')
 d = dcopext.DCOPApp ("kwin", dc)

 d.KWinInterface.setCurrentDesktop(desk)


def myPager(widget, desks, pos=5):
 dc = dcop.DCOPClient()
 dc.attach()
 dc.registerAs('monbar')
 d = dcopext.DCOPApp ("kwin", dc)
 
 bk = getWallpapers(desks)
 desktops = []
 
 for i in range(0, desks):
  desktops.append(karamba.createImage(widget, (i * 60)+pos,0, bk[i]))
  karamba.resizeImage(widget, desktops[i], 55, 40)
  deskcommand = 'd.KWinInterface.setCurrentDesktop(' + str(i+1) + ')'
  karamba.attachClickArea(widget, desktops[i])
 
 return desktops
