import karamba

import string
import os
import commands
import time
import glob

		
#############
# Bar Class #
#############

class Bar:
	def __init__(self,widget,headleft,middle,headright,offsetleft=0,offsetmiddle=0,offsetright=0):
		self.Headleft = headleft
		self.Middle = middle
		self. Headright = headright
		self.OffL = offsetleft
		self.OffM = offsetmiddle
		self.OffR = offsetright
		##Now we create, and then destroy a single middle element, just to know what is its width
		middlet = karamba.createImage(widget,0,0,self.Middle)
		self.Size = karamba.getImageWidth(widget,middlet)
		karamba.deleteImage(widget,middlet)
		
	def createBar(self,widget,nPos):
		## this code detect your resolution it's a rip-off of the code on cleanbar, 
		## i hope i can use it,if it's not please tell me
		xwinfo = os.system("which xwininfo")
		if ( xwinfo != ""):
			fp = os.popen("xwininfo -root -stats")
			output = fp.read()
			output = output.splitlines()
			for x in output:
				param = x.split()
				if(len(param) > 1):
					if (param[0].find("Width:") != -1):
						resX = int( param[1])
					if (param[0].find("Height:") != -1):
						resY = int( param[1])
		else :
			print("\n Can't detect your resolution we use the default res.\n")
			resX = 1024
			resY = 768
		##This code  create the bar
		karamba.createImage(widget, 0, self.OffL, self.Headleft)
		for i in range(1,nPos):
			karamba.createImage(widget, (i*self.Size)+12, self.OffM, self.Middle)
		karamba.createImage(widget, (nPos*self.Size)+12, self.OffR, self.Headright)
		##Now we center it on the screen
		TotalBarWidth = 76+((nPos-1)*self.Size)+46
		TotalBarHeight = 100
		karamba.resizeWidget(widget,TotalBarWidth,TotalBarHeight)
		karamba.moveWidget(widget,(resX-TotalBarWidth)/2,(resY-TotalBarHeight))
	
	##This metod create the Icon & the Applet on the bar	
	def designApps(self,widget,Icon):
		i = 0
		for i in range(len(Icon)):
			Icon[i].createApps(widget)

##############
# Icon Class #
##############

class IconApp:
	def __init__(self,size,sizemax,pos,icon,tooltip,command):
		#These are the base property of the object Icon
		self.Pos = pos
		self.Icon = icon
		self.Tooltip = tooltip
		self.Command = command
		self.Size = size
		self.SizeMax = sizemax
		
	def createApps(self,widget):
		##First the Icon
		self.IconHandle = karamba.createImage(widget,(self.Pos*self.Size),((72-self.Size)/2),self.Icon)
		karamba.resizeImageSmooth(widget,self.IconHandle,48,48)
		width=karamba.getImageWidth(widget,self.IconHandle)
		karamba.moveImage(widget,self.IconHandle,((5+(self.Pos*self.Size)+((self.Size-width)/2))),(((72-width)/2)+5))
		##Then the tooltip
		karamba.addImageTooltip(widget,self.IconHandle,self.Tooltip)
		##At last the clickArea
		karamba.createClickArea(widget,5+(self.Pos*self.Size),((72-self.Size)/2),self.Size,self.Size,self.Command)
		
	def zoomApp(self, widget,Off):
		if (Off < (self.Size/2)):
			karamba.resizeImageSmooth(widget,self.IconHandle,((self.SizeMax)+(Off-(self.Size/2))),((self.SizeMax)+(Off-(self.Size/2))))
			width = karamba.getImageWidth(widget,self.IconHandle)
			karamba.moveImage(widget, self.IconHandle,((5+(self.Pos*self.Size)+((self.Size-width)/2))-(Off/8)),((self.Size-width)/2)+5)
		elif (Off >= (self.Size/2)):
			karamba.resizeImageSmooth(widget,self.IconHandle,((self.SizeMax)-(Off-(self.Size/2))),((self.SizeMax)-(Off-(self.Size/2))))
			width = karamba.getImageWidth(widget,self.IconHandle)
			karamba.moveImage(widget, self.IconHandle,((5+(self.Pos*self.Size)+((self.Size-width)/2))-(Off/8)),((self.Size-width)/2)+5)
	
	#This method is used to reset the Icon
	def checkApp(self,widget):
		karamba.resizeImageSmooth(widget,self.IconHandle,48,48)
		width=karamba.getImageWidth(widget,self.IconHandle)
		karamba.moveImage(widget,self.IconHandle,((5+(self.Pos*self.Size)+((self.Size-width)/2))),(((72-width)/2)+5))
	
	#The nice Rotating effect
	def clickApp(self,widget,x,y):
		i=0
		while(i < 60):
			karamba.rotateImage(widget,self.IconHandle,i)
			karamba.redrawWidget(widget)
			i+=10
		while(i >= 0):
			karamba.rotateImage(widget,self.IconHandle,i)
			karamba.redrawWidget(widget)
			i-=10
		pass	
		
###############
# Pager Class #
###############

class Pager:
	
	def __init__(self,pagerback,pager,pos=0):
		self.pagerbackfile = pagerback
		self.pagerfile= pager
		self.PagerPos = pos
		self.Size = 64
		
	def createApps(self,widget):
		Desktop = commands.getoutput('dcop kwin KWinInterface currentDesktop')
		if int(Desktop) == 1:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*self.Size)+1,15,self.pagerbackfile)
		elif int(Desktop) == 2:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*self.Size)+32+2,15,self.pagerbackfile)
		elif int(Desktop) == 3:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*self.Size)+1,40,self.pagerbackfile)
		elif int(Desktop) == 4:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*self.Size)+32+2,40,self.pagerbackfile)
		self.pager=karamba.createImage(widget,(self.PagerPos*self.Size),15,self.pagerfile)
		
	def zoomApp(self, widget,Off):
		pass
		
	def clickApp(self,widget,x,y):
		if (x < ((self.PagerPos*self.Size)+32)):
			if (y < 39):
				# this call to dcop change the desktop
				os.system('dcop kwin KWinInterface setCurrentDesktop 1') 
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+1,15)
			else:
				os.system('dcop kwin KWinInterface setCurrentDesktop 3')
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+1,40)
		else:
			if (y < 39):
				os.system('dcop kwin KWinInterface setCurrentDesktop 2')
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+32+2,15)
			else:
				os.system('dcop kwin KWinInterface setCurrentDesktop 4')
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+32+2,40)

	#This method check if we had changed our Virtual desktop by other means than the Pager, and update it
	def checkApp(self,widget):
		Desktop = commands.getoutput('dcop kwin KWinInterface currentDesktop')
		if int(Desktop) == 1:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+1,15)
		elif int(Desktop) == 2:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+32+2,15)
		elif int(Desktop) == 3:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+1,40)
		elif int(Desktop) == 4:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*self.Size)+32+2,40)
			
###############
# Clock Class #
###############

class Clock:
	def __init__(self,pos):
		self.ClockPos = pos
		self.Size = 64
		
	def createApps(self,widget):
		self.Hour= commands.getoutput('date +%H:%M') #To change the format of the time do a man date in the console
		self.Clock = karamba.createText(widget,(self.ClockPos*self.Size)+10,20,64,20,self.Hour)
		karamba.changeTextFont(widget,self.Clock,"arial black")
		karamba.changeTextSize(widget,self.Clock,16)
		karamba.changeTextColor(widget,self.Clock,255,255,255)
		self.Date = karamba.createText(widget,(self.ClockPos*self.Size)+3,45,74,20,time.strftime("%a %d/%m/%Y", time.gmtime()))
		karamba.changeTextFont(widget,self.Date,"verdana")
		karamba.changeTextSize(widget,self.Date,8)
		karamba.changeTextColor(widget,self.Date,255,255,255)

	#This function is called by widgetUpdate and modify the clock to display the correct time
	def checkApp(self,widget):
		self.Hour= commands.getoutput('date +%H:%M')
		karamba.changeText(widget,self.Clock,self.Hour)
		karamba.changeText(widget,self.Date,time.strftime("%a %d/%m/%Y", time.gmtime()))
	
	def zoomApp(self, widget,Off):
		pass
		
	def clickApp(self,widget,x,y):
		pass	
	
###########################################
# Routine to parse the configuration file #
###########################################

#This function identify  our icon theme
def iconpath():
	if os.path.exists(os.path.normpath(os.path.expandvars("$HOME/.kde/share/config/kdeglobals"))):
		file = open(os.path.normpath(os.path.expandvars("$HOME/.kde/share/config/kdeglobals")),'r')
		kdePath = os.path.normpath(os.path.expandvars("$HOME/.kde/"))
	else:
		file = open(os.path.normpath(os.path.expandvars("$HOME/.kde3/share/config/kdeglobals")),'r')
		kdePath = os.path.normpath(os.path.expandvars("$HOME/.kde3/"))
	#we search the right icon theme	
	for line in file.readlines():
		if string.count(line,"Theme"):
			strPos = string.find(line,'=') + 1
			iconTheme= string.strip(line[strPos:-1])
	#check for the icon theme
	if os.path.exists(os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/64x64/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/64x64/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/48x48/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/48x48/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/128x128/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/128x128/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/64x64/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/64x64/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/48x48/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/48x48/apps"),'')))
	file.close()

# this function parses the Configuration file to know how is the bar
def parseConf(lista):
	file = open(os.path.expandvars(os.path.normpath("$HOME/.roundbarrc")), 'r')
	iconPath = iconpath()
	apps = 0
	control = 0
	i = 0
	j = 0
	appletlist = []
	appletpos = {}
	for line in file.readlines():
		if apps < 1:
			if string.count(line[0:2],'#'):
				pass ##I's a comment line
			elif string.count(line,"[Apps]"):
				apps = 1
			else:
				strPos = string.find(line, '=') + 1
				pos = int(string.strip(line[strPos:-1]))
				name = string.strip(line[:(strPos-1)])
				appletpos[name] = pos
				appletlist.append(0)
				appletlist[j] = name
				j += 1
		else:
		
			if string.count(line, "Icon"):
				strPos = string.find(line, '=') + 1
				#if in the conf file  the Icon tag contains a path that exist we use it
				if os.path.exists(string.strip(line[strPos:-1])):
					 Icon = (string.strip(line[strPos:-1]))
				#else we use the standard icon of the theme, if exist
				elif os.path.exists(os.path.normpath(iconPath+'/'+string.strip(line[strPos:-1])+".png")):
					Icon = (os.path.normpath(iconPath+'/'+string.strip(line[strPos:-1])+".png"))	
				control += 1
			
			elif string.count(line, "Exec"):
				strPos = string.find(line, '=') + 1
				#we set up the commands to execute on click
				Command = (string.strip(line[strPos:-1]))
				firstArgPos = string.find(Command," ")
				if firstArgPos > 0 :
					firstArg = Command[:firstArgPos]
				else:
					firstArg = Command
				#if it's not a dcop call it's better to launch the command with kstart, so we can continue
				#to use the RoundBar
				if (firstArg != "dcop"):
					Command = ("kstart " + Command)
					print Command
				control += 1
			
			elif string.count(line, "Tooltip"):
				strPos = string.find(line, '=') + 1
				Tooltip = (string.strip(line[strPos:-1]))
				control += 1
			
			if control == 3:
				control = 0
				lista.append(0)
				k = 0
				#We need to check that our current position is'nt occupied by the Clock or Pager
				for k in range(len(appletlist)):
					if i == appletpos[appletlist[k]]:
						if string.count(appletlist[k], "Pager"):
							lista[i] = Pager("Pics/Pager/Pager_back.png","Pics/Pager/Pager.png",i)
							i += 1
							lista.append(0)
						elif string.count(appletlist[k], "Clock"):
							lista[i] = Clock(i)
							i += 1
							lista.append(0)
				lista[i] = IconApp(64,72,i,Icon,Tooltip,Command)
				i += 1
	file.close()	

##########################
# Now The Karamba Stuff  #
##########################

HeadLeft = "Pics/head-left.png"
Middle = "Pics/middle.png"
HeadRight = "Pics/head-right.png"

IconApps = []

def initialize(widget):
	global init
	global IconApps
	parseConf(IconApps)
	BaseBar = Bar(widget,HeadLeft,Middle,HeadRight,0,5,5)
	BaseBar.createBar(widget,len(IconApps))
	BaseBar.designApps(widget,IconApps)
			
		
def initWidget(widget):
	initialize(widget)
	pass
	
def widgetUpdated(widget):
	for i in range(len(IconApps)-1):
		IconApps[i].checkApp(widget)
	pass
	
def widgetClicked(widget,x,y,button):
	if button == 1:
		Icon = x / IconApps[0].Size
		if Icon < len(IconApps):
			IconApps[Icon].clickApp(widget,x,y)
	elif button == 2:
		os.system(os.path.expandvars("kstart kedit $HOME/.roundbarrc"))
		
	pass
	
def widgetMouseMoved(widget,x,y,button):
	Icon = x / IconApps[0].Size
	Offset = x % IconApps[0].Size
	if x >	5 and x < (IconApps[0].Size*(len(IconApps))) and y > 5 and y < 72 :
		if Icon < len(IconApps):
			if Icon == (len(IconApps)-1):
				IconApps[Icon-1].checkApp(widget)
			elif Icon == 0:
				IconApps[Icon+1].checkApp(widget)
			else:
				IconApps[Icon-1].checkApp(widget)
				IconApps[Icon+1].checkApp(widget)
			IconApps[Icon].zoomApp(widget,Offset)
			
	else: 
		IconApps[0].checkApp(widget)
		if Icon < len(IconApps):
			IconApps[Icon].checkApp(widget)
		IconApps[len(IconApps)-1].checkApp(widget)
	karamba.redrawWidget(widget)
	pass
