#SpiffiBar by Willem Bult

#Parts are modifications of "DynBar" by Wizzard (original "RoundBar" by Michele Albanese)
#and "PlasticBar" by Sean Fleming

#Credits for the name go to Amber, who invented the word spiffiness as a synonym for "coolness"

import karamba
import glob
import string
import time
import os
import os.path
import qt
from kdecore import KWin, KURL
from kio import KFileItem

bar = [ ]
dividerspace = 15

kmenu_x = 0
kmenu_width = 0

desktops = [ ]
desktopCount = 0
desktops_x = 0
desktops_width = 0
currentdesktop = 0

names = [ ]
icons = [ ]
commands = [ ]
iconCount = 0
iconSize = 24
iconSpace = 0
# Both of these 2 paths should have the closing / !
iconTheme = "/usr/kde/3.2/share/icons/slick/"
linksPath = "/home/wbult/.superkaramba/SpiffiBar/files/"

taskbar_x = 0
taskbar_y = 39
taskbar_height = 18
taskbar_width = 200
taskbar_font = "Verdana"
taskbar_fontsize = 10
task_width = 0
task_list = []
task_oldtextlist = []
task_frametextlist = []
extraTaskbarSpace = 100

browser_x = 0
browser_width = 30
# Path the quickbrowser should use as root, without closing / !
browser_path = "/mnt/files"
browser_contents = {}

systray = 0
systray_enabled = 1
systray_x = 0
systray_width = 100

time_x = 0
time_width = 85
time_font = "Verdana"
time_fontsize = 18
time_text = 0
date_font = "Verdana"
date_fontsize = 12
date_text = 0

if (os.system("which xwininfo") == 0):
	pass
else:
	print "\nCan't find xwininfo in your path."

fp = os.popen("xwininfo -root -stats")
output = fp.read()
output = output.splitlines()
i = 0
for x in output:
	param = x.split()
	if (len(param) > 1):
		if param[0].find("Width:") != -1:
			resX = int(param[1])
		if param[0].find("Height:") != -1:
			resY = int(param[1])


def initWidget(widget):
	global iconTheme
	global resX
	global resY
	
	global bar
	global dividerspace
 	global extraTaskbarSpace
	
	global kmenu_x
	global kmenu_width
	
	global desktops_x
	global desktops_width
	
	global linksPath
	global names
	global icons
	global commands
	global iconCount
	global iconSize
	global iconSpace
	
	global taskbar_x
	global taskbar_width
	
	global browser_x
	global browser_width
	
	global systray
	global systray_x
	global systray_width
	global systray_enabled

	global time_x
	
	karamba.addMenuConfigOption(widget, "systray", "Systray Enabled") 
	systray_enabled = karamba.readMenuConfigOption(widget, "systray")
		
	names = [ ]
	icons = [ ]
	commands = [ ]
	iconCount = 0
	iconSpace = iconSize + 16
	
	fileList = glob.glob(linksPath+"*")
	fileList.sort()
	for fileName in fileList:
		if os.path.isfile(fileName) != 1:
			continue
		file = open(fileName, 'r')
		line = file.readline()
		if string.count(line, "[Desktop"):
			for line in file.readlines():
				names.append("")
				icons.append("")
				commands.append("")
				if line[:4] == "Name":
					strPos = string.find(line, "=") + 1
					names[iconCount] = line[strPos:-1]
				if line[:3] == "Dev":
					strPos = string.find(line, "=") + 1
					names[iconCount] = line[strPos:-1]
				if line[:4] == "Exec":
					strPos = string.find(line, "=") + 1
					commands[iconCount] = line[strPos:-1]
				if line[:10] == "MountPoint":
					strPos = string.find(line, "=") + 1
					commands[iconCount] = "kstart konqueror " + line[strPos:-1]
				if line[:4] == "Icon" or line[:11] == "UnmountIcon":
					line = string.replace(line, ".png", '')
					strPos = string.find(line, '=') + 1
					if glob.glob(line[strPos:-1]+".png") != []:
						icons[iconCount] = line[strPos:-1]+".png"
					elif glob.glob(iconTheme+"48x48/apps/"+line[strPos:-1]+".png") != []:
						icons[iconCount] = iconTheme+"48x48/apps/"+line[strPos:-1]+".png"
					elif glob.glob(iconTheme+"48x48/devices/"+line[strPos:-1]+".png") != []:
						icons[iconCount] = iconTheme+"48x48/devices/"+line[strPos:-1]+".png"
					elif glob.glob(iconTheme+"48x48/actions/"+line[strPos:-1]+".png") != []:
						icons[iconCount] = iconTheme+"48x48/actions/"+line[strPos:-1]+".png"
					elif glob.glob(iconTheme+"48x48/filesystems/"+line[strPos:-1]+".png") != []:
						icons[iconCount] = iconTheme+"48x48/filesystems/"+line[strPos:-1]+".png"
					elif glob.glob(iconTheme+"48x48/mimetypes/"+line[strPos:-1]+".png") != []:
						icons[iconCount] = iconTheme+"48x48/mimetypes/"+line[strPos:-1]+".png"
			iconCount += 1

	kmenu_x = 16
	kmenu_width = 24
	
	desktopCount = KWin.numberOfDesktops()
	desktopTopCount = (desktopCount/2 + desktopCount%2)
	desktops_width = desktopTopCount * 30
	desktops_x = kmenu_x + kmenu_width + dividerspace

	taskbar_x = desktops_x + desktops_width + dividerspace
	taskbar_width = iconSpace * iconCount + dividerspace + browser_width + dividerspace + systray_width + extraTaskbarSpace
	
	browser_x = taskbar_x + taskbar_width - browser_width
	systray_x = browser_x - dividerspace - systray_width
	
	time_x = taskbar_x + taskbar_width + 0.5 * dividerspace
	total_width = 16 + kmenu_width + dividerspace + desktops_width + dividerspace + taskbar_width + dividerspace + time_width + 16
		
	karamba.resizeWidget(widget,total_width, 64)
	karamba.moveWidget(widget, (resX-total_width)/2, resY-64)
	karamba.redrawWidget(widget)
		
	bar.append(karamba.createImage(widget, 0, 0, "img/head-left.png"))
	bar.append(karamba.createImage(widget, 16, 0, "img/middle.png"))
	karamba.resizeImage(widget, bar[1], total_width - 32, 70)
	bar.append(karamba.createImage(widget, total_width - 16, 0, "img/head-right.png"))
	
	kmenu = karamba.createImage(widget, kmenu_x, 9, "img/kmenu.png")
	karamba.resizeImage(widget, kmenu, 24, 24)
	
	kdesktop = karamba.createImage(widget, kmenu_x, 33, "img/desktop.png")
	karamba.resizeImage(widget,kdesktop, 24, 24)
	
	updateDesktops(widget)
		
	for i in range(iconCount):
		icons[i] = karamba.createImage(widget, taskbar_x+(i*iconSpace), 8, icons[i])
		karamba.resizeImage(widget, icons[i], iconSize, iconSize)
		karamba.addImageTooltip(widget, icons[i], names[i])

	karamba.createImage(widget, browser_x, 8, "img/browser.png")
	
	systray = karamba.createSystray(widget, systray_x, 5, systray_width, 24)
	if systray_enabled == 0:
		karamba.hideSystray(widget)
		
	update_tasks(widget)
	
	
def widgetUpdated(widget):
	update_time(widget)
	update_tasks(widget)
	pass

	
def widgetClicked(widget, x, y, button):
	global iconCount
	global commands
	global kmenu_x
	global kmenu_width
	global desktops_x
	global desktops_width
	global taskbar_x
	global taskbar_y
	global taskbar_height
	global taskbar_width
	global browser_path

	if ( button==1 and kmenu_x <= x <= kmenu_x + kmenu_width and y < 33):
		coords = karamba.getWidgetPosition(widget)
		os.system("dcop kicker kicker popupKMenu " + `coords[0] + kmenu_x` + "," + `-410`)
	elif ( button==1 and (kmenu_x <= x <= kmenu_x + kmenu_width) and y >= 33):
		karamba.toggleShowDesktop(widget)
	elif ( button==1 and (desktops_x <= x <= taskbar_x)):
		desktop_click(widget, x, y)
	elif ( button==1 and (taskbar_x <= x <= (taskbar_x+taskbar_width)) and (taskbar_y <= y <= (taskbar_y+taskbar_height)) ):  
		task_click(widget, x, y)
	elif ( button==1 and (taskbar_x <= x <= taskbar_x+(iconCount*iconSpace)) and 8 <= y <= 30 ):
		icon = (x-taskbar_x) / iconSpace
		if 0 <= icon < iconCount:
			os.system(commands[icon]+" &")
	elif ( button==1 and (browser_x <= x <= browser_x + browser_width) and 8 <= y <= 30 ):
		filebrowser(widget, browser_path)
	pass
	

def taskAdded(widget, task):
	update_tasks(widget)

def taskRemoved(widget, task):
	update_tasks(widget)
    
def activeTaskChanged(widget, task):
	update_tasks(widget)    

def updateDesktops(widget):
	global kmenu_x
	global kmenu_width
	global currentdesktop
	global desktops
	global desktops_width
	global desktops_x
	
	for i in desktops:
		karamba.deleteImage(widget,i)
	
	desktops = []
	currentdesktop = KWin.currentDesktop()
	desktopCount = KWin.numberOfDesktops()
	desktopTopCount = (desktopCount/2 + desktopCount%2)
		
	for i in range(desktopCount):
		if (i+1) == currentdesktop:
			desktops.append(karamba.createImage(widget, desktops_x+30*(i%desktopTopCount), 6 + (i/desktopTopCount)*26, "img/desktop_active.png"))
		else:
			desktops.append(karamba.createImage(widget, desktops_x+30*(i%desktopTopCount), 6 + (i/desktopTopCount)*26, "img/desktop_inactive.png"))
		

def update_tasks(widget):
	global task_list
	global task_oldtextlist
	global task_frametextlist
	global taskbar_x
	global taskbar_y
	global taskbar_height
	global taskbar_width
	global task_width
	global taskbar_font
	global desktops_width
	global currentdesktop
	
	for this_task in task_oldtextlist:
		karamba.deleteText(widget, this_task)

	for this_task in task_frametextlist:
		karamba.deleteImage(widget, this_task)

	task_oldtextlist = []
	task_frametextlist = []

	task_templist = karamba.getTaskList(widget)
	task_list = []
	
	if KWin.currentDesktop() != currentdesktop:
		updateDesktops(widget)
	
	for this_task in task_templist:
		task_info = karamba.getTaskInfo(widget,this_task)      
		if task_info[3] == currentdesktop:
			task_list.append(this_task)	
	
	if len(task_list) > 0:
		task_width = taskbar_width / len(task_list)
	else:
		task_width = 0
	task_x = taskbar_x
	task_y = taskbar_y
	
	for this_task in task_list:                                
		task_info = karamba.getTaskInfo(widget,this_task)      

		if task_info[7] == 1:
			this_frame = karamba.createImage(widget, task_x, task_y, "img/taskbg_active.png")
		else:
			this_frame = karamba.createImage(widget, task_x, task_y, "img/taskbg_inactive.png")
		
		karamba.resizeImage(widget,this_frame,task_width-5,taskbar_height-1)
		task_frametextlist.append(this_frame)
			
		this_text = karamba.createText(widget, task_x+5, task_y, task_width-11, taskbar_height, task_info[0])
		karamba.changeTextColor(widget, this_text, 0, 0, 0)
		karamba.changeTextSize(widget, this_text, taskbar_fontsize)
		karamba.changeTextFont(widget, this_text, taskbar_font)
		task_oldtextlist.append(this_text)

		task_x = task_x + task_width
		
def update_time(widget):
	global time_text
	global time_x
	global time_font
	global time_fontsize
	global date_text
	global date_font
	global date_fontsize
	
	karamba.deleteText(widget,time_text)
	time_text = karamba.createText(widget, time_x, 10, time_width, 30, time.strftime("%H:%M:%S",time.localtime())) 
	karamba.changeTextColor(widget,time_text, 0, 0, 0)
	karamba.changeTextSize(widget,time_text,time_fontsize)
	karamba.changeTextFont(widget,time_text,time_font)
	
	karamba.deleteText(widget,date_text)
	date_text = karamba.createText(widget, time_x, 38, date_text, 30, time.strftime("%d-%m-%Y",time.localtime())) 
	karamba.changeTextColor(widget,date_text, 0, 0, 0)
	karamba.changeTextSize(widget,date_text,date_fontsize)
	karamba.changeTextFont(widget,date_text,date_font)
	
def task_click(widget, x, y):
	global task_list
	global taskbar_x
	global taskbar_h
	global taskbar_width
   
	task_x = x - taskbar_x
	task_y = y - taskbar_y
	listnum = (task_x / task_width)
	karamba.performTaskAction(widget, task_list[listnum], 8)
	
def desktop_click(widget, x, y):
	global desktops_x
	
	desktopCount = KWin.numberOfDesktops()
	desktopTopCount = (desktopCount/2 + desktopCount%2)
	
	clicky = y-5
	clickx = x-desktops_x
	desktopclick = (clickx/30) + (clicky/30)*desktopTopCount
	KWin.setCurrentDesktop(desktopclick+1)
	
	update_tasks(widget)
	
def filebrowser(widget, path):
	global browser_contents
	global browser_path
	
	contents = os.listdir(path)
	contents.sort()
	
	browser_menu = karamba.createMenu(widget)
	browser_contents = {}
	
	menu_id = karamba.addMenuItem(widget,browser_menu,"OPEN IN FILEMANAGER","konqueror")
	browser_contents[menu_id] = "FILEMGR:" + path
	menu_id = karamba.addMenuItem(widget,browser_menu,"OPEN IN XMMS","xmms")
	browser_contents[menu_id] = "XMMS:" + path
	menu_id = karamba.addMenuItem(widget,browser_menu,"ENQUEUE IN XMMS","xmms")
	browser_contents[menu_id] = "XMMSENQ:" + path
	menu_id = karamba.addMenuItem(widget,browser_menu,"","/")
	browser_contents[menu_id] = "DIVIDER"
	
	for item in contents:
		if os.path.isdir(path + "/" + item):
			menu_id = karamba.addMenuItem(widget,browser_menu,item,"folder")
			browser_contents[menu_id] = path + "/" + item

	for item in contents:
		if os.path.isfile(path + "/" + item):
			file = KFileItem(KFileItem.Unknown, KFileItem.Unknown, KURL(path + "/" + item))
			menu_id = karamba.addMenuItem(widget,browser_menu,item,str(file.iconName()))
			browser_contents[menu_id] = path + "/" + item
	
	if not path == browser_path:
		menu_id = karamba.addMenuItem(widget,browser_menu,"","/")
		browser_contents[menu_id] = "DIVIDER"
		menu_id = karamba.addMenuItem(widget,browser_menu,"BACK","folder")
		browser_contents[menu_id] = path[:string.rfind(path,"/")]
	
	karamba.popupMenu(widget,browser_menu,browser_x+15,-len(browser_contents)*20)
	pass
	
def menuItemClicked(widget, menu, id):
	global browser_contents
	
	if os.path.isdir(browser_contents[id]):
		filebrowser(widget,browser_contents[id])
	elif os.path.isfile(browser_contents[id]):
		file = KFileItem(KFileItem.Unknown, KFileItem.Unknown, KURL(browser_contents[id]))
		file.run()
	elif browser_contents[id][:8] == "FILEMGR:":
		os.system("konqueror '" + browser_contents[id][8:] + "'")
	elif browser_contents[id][:5] == "XMMS:":
		os.system("xmms '" + browser_contents[id][5:] + "'")
	elif browser_contents[id][:8] == "XMMSENQ:":
		os.system("xmms -e '" + browser_contents[id][8:] + "'")
	else:
		pass	
		
def menuOptionChanged(widget, key, value):

	if key == "systray" and value == 1:
		karamba.showSystray(widget)
	elif key == "systray" and value == 0:
		karamba.hideSystray(widget)