#SpiffiLyrics by Willem Bult

#Modified from XMMSlyrics by Krasimir Atanasov
#Released under the GPL

#Credits for the name go to Amber, who invented the word spiffiness as a synonym for "coolness"

import os
import karamba
import string
import urllib
import re

font = "Verdana"
fontsize = 10
title_fontsize = 3
title = 0

lyrics_list = []
display_list = []
listindex = 0
linecount = 20
maxlinelength = 38
lyrics_engine = "lyrc.com.ar"

lyr_path = " - "
artist = " - "
song = " - "
songtitle = " - "

barroller = 0
barrollerheight = 0


def initWidget(widget):
	global linecount,title
	global font,fontsize,title_fontsize
	global barroller
			
	if (os.system("which xmmsctrl") == 0):
		pass
	else:
		os.system("kdialog --error \"xmmsctrl could not be found!  Please install it to use this theme.  \nVisit:\nhttp://user.it.uu.se/~adavid/utils/\" --title \"XMMS Bar Error\"")
		print "\nCan't find xmmsctrl in your path.  Please install it to make this work.  "

	karamba.createImage(widget,0,0,"image/top.png")
	middle = karamba.createImage(widget,0,16,"image/middle.png")
	karamba.resizeImage(widget,middle,250,linecount * 15+40)
	karamba.createImage(widget,0,linecount*15+40+16,"image/bottom.png")
	karamba.resizeWidget(widget,250,linecount*15+40+32)
	
	bar = karamba.createImage(widget,235,16+40,"image/bar.png")
	karamba.resizeImage(widget,bar,5,linecount*15)
	
	barroller = karamba.createImage(widget,235,16+40,"image/barfilled.png")
	karamba.resizeImage(widget,barroller,5,0)
		
	title = karamba.createRichText(widget,"",0)
	karamba.moveRichText(widget,title,6,10)
	
	for i in range(linecount):
		curline = karamba.createText(widget,10,i*15+58,300,15,"")
		karamba.changeTextColor(widget,curline,0,0,0)
		karamba.changeTextSize(widget,curline,fontsize)
		karamba.changeTextFont(widget,curline,font)
		display_list.append(curline)
	
	karamba.redrawWidget(widget)
			
def widgetUpdated(widget):
	global songtitle, artist, song
	global font,title_fontsize
	global lyrics_list, display_list, listindex, linecount, maxlinelength
	global barroller,barrollerheight
	global title

	oldtitle = songtitle
	song_info(widget)
	
	if songtitle != oldtitle:
		karamba.changeRichText(widget,title,"<font face="+font+" size="+str(title_fontsize)+"><b>"+songtitle+"</b></font>")
		karamba.setRichTextWidth(widget,title,250)
	
		try:
			fp = open(lyr_path, 'r')
			output = fp.readlines()
		except:
			output = downloadLyrics(widget, artist, song)

		lyrics_list = []
		
		for line in output:
			curstring = line
			while len(curstring)>maxlinelength:
				for y in range(0, maxlinelength):
					if (curstring[y] == " "):
						last_space = y
				if last_space < 10 :
					last_space = maxlinelength
				lyrics_list.append(str(curstring[0:last_space]))
				curstring=curstring[last_space+1:]
			lyrics_list.append(str(curstring))
			
		listindex = 0
		for line in range(linecount):
			if len(lyrics_list) > line:
				karamba.changeText(widget,display_list[line],lyrics_list[line])
				karamba.showText(widget,display_list[line])
			else:
				karamba.hideText(widget,display_list[line])
		
		if len(lyrics_list) > linecount:
			barrollerheight = int(float(float(linecount)/float(len(lyrics_list)))*(linecount*15))
			karamba.resizeImage(widget,barroller,5,barrollerheight)
		else:
			karamba.resizeImage(widget,barroller,5,0)
				
		karamba.redrawWidget(widget)

def widgetClicked(widget, x, y, button):
	global lyrics_list,display_list,listindex,linecount,barroller,barrollerheight

	if (button == 4):
		listindex -= 5
	if (button == 5):
		listindex += 5

	if listindex > (len(lyrics_list)-linecount):
		listindex = len(lyrics_list)-linecount
	if listindex < 0:
		listindex = 0
	
	a = float(float(listindex)/float(len(lyrics_list)-linecount)) * ((linecount * 15) - barrollerheight)
	karamba.moveImage(widget,barroller,235,16+40+a)
	
	for line in range(linecount):
		if len(lyrics_list) >= (line+listindex):
			karamba.changeText(widget,display_list[line],lyrics_list[line+listindex])
			karamba.showText(widget,display_list[line])
		else:
			karamba.hideText(widget,display_list[line])
		
	karamba.redrawWidget(widget)
	
	
def song_info(widget):
	global songtitle, artist, song, lyr_path
	try:
		songtitle = os.popen("xmmsctrl title")
		songtitle = songtitle.readline()
		song = songtitle.split("-")
		artist = song[0]
		artist = artist[:-1]
		song = song[1]
		song = song[1:-1]
		lyr_path = karamba.getThemePath(widget)
		lyr_path = lyr_path + 'lyrics/' + string.lower(songtitle[0]) + '/' + songtitle[0:-1] + '.txt'
	except:
		songtitle = 'XMMS is not Started !'
		artist = 'XMMS is not Started !'
		song = 'XMMS is not Started !'
		lyr_path = karamba.getThemePath(widget)
		lyr_path = lyr_path + 'lyrics/' + 'noxmms.txt'	
		
def downloadLyrics(widget, artist, song):
	if lyrics_engine == "sing365.com":
	  return sing365(artist,song)
	else:
		return lyrc(artist,song)
	
def lyrc(artist, song):
#try:
	params = urllib.urlencode({'artist': artist, 'songname': song, 'procesado2': '1', 'Submit': ' S E A R C H '})
	f = urllib.urlopen("http://lyrc.com.ar/en/tema1en.php", params)
	Page = f.readlines()
	output = []
	
	for x in Page:
		if re.search('<br />',x):
			if x[0:5] == '<font':
				x = re.sub('(<font \w+=\'2\'>)|(</font>)|(<b>)|(</b>)|(<u>)|(</u>)|(<br>)','',x)
				x = x[len(artist+song):]

			x = re.sub('<br />','',x)
			output.append(string.lstrip(x))
			
	if len(output) > 2:
		saveLyrics(output)
		return output
	else:
		return ["No Lyrics found !"]
#except:
#	return ["HTTP ERROR !"]

def sing365(artist, song):
	try:
		params = urllib.urlencode({'searchstr': song, 'category': 'song'})
		f = urllib.urlopen("http://search.sing365.com./search.php?%s" %params)
		Page = f.read()
		Page = re.sub('<B>','', Page)
		Page = re.sub('</B>','', Page)
		pattern = '<a href\=click\.php\?id\=(.*?)>'  + song +'</FONT></a>'
		try:
			x = re.search(pattern, Page).group(1)
		except:
			return ["No Lyrics found !"]
		x='http://search.sing365.com/click.php?id=' + x + '&table=song'
		f = urllib.urlopen(x)
		Page = f.read()
		pattern = '.*?<BR>'
		x = re.findall(pattern, Page)

		output = ""
		for y in x:
			if y[0] != '<':
				y = re.sub('<BR>',"\n", y)
				output = output + y

		if len(output) > 20:
			saveLyrics(output)
			return output
		else:
			return ["No Lyrics found !"]
	except:
		return ["HTTP ERROR !"]

def saveLyrics(output):
	global lyr_path, old_song
	save = open(lyr_path, 'w')
	for line in output:
		print >> save, string.rstrip(str(line))
	save.close()
