#***************************************************************************
#                              Super Api 
#                            -------------------
#   begin                : Mon Jan 26 2004
#   copyright            : (C) 2004 by Dmitry "Troydm" Geurkov
#   email                : dmitry_627@mail.ru
#***************************************************************************

#***************************************************************************
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#***************************************************************************
import karamba
import os,re,time
import xmms

############ Widget class ###############################
class Widget :
     
     def __init__(self,widget,x,y,w,h):
             pass
             self.x=x
             self.y=y
             self.w=w
             self.h=h
             self.k=0
             self.s=False
             self.wd=widget
     
     def create(self):
             pass
             self.k=0
             self.s=True
     
     def delete(self):
             pass
             self.k=0
             self.s=False
     
     def update(self):
             pass
     
     def move(self,x,y):
             pass
             if self.x!=x or self.y!=y:
                 self.x=x
                 self.y=y
                 return True
             else:
                 return False
     
     def resize(self,w,h):
             pass
             if self.w!=w or self.h!=h:
                 self.w=w
                 self.h=h
                 return True
             else:
                 return False
     
     def isShown(self):
             pass
             return self.s
     
     def hide(self):
             pass
             if self.s==True:
                 self.s=False
                 return True
             else:
                 return False
     
     def show(self):
             pass
             if self.s==False:
                 self.s=True
                 return True
             else:
                 return False
     
     def clicked(self,x,y) :
             pass
             return (self.y<=y<=self.y+self.h and self.x<=x<=self.x+self.w)
     
     def click(self,x,y):
             pass
#############       Image class    ########################
class Image( Widget ) :
     
     def __init__(self,widget,x,y,w,h,path):
             pass
             Widget.__init__(self,widget,x,y,w,h)
             self.p=path
     
     def create(self):
             pass
             Widget.create(self)
             self.k=karamba.createImage(self.wd,self.x,self.y,self.p)
     
     def delete(self):
             pass
             karamba.deleteImage(self.wd,self.k)
             Widget.delete(self)
     
     def move(self,x,y):
             pass
             if Widget.move(self,x,y):
                 karamba.moveImage(self.wd,self.k,self.x,self.y)
     
     def resize(self,w,h):
             pass
             if Widget.resize(self,w,h):
                 karamba.resizeImage(self.wd,self.k,self.w,self.h)
     
     def hide(self):
             pass
             if Widget.hide(self):
                 karamba.hideImage(self.wd,self.k)
     
     def show(self):
             pass
             if Widget.show(self):
                 karamba.showImage(self.wd,self.k)
##################  Text class    #########################
class Text( Widget ) :
     
     def __init__(self,widget,x,y,w,h,t='',s=12,cr=0,cg=0,cb=0):
             pass
             Widget.__init__(self,widget,x,y,w,h)
             self.t=t
             self.ts=s
             self.tc=[cr,cg,cb]
     
     def create(self):
             pass
             Widget.create(self)
             self.k=karamba.createText(self.wd,self.x,self.y,self.w,self.h,self.t)
             karamba.changeTextSize(self.wd,self.k,self.ts)
             karamba.changeTextColor(self.wd,self.k,self.tc[0],self.tc[1],self.tc[2])
     
     def delete(self):
             pass
             karamba.deleteText(self.wd,self.k)
             Widget.delete(self)
     
     def move(self,x,y):
             pass
             if Widget.move(self,x,y):
                 karamba.moveText(self.wd,self.k,self.x,self.y)
     
     def resize(self,w,h):
             pass
             if Widget.resize(self,w,h):
                 k=karamba.createText(self.wd,self.x,self.y,self.w,self.h,self.t)
                 karamba.changeTextSize(self.wd,k,self.ts)
                 karamba.changeTextColor(self.wd,k,self.tc[0],self.tc[1],self.tc[2])
                 karamba.deleteText(self.wd,self.k)
                 self.k=k
     
     def hide(self):
             pass
             if Widget.hide(self):
                 karamba.hideText(self.wd,self.k)
     
     def show(self):
             pass
             if Widget.show(self):
                 karamba.showText(self.wd,self.k)
     
     def change(self,t):
             pass
             self.t=t
             karamba.changeText(self.wd,self.k,self.t)
     
     def setSize(self,s):
         pass
         if self.ts!=s:
             self.ts=s
             karamba.changeTextSize(self.wd,self.k,self.ts)
     
     def setColor(self,cr,cg,cb):
             pass
             if self.tc[0]!=cr or self.tc[1]!=cg or self.tc[2]!=cb:
                 self.tc=[cr,cg,cb]
                 karamba.changeTextColor(self.wd,self.k,self.tc[0],self.tc[1],self.tc[2])
#############       SysTray class    ########################
class SysTray( Widget ) :
     
     def __init__(self,widget,x,y,w,h):
             pass
             Widget.__init__(self,widget,x,y,w,h)
     
     def create(self):
             pass
             Widget.create(self)
             self.k=karamba.createSystray(self.wd,self.x,self.y,self.w,self.h)
     
     def delete(self):
             pass
             karamba.deleteSystray(self.wd,self.k)
             Widget.delete(self)
     
     def move(self,x,y):
             pass
             if Widget.move(self,x,y):
                 karamba.moveSystray(self.wd,self.k,self.x,self.y)
     
     def resize(self,w,h):
             pass
             if Widget.resizeSystray(self,w,h):
                 pass
     
     def hide(self):
             pass
             if Widget.hide(self):
                 karamba.hideSystray(self.wd,self.k)
     
     def show(self):
             pass
             if Widget.show(self):
                 karamba.showSystray(self.wd,self.k)
############# HorBar class #################
class HorBar( Widget ) :
     
     def __init__(self,widget,x,y,w,h,p,n):
             pass
             Widget.__init__(self,widget,x,y,w,h)
             self.p=p
             self.n=n
     
     def create(self):
             pass
             Widget.create(self)
             self.k=range(self.n)
             st=self.w/self.n
             for i in range(self.n):
                 self.k[i]=karamba.createImage(self.wd,self.x+i*st,self.y,self.p)
     
     def delete(self):
             pass
             for i in range(self.n):
                 karamba.deleteImage(self.wd,self.k[i])
             Widget.delete(self)
     
     def hide(self):
             pass
             if Widget.hide(self):
                 for i in range(self.n):
                     karamba.hideImage(self.wd,self.k[i])
     
     def setBar(self,p):
             pass
             if self.p!=p:
                 self.p=p
                 p=int(self.n*p)
                 for i in range(p):
                     karamba.showImage(self.wd,self.k[i])
                 for i in range(p,self.n):
                     karamba.hideImage(self.wd,self.k[i])
     
     def show(self):
             pass
             if Widget.show(self):
                 for i in range(self.n):
                     karamba.showImage(self.wd,self.k[i])
     
     def onclick(self,x,y):
             pass
             return float((x-self.x))/self.w
############# VerBar class #################
class VerBar( Widget ) :
     
     def __init__(self,widget,x,y,w,h,p,n):
             pass
             Widget.__init__(self,widget,x,y,w,h)
             self.p=p
             self.n=n
     
     def create(self):
             pass
             Widget.create(self)
             self.k=range(self.n)
             st=self.h/self.n
             for i in range(self.n):
                 self.k[i]=karamba.createImage(self.wd,self.x,self.y+self.h-i*st,self.p)
     
     def delete(self):
             pass
             for i in range(self.n):
                 karamba.deleteImage(self.wd,self.k[i])
             Widget.delete(self)
     
     def hide(self):
             pass
             if Widget.hide(self):
                 for i in range(self.n):
                     karamba.hideImage(self.wd,self.k[i])
     
     def setBar(self,p):
             pass
             if self.p!=p:
                 self.p=p
                 p=int(self.n*p)
                 for i in range(p):
                     karamba.showImage(self.wd,self.k[i])
                 for i in range(p,self.n):
                     karamba.hideImage(self.wd,self.k[i])
     
     def show(self):
             pass
             if Widget.show(self):
                 for i in range(self.n):
                     karamba.showImage(self.wd,self.k[i])
     
     def onclick(self,x,y):
             pass
             return float((y-self.y))/self.h
############# CPU Sensor ################
class CPUSensor :
     
     def __init__(self,cpu='cpu0'):
             pass
             self.c=cpu
             self.u=[0,0]
             self.s=[0,0]
             self.n=[0,0]
             self.i=[0,0]
             self.t=0
             self.update()
     
     def update(self):
             pass
             f=open('/proc/stat','r')
             buf=f.readlines()
             f.close()
             for i in range(len(buf)):
                 st=re.match(self.c+'\\s+(\\d+)\\s+(\\d+)\\s+(\\d+)\\s+(\\d+)',buf[i])
                 if st!=None:
                     self.u[0]=self.u[1]
                     self.s[0]=self.s[1]
                     self.n[0]=self.n[1]
                     self.i[0]=self.i[1]
                     self.u[1]=long(st.group(1))
                     self.s[1]=long(st.group(2))
                     self.n[1]=long(st.group(3))
                     self.i[1]=long(st.group(4))
                     self.t=float((self.u[1]-self.u[0])+(self.s[1]-self.s[0])+(self.n[1]-self.n[0])+(self.i[1]-self.i[0]))
                     break
     
     def get(self,st) :
             pass
             st=st.replace('%t',str(int(100*self.getLoad())))
             st=st.replace('%u',str(int(100*self.getUser())))
             st=st.replace('%s',str(int(100*self.getSystem())))
             st=st.replace('%n',str(int(100*self.getNice())))
             st=st.replace('%i',str(int(100*self.getIdle())))
             return st
      
     def getLoad(self):
             pass
             return ((self.u[1]+self.s[1]+self.n[1])-(self.u[0]+self.s[0]+self.n[0]))/self.t
     
     def getUser(self):
             pass
             return (self.u[1]-self.u[0])/self.t
     
     def getSystem(self):
             pass
             return (self.s[1]-self.s[0])/self.t
     
     def getNice(self):
             pass
             return (self.n[1]-self.n[0])/self.t
     
     def getIdle(self):
             pass
             return (self.i[1]-self.i[0])/self.t
############# Memory Sensor ################
class MEMSensor :
     
     def __init__(self):
             pass
             self.t=0
             self.f=0
             self.b=0
             self.c=0
             self.ts=0
             self.fs=0
             self.update()
     
     def update(self):
             pass
             f=open('/proc/meminfo','r')
             buf=f.readlines()
             f.close()
             for i in range(len(buf)):
                 st=re.match('MemTotal:\\s*(\\d*)',buf[i])
                 if st!=None : self.t=int(st.group(1))
                 st=re.match('MemFree:\\s*(\\d+)',buf[i])
                 if st!=None : self.f=int(st.group(1))
                 st=re.match('Buffers:\\s*(\\d+)',buf[i])
                 if st!=None : self.b=int(st.group(1))
                 st=re.match('Cached:\\s*(\\d+)',buf[i])
                 if st!=None : self.c=int(st.group(1))
                 st=re.match('SwapCached:\\s*(\\d+)',buf[i])
                 if st!=None : self.c=self.c+int(st.group(1))
                 st=re.match('SwapTotal:\\s*(\\d+)',buf[i])
                 if st!=None : self.ts=self.c+int(st.group(1))
                 st=re.match('SwapFree:\\s*(\\d+)',buf[i])
                 if st!=None : self.fs=self.c+int(st.group(1))
     
     def get(self,st) :
             pass
             st=st.replace('%ts',str(self.getTotalSwap()))
             st=st.replace('%fs',str(self.getFreeSwap()))
             st=st.replace('%fp',str(self.getFreeP()))
             st=st.replace('%us',str(self.getUsedSwap()))
             st=st.replace('%up',str(self.getUsedP()))
             st=st.replace('%fb',str(self.getFreeNoBuffer()))
             st=st.replace('%ub',str(self.getUsedNoBuffer()))
             st=st.replace('%t',str(self.getTotal()))
             st=st.replace('%u',str(self.getUsed()))
             st=st.replace('%f',str(self.getFree()))
             return st
        
     def getTotal(self):
             pass
             return int((self.t)/1024.0+0.5)
     
     def getUsed(self):
             pass
             return int((self.t-self.f)/1024.0+0.5)
     
     def getUsedP(self):
             pass
             return int(100*(float(self.getUsed())/self.getTotal()))
     
     def getFree(self):
             pass
             return int((self.f)/1024.0+0.5)
        
     def getFreeP(self):
             pass
             return int(100*(float(self.getFree())/self.getTotal()))
        
     def getFreeNoBuffer(self):
             pass
             return int((self.f+self.b+self.c)/1024.0+0.5)
        
     def getUsedNoBuffer(self):
             pass
             return int(((self.t-self.f)-self.b-self.c)/1024.0+0.5)
        
     def getTotalSwap(self):
             pass
             return int((self.ts)/1024.0+0.5)
        
     def getUsedSwap(self):
             pass
             return int((self.ts-self.fs)/1024.0+0.5)
        
     def getFreeSwap(self):
             pass
             return int((self.fs)/1024.0+0.5)
############### Net Sensor  ###############
class NETSensor :
        
     def __init__(self,device='ppp0'):
             pass
             self.d=device
             self.i=[0,0]
             self.o=[0,0]
             self.update()
        
     def update(self):
             pass
             f=open('/proc/net/dev','r')
             buf=f.read()
             f.close()
             buf=buf.splitlines()
             for i in range(len(buf)):
                 st=re.match('\\W+'+self.d+':\\D*(\\d+)(?:\\D+\\d+){7}\\D+(\\d+)',buf[i])
                 if st!=None :
                     self.i[0]=self.i[1]
                     self.o[0]=self.o[1]
                     self.i[1]=long(st.group(1))
                     self.o[1]=long(st.group(2))
                     break
        
     def get(self,st) :
             pass
             st=st.replace('%in',str(int(self.getIn())))
             st=st.replace('%fs',str(int(self.getOut())))
             return st
        
     def getIn(self):
             pass
             return ((self.i[1]-self.i[0])/1024.0)
        
     def getOut(self):
             pass
             return ((self.o[1]-self.o[0])/1024.0)
############### Disk Sensor ###############
class DISKSensor :
        
     def __init__(self,disk='/'):
             pass
             self.d=disk
             self.update()
        
     def update(self):
             pass
             buf=str(os.statvfs(self.d))
             st=re.match('\((\\d+),\\s+(\\d+),\\s+(\\d+)L,\\s+(\\d+)L',buf)
             if st!=None:
                 bs=float(st.group(1))/1024
                 bt=long(st.group(3))
                 bf=long(st.group(4))
                 self.t=long(bs*bt)
                 self.f=long(bs*bf)
                 self.u=self.t-self.f
        
     def getTotal(self):
             return self.t/1024
        
     def getTotalGB(self):
             return float(self.getTotal())/1024
        
     def getUsed(self):
             return self.u/1024
        
     def getUsedGB(self):
             return float(self.getUsed())/1024
        
     def getUsedP(self):
             return float(self.getUsed())/self.getTotal()
        
     def getFree(self):
             return self.f/1024
        
     def getFreeGB(self):
             return float(self.getFree())/1024
        
     def getFreeP(self):
             return float(self.getFree())/self.getTotal()
############### Time Sensor ###############
class TIMESensor :
        
     def __init__(self):
             pass
             self.dayst=('Mon','Tue','Wed','Thu','Fri','Sat','Sun')
             self.monst=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')
             self.update()
        
     def update(self):
             pass
             self.tm=time.localtime(time.time())
        
     def get(self,st):
             pass
             st=st.replace('%h',self.getHour())
             st=st.replace('%m',self.getMin())
             st=st.replace('%s',self.getSec())
             st=st.replace('%d',self.getDay())
             st=st.replace('%D',self.getMDay())
             st=st.replace('%M',self.getMonth())
             st=st.replace('%y',self.getYear())
             return st
        
     def getHour(self):
             pass
             if self.tm.tm_hour < 10 :
                 return '0'+str(self.tm.tm_hour)
             else:
                 return str(self.tm.tm_hour)
        
     def getMin(self):
             pass
             if self.tm.tm_min < 10 :
                 return '0'+str(self.tm.tm_min)
             else:
                 return str(self.tm.tm_min)
        
     def getSec(self):
             pass
             if self.tm.tm_sec < 10 :
                 return '0'+str(self.tm.tm_sec)
             else:
                 return str(self.tm.tm_sec)
        
     def getDay(self):
             pass
             return self.dayst[self.tm.tm_wday]
        
     def getMonth(self):
             pass
             return self.monst[self.tm.tm_mon+1]
        
     def getMDay(self):
             pass
             return str(self.tm.tm_mday)
        
     def getYear(self):
             pass
             return str(self.tm.tm_year)
########### TASK Sensor #####################
class TASKSensor:
     
     def __init__(self,widget):
             pass
             f=os.popen('dcop kwin KWinInterface currentDesktop')
             self.d=int(f.read())-1
             f.close()
             self.t=None
             self.wd=widget
             self.update()
     
     def update(self):
             pass
             tl=karamba.getTaskList(self.wd)
             del self.t
             self.t=[[],[],[],[]]
             self.tf=[None,None,None,None]
             for d in range(len(self.t)):
                 for i in range(len(self.t[d])):
                     self.t[d].pop()
             for i in range(len(tl)):
                 ti=karamba.getTaskInfo(self.wd,tl[i])
                 self.t[ti[3]-1].append(ti)
                 if ti[7]==1 : self.tf[ti[3]-1]=i
        
     def updateTask(self,task):
             pass
             i=self.findTask(task)
             if i!=None:
                 self.t[i[0]][i[1]]=karamba.getTaskInfo(self.wd,task)
                 if self.t[i[0]][i[1]][7]==1 :
                     if self.tf[i[0]]!=None : self.t[i[0]][self.tf[i[0]]][7]=0
                     self.tf[i[0]]=i[1]
                 return [i[0],i[1]]
      
     def updateCurrentTasks(self):
             pass
             self.updateTasks(self.d)
        
     def updateTasks(self,desktop):
             pass
             self.tf[desktop]=None
             for i in range(self.getNumberOfTasks(desktop)):
                 self.t[desktop][i]=karamba.getTaskInfo(self.wd,self.t[desktop][i][8])
                 if self.t[desktop][i][7]==1 : self.tf[desktop]=i
        
     def setDesktop(self,d):
             pass
             self.d=d
             karamba.execute('dcop kwin KWinInterface setCurrentDesktop '+str(self.d+1))
        
     def getCurrentDesktop(self):
             pass
             return self.d
        
     def getCurrentNumberOfTasks(self,desktop):
             pass
             return len(self.t[self.d])
        
     def getNumberOfTasks(self,desktop):
             pass
             return len(self.t[desktop])
        
     def getTaskDesktop(self,task):
             pass
             ti=karamba.getTaskInfo(self.wd,task)
             return ti[3]-1
     
     def getTaskName(self,task):
             pass
             ti=karamba.getTaskInfo(self.wd,task)
             return ti[0]
        
     def findTask(self,task):
             pass
             for d in range(len(self.t)):
                 for i in range(len(self.t[d])):
                     if self.t[d][i][8]==task:
                         return [d,i]
        
     def isMinimazed(self,desktop,task):
             pass
             return self.t[desktop][task][5]
        
     def minimaze(self,desktop,task):
             pass
             if self.isMinimazed(desktop,task)==0:
                 karamba.performTaskAction(self.wd,self.t[desktop][task][8],3)
                 self.t[desktop][task][5]=1
                 self.t[desktop][task][7]=0
                 self.tf[desktop]=None
                 for i in range(len(self.t[desktop])):
                     if self.isMinimazed(desktop,i)==0:
                         self.tf[desktop]=i
                         self.t[desktop][i][7]=1
                         break
                 return True
             else :
                 return False
        
     def restore(self,desktop,task):
             pass
             if self.isMinimazed(desktop,task)==1:
                 karamba.performTaskAction(self.wd,self.t[desktop][task][8],2)
                 self.t[desktop][task][5]=0
                 self.t[desktop][task][7]=1
                 if self.tf[desktop]!=None : self.t[desktop][self.tf[desktop]][7]=0
                 self.tf[desktop]=task
                 return True
             else :
                 return False
        
     def minimazeRestore(self,desktop,task):
         pass
         if self.minimaze(desktop,task)==False:
             self.restore(desktop,task)
     
     def isMaximazed(self,desktop,task):
             pass
             return self.t[desktop][task][4]
        
     def maximaze(self,desktop,task):
             pass
             if  self.isMaximazed(desktop,task)==0:
                 karamba.performTaskAction(self.wd,self.t[desktop][task][8],1)
        
     def isFocused(self,desktop,task):
             pass
             return self.tf[desktop]==task
        
     def focus(self,desktop,task):
             if self.isFocused(desktop,task)==0:
                 karamba.performTaskAction(self.wd,self.t[desktop][task][8],5)
                 self.t[desktop][task][7]=1
                 if self.tf[desktop]!=None : self.t[desktop][self.tf[desktop]][7]=0
                 self.tf[desktop]=task
        
     def close(self,desktop,task):
             pass
             karamba.performTaskAction(self.wd,self.t[desktop][task][8],4)
             self.removeTask(self.t[desktop][task][8])
             self.updateTasks(desktop)
        
     def addTask(self,task):
             pass
             ti=karamba.getTaskInfo(self.wd,task)
             self.t[ti[3]-1].append(ti)
             self.updateTasks(ti[3]-1)
             return len(self.t[ti[3]-1])-1
        
     def removeTask(self,task):
             pass
             i=self.findTask(task)
             self.t[i[0]].pop(i[1])
             self.updateTasks(i[0])
             return i
########### XMMS Sensor #####################
class XMMSSensor :
        
     def __init__(self):
             pass
             self.update()
        
     def update(self):
             pass
             self.r=xmms.is_running()
             if self.r==1 :
                 self.p=xmms.is_paused()
                 self.i=xmms.get_playlist_pos()
                 self.t=xmms.get_playlist_title(self.i)
                 self.ct=xmms.get_output_time()/1000
                 self.tt=(xmms.get_playlist_time(self.i)/1000)
                 self.v=xmms.get_main_volume()
        
     def get(self,st):
             pass
             st=st.replace('%m',self.getMin())
             st=st.replace('%s',self.getSec())
             st=st.replace('%ts',self.getTSec())
             st=st.replace('%tm',self.getTMin())
             st=st.replace('%t',self.getTitle())
             return st
        
     def getMin(self):
             pass
             m=self.ct/60
             if m<10 :
                 m='0'+str(m)
             else :
                 m=str(m)
             return m
        
     def getSec(self):
             pass
             s=self.ct-(self.ct/60)*60
             if s<10 :
                 s='0'+str(s)
             else :
                 s=str(s)
             return s
        
     def getTMin(self):
             pass
             m=self.tt/60
             if m<10 :
                 m='0'+str(m)
             else :
                 m=str(m)
             return m
        
     def getTSec(self):
             pass
             s=self.tt-(self.tt/60)*60
             if s<10 :
                 s='0'+str(s)
             else :
                 s=str(s)
             return s
        
     def getTitle(self):
             pass
             return self.t
        
     def setTime(self,p):
             pass
             self.ct=int(p*self.tt)
             xmms.jump_to_time(self.ct*1000)
        
     def getTime(self):
             pass
             return float(self.ct)/self.tt
        
     def setVolume(self,p):
             pass
             self.v=int(p*100.0)
             xmms.set_main_volume(self.v)
        
     def getVolume(self):
             pass
             return float(self.v)/100
        
     def next(self):
             pass
             if self.i==xmms.get_playlist_length()-1 :
                 xmms.set_playlist_pos(0)
             else :
                 xmms.playlist_next()
        
     def play(self):
             pass
             xmms.play_pause()
        
     def prev(self):
             pass
             if self.i==0 :
                 xmms.set_playlist_pos(xmms.get_playlist_length()-1)
             else :
                 xmms.playlist_prev()
        
     def isRunning(self):
             pass
             return self.r
##########################################################

def setKicker(show):
    pass
    if show :  os.system('dcop kicker qt/Panel show')
    else      :  os.system('dcop kicker qt/Panel hide')
