#***************************************************************************
#                             SuperGlass
#                            -------------------
#   begin                : Sat Jan 4 2004
#   copyright            : (C) 2004 by Dmitry "Troydm" Geurkov
#   email                : dmitry_627@mail.ru
#***************************************************************************

#***************************************************************************
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#***************************************************************************
from Super import *

#############    Time Bar       #######################
class TIMEBar( Image ):
        
     def __init__(self,widget,x,y,w,h,t,d):
             pass
             Image.__init__(self,widget,x,y,w,h,'pic/time.png')
             self.tt=t
             self.dt=d
             self.t=Text(widget,self.x+50,self.y+8,self.w,self.h,'',25,0,0,0)
             self.d=Text(widget,self.x+50,self.y+32,self.w,self.h,'',15,0,0,0)
             self.ts=TIMESensor()
        
     def create(self):
             pass
             Image.create(self)
             self.d.create()
             self.t.create()
      
     def update(self):
             pass
             self.ts.update()
             self.t.change(self.ts.get(self.tt))
             self.d.change(self.ts.get(self.dt))
########## XMMS Bar ##############
class XMMSBar( Image ):
        
     def __init__(self,widget,x,y,w,h):
             pass
             Image.__init__(self,widget,x,y,w,h,'pic/xmms.png')
             self.xt=Text(widget,self.x+30,self.y+15,self.w-130,self.h,'',15,0,0,0)
             self.xp=HorBar(widget,self.x+30,self.y+35,200,self.h,'pic/xmmsbar.png',100)
             self.xb=[Image(widget,self.x+250,self.y+15,25,25,'pic/xmmsbutton.png')
                     ,Image(widget,self.x+275,self.y+15,25,25,'pic/xmmsbutton.png')
                     ,Image(widget,self.x+300,self.y+15,25,25,'pic/xmmsbutton.png')]
             self.xbs=[Image(widget,self.x+250,self.y+15,25,25,'pic/xmmsprevious.png')
                      ,Image(widget,self.x+275,self.y+15,25,25,'pic/xmmsplay.png')
                      ,Image(widget,self.x+275,self.y+15,25,25,'pic/xmmspause.png')
                      ,Image(widget,self.x+300,self.y+15,25,25,'pic/xmmsnext.png')]
             self.xv=Image(widget,self.x+256,self.y+40,5,10,'pic/xmmsvolume.png')
             self.xvb=Image(widget,self.x+256,self.y+40,60,10,'pic/xmmsvolumebar.png')
             self.xs=XMMSSensor()
        
     def create(self):
             pass
             Image.create(self)
             self.xt.create()
             self.xp.create()
             self.xb[0].create()
             self.xb[1].create()
             self.xb[2].create()
             self.xbs[0].create()
             self.xbs[1].create()
             self.xbs[2].create()
             self.xbs[3].create()
             self.xv.create()
             self.xvb.create()
             self.hide()
             self.update()
        
     def update(self):
             pass
             self.xs.update()
             if self.xs.isRunning() :
                 self.show()
                 self.xp.setBar(self.xs.getTime())
                 self.xt.change(self.xs.get('%t'))
                 self.xv.move(int(self.xvb.x+self.xs.getVolume()*(self.xvb.w-self.xv.w)),self.xvb.y)
                 if self.xs.p == 1:
                     self.xbs[2].hide()
                     self.xbs[1].show()
                 else :
                     self.xbs[1].hide()
                     self.xbs[2].show()
             else :
                 self.hide()
        
     def hide(self):
             pass
             self.xp.hide()
             self.xt.hide()
             self.xb[0].hide()
             self.xb[1].hide()
             self.xb[2].hide()
             self.xbs[0].hide()
             self.xbs[1].hide()
             self.xbs[2].hide()
             self.xbs[3].hide()
             self.xv.hide()
             self.xvb.hide()
        
     def show(self):
             pass
             self.xt.show()
             self.xp.show()
             self.xb[0].show()
             self.xb[1].show()
             self.xb[2].show()
             self.xbs[0].show()
             self.xbs[3].show()
             self.xv.show()
             self.xvb.show()
        
     def click(self,x,y):
             pass
             if self.clicked(x,y)==1:
                 if self.xs.isRunning()==0:
                     karamba.execute('xmms -p')
                 else:
                     if self.xp.clicked(x,y):
                         self.xs.setTime(self.xp.onclick(x,y))
                     if self.xvb.clicked(x,y):
                         self.xs.setVolume(float(x-self.xvb.x)/(self.xvb.w-self.xv.w))
                     if self.xb[0].clicked(x,y):
                         self.xs.prev()
                     if self.xb[1].clicked(x,y):
                         self.xs.play()
                     if self.xb[2].clicked(x,y):
                         self.xs.next()
########## Stat Bar ####################
class STATBar( Image ):
        
     def __init__(self,widget,x,y,w,h,netdev):
             pass
             Image.__init__(self,widget,x,y,w,h,'pic/stat.png')
             self.c=Text(widget,self.x+40,self.y+20,50,40,'',15,0,0,0)
             self.m=Text(widget,self.x+90,self.y+20,50,40,'',15,0,0,0)
             self.n=Text(widget,self.x+140,self.y+20,50,40,'',15,0,0,0)
             self.cs=CPUSensor()
             self.ms=MEMSensor()
             self.ns=NETSensor(netdev)
        
     def create(self):
             pass
             Image.create(self)
             self.c.create()
             self.m.create()
             self.n.create()
        
     def update(self):
             pass
             self.cs.update()
             self.ms.update()
             self.ns.update()
             self.c.change(self.cs.get('%t%'))
             self.m.change(self.ms.get('%up%'))
             self.n.change(self.ns.get('%in kb'))
############ Disk Bar #####################
class DISKBar( Image ):
        
     def __init__(self,widget,x,y,w,h,d1,d2,d3,d4):
             pass
             self.dp=[d1,d2,d3,d4]
             Image.__init__(self,widget,x,y,w,h,'pic/disk.png')
             self.d=[0,0,0,0]
             self.d[0]=VerBar(widget,self.x+41,self.y+20,40,20,'pic/diskbar.png',10)
             self.d[1]=VerBar(widget,self.x+91,self.y+20,40,20,'pic/diskbar.png',10)
             self.d[2]=VerBar(widget,self.x+138,self.y+20,40,20,'pic/diskbar.png',10)
             self.d[3]=VerBar(widget,self.x+184,self.y+20,40,20,'pic/diskbar.png',10)
             self.ds=[DISKSensor(self.dp[0]),DISKSensor(self.dp[1]),DISKSensor(self.dp[2]),DISKSensor(self.dp[3])]
        
     def create(self):
             pass
             Image.create(self)
             self.d[0].create()
             self.d[1].create()
             self.d[2].create()
             self.d[3].create()
        
     def update(self):
             pass
             self.ds[0].update()
             self.ds[1].update()
             self.ds[2].update()
             self.ds[3].update()
             self.d[0].setBar(self.ds[0].getUsedP())
             self.d[1].setBar(self.ds[1].getUsedP())
             self.d[2].setBar(self.ds[2].getUsedP())
             self.d[3].setBar(self.ds[3].getUsedP())
        
     def click(self,x,y):
             pass
             if self.clicked(x,y):
                 if self.d[0].clicked(x,y)==1:
                     karamba.execute('konqueror '+str(self.dp[0]))
                 if self.d[1].clicked(x,y)==1:
                     karamba.execute('konqueror '+str(self.dp[1]))
                 if self.d[2].clicked(x,y)==1:
                     karamba.execute('konqueror '+str(self.dp[2]))
                 if self.d[3].clicked(x,y)==1:
                     karamba.execute('konqueror '+str(self.dp[3]))
########################################################################
timebar=0
xmmsbar=0
statbar=0
diskbar=0

#this is called when your widget is initialized
def initWidget(widget):
    pass
    global timebar,xmmsbar,statbar,diskbar
    timebar=TIMEBar(widget,0,0,200,65,'%h:%m:%s','%M %D %d %y')
    xmmsbar=XMMSBar(widget,200,0,350,65)
    statbar=STATBar(widget,550,0,200,65,'ppp0')
    diskbar=DISKBar(widget,750,0,250,65,'/','/home','/windows/C','/windows/D')
    timebar.create()
    xmmsbar.create()
    statbar.create()
    diskbar.create()




#This is called when your widget is closed.  You can use this to clean
#up open files, etc.  You don't need to delete text and images in your
#theme.  That is done automatically.  This callback is just for cleaning up
#external things.  Most people don't need to put anything here.
def widgetClosed(widget):
    pass

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    pass
    global timebar,xmmsbar,statbar,diskbar
    timebar.update()
    xmmsbar.update()
    statbar.update()
    diskbar.update()

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass
    global xmmsbar,diskbar
    xmmsbar.click(x,y)
    diskbar.click(x,y)

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    pass

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    pass

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    pass

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
    pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.  
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.  
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).  
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass

# This will be printed when the widget loads.
print "Superkaramba GlassBar loaded"

