################################################################################
#    ___   __  __    ___      __     _____     ____     __    ____
#   /'___\/\ \/\ \ /' _ `\  /'__`\  /\ '__`\  /',__\  /'__`\ /',__\
#  /\ \__/\ \ \_\ \/\ \/\ \/\ \L\.\_\ \ \L\ \/\__, `\/\  __//\__, `\
#  \ \____\\/`____ \ \_\ \_\ \__/.\_\\ \ ,__/\/\____/\ \____\/\____/
#   \/____/ `/___/> \/_/\/_/\/__/\/_/ \ \ \/  \/___/  \/____/\/___/
#              /\___/                  \ \_\
#              \/__/                    \/_/
################################################################################
#
# cynapses monitor by Andreas schneider <mail@cynapses.org>
# edited to show some news by Auke Bruinsma <aukebruinsma@gmx.net>
# Added patch to show the title. (By jerryarns <jerome.arnaud5 at wanadoo.fr>)
# Added some threating code from the Liquid Weather ++ theme. 
#     you can find this theme at: http://www.kde-look.org/content/show.php?content=6384)
# 		
# License: GPL
#
################################################################################

import os
import karamba
import thread
import re
from time import time
import string
from urllib import urlopen, quote_plus
from os.path import expanduser
import copy
from threading import *

#The newssource item in the list (url.conf).
#adjust this number to view a different news
#source.
s = 4

debug = 0
seconds = 1

textfont='nimbus sans l'
textsize=10
textcolor='000000'

#bAlreadyGettingData = 0
bUseThreads = 1
bLoading = 1
rssTimeout = 10
browser = "konqueror"
#The update time in seconds
interval = 600
lineheight = 14
linechars = 37
maxlines = 7

url = []
label = []
last_get = time() - interval
text_x = 15
text_y = 65
text_list = []
text_list_content = []
link_list = []
main_text = ""
main_text_content = ""
main_link = ""
rss_title = None

#elock = thread.allocate_lock()

# This is the threading engine.

class Future:

    def __init__(self,func,*param):
        # Constructor
        self.__done=0
        self.__result=None
        self.__status='working'
        self.__excpt=None
        self.__C=Condition()   # Notify on this Condition when result is ready
        # Run the actual function in a separate thread
        self.__T=Thread(target=self.Wrapper,args=(func,param))
        self.__T.setName("FutureThread")
        self.__T.start()

    def __repr__(self):
        return '<Future at '+hex(id(self))+':'+self.__status+'>'

    def isDone(self):
        return self.__done    # Notify if the function is complete

    def __call__(self):
        self.__C.acquire()
        while self.__done==0:
            self.__C.wait()
        self.__C.release()
        # An exception was thrown in the thread, re-raise it here.
        if self.__excpt: raise self.__excpt
        # We deepcopy __result to prevent accidental tampering with it.
        a=copy.deepcopy(self.__result)
        return a

    def Wrapper(self, func, param):
        # Run the actual function, and let us housekeep around it
        self.__C.acquire()
        try:
            self.__result=func(*param)
        except Exception, e: # We got an exception object, save it.
            self.__excpt = e
        except:
            self.__result="Exception raised within Future"
        self.__done=1
        self.__status=`self.__result`
        self.__C.notify()
        self.__C.release()

        
#
# This is called when the widget is initialized
# Lets get all you you need only on start
#
def initWidget(widget):

    global themepath
    global chunks
    global textfont, textsize, textcolor
    global rssTimeout
    global s
    global bUseThreads
    global rss_title
    lines = []


   
    chunks = 0
    ## get theme path
    themepath = karamba.getThemePath( widget )
    if debug == 1: print themepath

    karamba.addMenuConfigOption(widget, "textfont", "Change text font")
    karamba.addMenuConfigOption(widget, "textsize", "Change text size")
    karamba.addMenuConfigOption(widget, "textcolor", "Change text color")
    karamba.addMenuConfigOption(widget, "newRssItem", "Add a rss source")
    karamba.addMenuConfigOption(widget, "delRssItem", "Delete a rss source")
    karamba.addMenuConfigOption(widget, "selRssItem", "Select a rss source")
    karamba.addMenuConfigOption(widget, "selRssTimeout", "Select the timeout for resolving the rss feeds")
    karamba.addMenuConfigOption(widget, "newStartRss", "Select the next rss source when starting") 
    karamba.addMenuConfigOption(widget, "useThreads", "Use threads. This prevents the control from being not responding, while loading items") 
        
    karamba.setMenuConfigOption(widget, "newRssItem", "0")
    karamba.setMenuConfigOption(widget, "delRssItem", "0")
    karamba.setMenuConfigOption(widget, "selRssItem", "0")
    karamba.setMenuConfigOption(widget, "selRssTimeout", "0")
    
    bUseThreads = karamba.readMenuConfigOption(widget, "useThreads");
    if (karamba.readMenuConfigOption(widget, "newStartRss") == 1):
      try:
        indexFile = open(themepath + 'index.conf', 'r')
        savedS = indexFile.readline ()
        indexFile.close ()
      except IOError:
        savedS = None
    else:
      savedS = None

    rssTimeout = karamba.readConfigEntry (widget, "selRssTimeout")
    if (rssTimeout == None): rssTimeout = 10
        
    
    #savedS = #karamba.readConfigEntry(widget, "rssItem")
    if (savedS == None): s = 0
    else: s = int (savedS)
    
    textfont_test = karamba.readConfigEntry(widget, "textfont")
    if( textfont_test != None ): textfont = textfont_test

    textsize_test = karamba.readConfigEntry(widget, "textsize")
    if( textsize_test != None ):
      textsize = textsize_test
      print textsize

    textcolor_test = karamba.readConfigEntry(widget, "textcolor")
    if( textcolor_test != None ): textcolor = textcolor_test


    conffile = open (themepath + '/url.conf', 'r')
    while 1:
        line = conffile.readline()
        if not line:
            break
        elif line.startswith('\n'):
            continue
        elif line.startswith('#'):
            continue
        else:
            lines.append(line.strip('\n'))
            chunks = chunks + 1

    chunks = chunks/2

    
    n = 0
    for i in range(0, chunks):
        label.append(lines[n])
        n = n + 2
    n = 1
    for i in range(0, chunks):
        url.append(lines[n])
        n = n + 2
    
    ypos = text_y
    for x in range(maxlines):
        news_main = karamba.createText(widget, text_x, ypos, 350, lineheight, '  ')
        karamba.changeTextColor( widget, news_main, *hexToRGB( textcolor ))
        karamba.changeTextSize( widget, news_main, textsize )
        karamba.changeTextFont( widget, news_main, textfont )
        text_list.append(news_main)

        text_list_content.append("")
        link_list.append("")

        ypos = ypos + lineheight
    
    pass
    
    rss_title = karamba.createText(widget, 75, 20, 250, 50, label[s])
    karamba.changeTextColor( widget, rss_title, *hexToRGB( textcolor ))
    karamba.changeTextSize( widget, rss_title, 16)
    karamba.changeTextFont( widget, rss_title, 'neuropol')
    
    indexFile = open (themepath + 'index.conf', 'w')
    if (s == maxlines): s = -1;
    s = s + 1
    widgetUpdated (widget)
    indexFile.write (str (s))
    indexFile.close ()
             


###############################################################################
#
# this is called everytime your widget is updated
# the update inverval is specified in the .theme file
#
###############################################################################
def widgetUpdated( widget ):

    global bLoading
    global last_get
    global main_text
    global main_text_content
    global text_list
    global text_list_content
    global maxlines
    global linechars
    global interval
    
    diff = interval + last_get
           
    iItemCount = -1
    if( diff < time()): 
        last_get = time()
        content = HTTPgetFile(url)
        parseFile(content)
        print "update: " + str(diff) + " > " + str(time())
        print "maxlines: " + str(maxlines)
        #karamba.changeText (widget, main_text, main_text_content)

        iItemCount = 0
        for i in range(maxlines):
            if( len(text_list_content[i]) >= linechars ):
                text_list_content[i] = text_list_content[i][:linechars -3] + "..."
            if (len(text_list_content[i]) > 0):
                iItemCount = iItemCount + 1
            karamba.changeText(widget, text_list[i], text_list_content[i])
        
    if (iItemCount == 0 or bLoading != 0):
         iSpaces = linechars - 10
         iSpaces = iSpaces / 2
         sNoItems = ""
         if (bLoading != 0):
              for i in range(maxlines):
                    karamba.changeText(widget, text_list[i], "")
              sNoItems = "<loading...>"
              print "Show loading"
         else:
             sNoItems = "<no items>"
         for i in range (iSpaces):
             sNoItems = " " + sNoItems + " "
         karamba.changeText(widget, text_list[2], sNoItems)
    
    pass

#################################################
## hexToRGB by matthew_kay@ml1.net (Slickerbar)
## converts a 6-character hex representation of a colour to its RGB values and returns a tuple
## containing the RGB values (R, G, B), or None if the colour string is invalid
def hexToRGB( hexColour ):
    try:
      if len( hexColour ) == 6:
        try:
          ## this might be valid.... at least, its the right number of chars :)
          return ( eval( "0x" + hexColour[ 0:2 ]), eval( "0x" + hexColour[ 2:4 ] ), eval( "0x" + hexColour[4:] ) )
        except:
          ## error parsing the hex values... not a valid colour string
          return None
      else:
        ## this is not a valid colour string
        return None
    except:
      return ( 0, 0, 0 )


#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):

    global main_link
    global link_list
    global text_y
    global browser
    global lineheight
    global ypos   
    
    command_string = browser + " "
    if(x > 35) and (x < 370) and ( y < text_y ) and ( y < 40 ):
        command_string = command_string + main_link  + " &"
        os.system(command_string)
    elif (x > 75) and (x < 95) and (y > 40) and (y < 60):
        changeRssSource (widget, (s - 1))
    elif (x > 105) and (x < 125) and (y > 40) and (y < 60):
        changeRssSource (widget, (s + 1))
    elif(x > 35) and (x < 370)  and ( y > text_y ) and ( y < 210 ):
        ypos = y - text_y
        ypos = ypos / lineheight
        command_string = command_string + link_list[ypos] + " &"
        os.system(command_string)
    
    pass

def parseFile(content):
    global main_text_content
    global text_list_content
    global link_list
    global main_link
    global maxlines
    global bLoading
    
    i = -1
    is_channel_info = 0
    is_channel_item = 0
    content = content.splitlines()
    
    for line in content:
        if( i >= maxlines ):
            break

        if( line.find("<channel") != -1 ):
            is_channel_info = 1
        elif( line.find("</channel>") != -1 ):
            is_channel_info = 0
        if( line.find("<items") != -1 ):
            continue
        if( line.find("<item") != -1 ):
            is_channel_info = 0
            i = i + 1
        elif( line.find("<title>") != -1 ):
            x = re.split('<|>',line)
            if( is_channel_info == 1 ):
                main_text_content = x[2]
            else:
                text_list_content[i] = x[2]
        elif( line.find("<link>") != -1 ):
            x = re.split('<|>',line)
            if( is_channel_info == 1 ):
                main_link = x[2]
            else:
                link_list[i] = x[2]
    i = i + 1
    while( i < len(text_list_content) ):
        text_list_content[i] = ""
        link_list[i] = ""
        i = i + 1

    pass

def HTTPgetFile (url):
    global bAlreadyGettingData
    global bLoading
    global rssTimeout
    print url[s]
    print "timeout: " + str (rssTimeout)
    #bAlreadyGettingData = s
    command_string = "wget --timeout=" + str (rssTimeout) + " -O - -- " + url[s]
    temp = os.popen(command_string)
    content = temp.read()
    temp.close()
    #bAlreadyGettingData = 0
    
    bLoading = 0
    return content
    
    pass

def CreateSelRssCmd (title, description, countLines):

   cmdResult = ["kdialog", "--title", title, "--radiolist", description]
   items = 0
   show = 1
   counter = -1

   try:
     conffile = open(themepath + '/url.conf', 'r')
   except IOError:
     return None;

   while 1:
     if (countLines == 1): counter = counter + 1
     line = conffile.readline()
     if not line:
       break
     elif line.startswith('\n'):
       continue
     elif line.startswith('#'):
       continue
     else:
       #with this show system, only the titles are shown;
       if show:
          if (countLines == 1): cmdResult.append(str(counter))
          else: cmdResult.append(str(items))
          cmdResult.append(line.strip('\n'))
          cmdResult.append("0")
          items = items + 1
          show = 0
       else:
          show = not show

   conffile.close ()

   return cmdResult

   pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    global pidNewRssTitle, pidNewRssSource, pidNewRssIndex, pidDelRssSource, pidSelRssTimeout
    global bUseThreads

    pidNewRssIndex = None   
    pidNewRssTitle = None
    pidNewRssSource = None
    pidDelRssSource = None
    pidSelRssTimeout = None
    
    print "Config Clicked"
    

    if (key == "newRssItem"):
        cmdAddSourceTitle = ["kdialog", "--title", "Add a newssource [title]", "--inputbox", "Please enter the tile for the source :"]
        karamba.setMenuConfigOption (widget, "newRssItem", "0")
        pidNewRssTitle = karamba.executeInteractive(widget, cmdAddSourceTitle)

    elif (key == "selRssItem"):
        
        cmdSelectNewsIndex = CreateSelRssCmd ("Select an item", "Choose the title of the news item you wish to see :", 0)
        karamba.setMenuConfigOption(widget, "selRssItem", "0")
        if (cmdSelectNewsIndex == None): return
        pidNewRssIndex = karamba.executeInteractive(widget, cmdSelectNewsIndex)
            
    elif (key == "delRssItem"):
        
        cmdDelRssSource = CreateSelRssCmd ("Select an item", "Choose the news item you wish to delete :", 1)
        karamba.setMenuConfigOption(widget, "delRssItem", "0")
        if (cmdDelRssSource == None): return
        pidDelRssSource= karamba.executeInteractive(widget, cmdDelRssSource)

    elif (key == "selRssTimeout"):
        cmdSelRssTimeout = ["kdialog", "--title", "Select a timeout", "--inputbox", "Please enter the timeout for retrieving sources :"]
        karamba.setMenuConfigOption (widget, "selRssTimeout", "0")
        pidSelRssTimeout = karamba.executeInteractive(widget, cmdSelRssTimeout)
    
    elif (key == "useThreads"):
        bUseThreads = karamba.readMenuConfigOption(widget, "useThreads");
        print "UseThreads: " + str (bUseThreads)
        #karamba.writeConfigEntry (widget, "useThreads", bUseThreads);
        
    pass

def changeRssSource (widget, n):
    global s
    global last_get
    global rss_title
    global bLoading
    global bUSeThreads
    global chunks;
    
    if (n == None):
        return;
    
    bLoading = 1;
    widgetUpdated (widget)
    print "newIndex " + str (n) + "\n"
    karamba.writeConfigEntry (widget, "rssItem", str (n))
    s = n;
    if (s < 0): s = chunks - 1
    if (s >= chunks): s = 0

    last_get = 0
    karamba.changeText (widget, rss_title, label[s])
    if (bUseThreads):
        Future (widgetUpdated,widget)
    else:
        widgetUpdated (widget)
    
    pass

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    global pidNewRssTitle, pidNewRssSource, pidNewRssIndex, pidDelRssSource, s, last_get, rss_title, rssTimeout

    newIndex = 0
    
    if pid == pidNewRssTitle:
        if not output.replace('\n',''):
                print "Canceld"
        else:
                conffile = open(themepath + '/url.conf', 'a')
                conffile.write (output)
                conffile.close ()
                cmdAddSourceUrl = ["kdialog", "--title", "Add a newssource [url]", "--inputbox", "Please enter the url of the rss file :"]
                pidNewRssSource = karamba.executeInteractive(widget, cmdAddSourceUrl)
        
        #configchange = 0
        #widgetUpdated(widget)

    elif pid == pidNewRssSource:
        if not output.replace('\n',''):
          print "Canceld"
          try:
            conffile = open(themepath + '/url.conf', 'r')
          except IOError:
            return None;

          lstItems = conffile.readlines ()
          del lstItems [len (lstItems) -1]
          conffile.close ()
        
          try:
            conffile = open(themepath + '/url.conf', 'w')
          except IOError:
            return None;

          conffile.writelines (lstItems)
        else:
          conffile = open(themepath + '/url.conf', 'a')
          conffile.write (output)
          conffile.close ()

    elif pid == pidSelRssTimeout:
        newTimeout = output.replace ('\n', '')
        if not newTimeout:
            print "Canceld"
        else:
            print "new timeout: " + newTimeout + "\n"
            rssTimeout = int (newTimeout)
            karamba.writeConfigEntry (widget, "selRssTimeout", newTimeout);
            
    elif pid == pidNewRssIndex:
        newIndex = output.replace('\n','')
        if not newIndex:
            print "Canceld"
        else:
            changeRssSource (widget, int (n))
            #print "newIndex " + newIndex + "\n"
            #karamba.writeConfigEntry(widget, "rssItem", newIndex)
            #s = int (newIndex)
            #last_get = 0
            #widgetUpdated(widget)
            #karamba.changeText(widget, rss_title, label[s])
        
    elif pid == pidDelRssSource:
        strDelIndex = output.replace('\n','')
        if not strDelIndex:
            print "Canceld"
        else:
          delIndex = int (strDelIndex)
          try:
            conffile = open(themepath + '/url.conf', 'r')
          except IOError:
            return None;

          lstItems = conffile.readlines ();
          del lstItems [delIndex]
          del lstItems [delIndex]
          conffile.close ()
        
          try:
            conffile = open(themepath + '/url.conf', 'w')
          except IOError:
            return None;

          conffile.writelines (lstItems)

          if (s > len (lstItems) - 1): s = s - 1
          if (s < 0): s = 0

          last_get = 0
          widgetUpdated(widget)
          karamba.changeText(widget, rss_title, label[s])
    
# improvements for the own ego ;)
print "cynapses news monitor loaded, praise Andreas & ramone@oxibiose.dyndns.org ;-)"

