############################################################################
#    Copyright (C) 2004 by Bobby Z.                                        #
#    ziuchkov@uiuc.edu                                                     #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import player
import dcop
from dcophelper import *

class Amarok(player.Player):
   def __init__(self):
      # The following two commands will attach the python script as a dcop client
      self.dcopclient = dcop.DCOPClient()
      attach(self.dcopclient, "AmarokCmd", "amarok", "player")
      self.chkPosition()
      self.chkLength()
      self.chkSong()
   def chkPosition(self):
      dcopresult = dcopCall(self.dcopclient, "trackCurrentTime()")
      # The following translates the dcop result into the correct int value.
      # The reason for this is because the result is incorrectly interpretted
      # as a list of ascii values as opposed to an int.
      self.position = toInt(dcopresult)
   def chkLength(self):
      dcopresult = dcopCall(self.dcopclient, "trackTotalTime()")
      self.length = toInt(dcopresult)
   def chkSong(self):
      dcopresult = dcopCall(self.dcopclient, "nowPlaying()")
      self.song = toString(dcopresult)
   def seekPrev(self):
      dcopCall(self.dcopclient, "prev()")
   def seekNext(self):
      dcopCall(self.dcopclient, "next()")
   def seekPrevOffset(self, offset):
      seek = self.position - offset
      if seek <= 0:
         seek = 0
      dcopvalue = toChars(seek)
      dcopValCall(self.dcopclient, "amarok", "player", "seek(int)", dcopvalue)
   def seekNextOffset(self, offset):
      seek = self.position + offset
      if seek >= self.length:
         seek = self.length
      dcopvalue = toChars(seek)
      dcopValCall(self.dcopclient, "amarok", "player", "seek(int)", dcopvalue)
   def seekTime(self, seektime):
      dcopvalue = toChars(seektime)
      dcopValCall(self.dcopclient, "amarok", "player", "seek(int)", dcopvalue)
   def cmdPause(self):
      dcopCall(self.dcopclient, "pause()")
   def cmdStop(self):
      dcopCall(self.dcopclient, "stop()")
   def cmdPlay(self):
      dcopCall(self.dcopclient, "play()")
