############################################################################
#    Copyright (C) 2004 by Bobby Z.                                        #
#    ziuchkov@uiuc.edu                                                     #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import dcop

def attach(dcopobj, appname, *dcopargs):
   dcopobj.attach()
   dcopobj.registerAs(appname)
   if dcopobj.isAttached():
      dcopobj.rc = dcop.DCOPRef(*dcopargs)
   else:
      print "Couldn't attach!"
      sys.exit(1)

def dcopCall(dcopobj, funcstring):
   result = dcopobj.rc.call(funcstring)
   if result.isValid():
      return result.data.data()
   else:
      return "Couldn't call"

def dcopValCall(dcopobj, dcopprog, interface, function, value):
   dcopobj.call (dcopprog, interface, function, value, "x", "x")

def toInt(dcopresult):
   # This helper function converts the 4-byte dcop char array into an int value
   intval = ord(dcopresult[-4]) *256*256*256 + ord(dcopresult[-3]) *256*256 + \
            ord(dcopresult[-2]) *256 + ord(dcopresult[-1])
   if intval == 4294967295: # This is the equivalent of -1 coming from dcopresult
      intval = -1
   elif intval == 1667329132: # Also equivalent to -1 ?
      intval = -1
   return intval

def toChars(intval):
   # This helper function converts an int value into the 4-byte dcop char array
   char1, rem1 = divmod(intval, 256*256*256)
   char2, rem2 = divmod(rem1, 256*256)
   char3, char4 = divmod(rem2, 256)
   charstring = chr(char1) + chr(char2) + chr(char3) + chr(char4)
   return charstring

def toString(dcopresult):
   # QString dcop return results are ugly.  This converts into a nice string
   strval = str(dcopresult)[4:]
   strval = strval[1::2]
   # It would probably be good programming to put this in each of the Player classes as
   # opposed to here, for reuseability's sake, but I have a feeling people who write their
   # own Player classes will get confused when they see 'ntcl' as their song playing.
   if strval == 'ntcl':
      strval = 'No Song Playing - No Song Playing'
   return strval
