############################################################################
#    Copyright (C) 2004 by Bobby Z.                                        #
#    ziuchkov@uiuc.edu                                                     #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import player
import dcop
from dcophelper import *

class Kaffeine(player.Player):
   def __init__(self):
      # The following two commands will attach the python script as a dcop client
      self.dcopkafclient = dcop.DCOPClient()
      attach(self.dcopkafclient, "KaffeineKafCmd", "kaffeine", "Kaffeine")
      self.dcopplayclient = dcop.DCOPClient()
      attach(self.dcopplayclient, "KaffeinePlyrCmd", "kaffeine", "PlaybackControl")
      self.chkPosition()
      self.chkLength()
      self.chkSong()
   def chkPosition(self):
      dcopresult = dcopCall(self.dcopplayclient, "getTimeStr()")
      # The following translates the dcop result into the correct int value.
      # The reason for this is because the result is incorrectly interpretted
      # as a list of ascii values as opposed to an int.
      if dcopresult != "Couldn't call":
         timestring = toString(dcopresult)
         self.position = int(str(timestring[2:4])) *60 + int(str(timestring[5:]))
      else:
         self.position = 0
   def chkLength(self):
      # There appears to be no way of getting the length of a song through dcop for kaffeine
      self.length = self.position + 1
   def chkSong(self):
      dcopresult = dcopCall(self.dcopkafclient, "getTitle()")
      self.song = toString(dcopresult)
   def seekPrev(self):
      dcopCall(self.dcopkafclient, "previous()")
   def seekNext(self):
      dcopCall(self.dcopkafclient, "next()")
   def seekPrevOffset(self, offset):
      dcopCall(self.dcopplayclient, "posMinus()")
   def seekNextOffset(self, offset):
      dcopCall(self.dcopplayclient, "posPlus()")
   def seekTime(self, seektime):
      # There's no way for us to seek to a specific time without knowing the song length =/
      pass
   def cmdPause(self):
      dcopCall(self.dcopkafclient, "togglePlayPause()")
   def cmdStop(self):
      dcopCall(self.dcopkafclient, "stop()")
   def cmdPlay(self):
      dcopCall(self.dcopkafclient, "play()")
