############################################################################
#    Copyright (C) 2004 by Bobby Z.                                        #
#    ziuchkov@uiuc.edu                                                     #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import player
import dcop
from dcophelper import *

class Kscd(player.Player):
   def __init__(self):
      # The following two commands will attach the python script as a dcop client
      self.dcopclient = dcop.DCOPClient()
      attach(self.dcopclient, "KscdCmd", "kscd", "CDPlayer")
      self.chkPosition()
      self.chkLength()
      self.chkSong()
   def chkPosition(self):
      dcopresult = dcopCall(self.dcopclient, "currentTrack()")
      self.position = toInt(dcopresult)
   def chkLength(self):
      dcopresult = dcopCall(self.dcopclient, "currentTrack()")
      self.length = toInt(dcopresult)
   def chkSong(self):
      dcopresult = dcopCall(self.dcopclient, "currentTrackTitle()")
      self.song = toString(dcopresult)
   def seekPrev(self):
      dcopCall(self.dcopclient, "previous()")
   def seekNext(self):
      dcopCall(self.dcopclient, "next()")
   def seekPrevOffset(self, offset):
      dcopCall(self.dcopclient, "backward()")
   def seekNextOffset(self, offset):
      dcopCall(self.dcopclient, "forward()")
   def seekTime(self, seektime):
      pass
   def cmdPause(self):
      dcopCall(self.dcopclient, "play()")
   def cmdStop(self):
      dcopCall(self.dcopclient, "stop()")
   def cmdPlay(self):
      dcopCall(self.dcopclient, "play()")
