############################################################################
#    Copyright (C) 2004 by Bobby Z.                                        #
#    ziuchkov@uiuc.edu                                                     #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import player
import dcop
from dcophelper import *

class Noatun(player.Player):
   def __init__(self):
      self.dcopclient = dcop.DCOPClient()
      attach(self.dcopclient, "NoatunCmd", "noatun", "Noatun")
      self.chkPosition()
      self.chkLength()
      self.chkSong()
   def chkPosition(self):
      dcopresult = dcopCall(self.dcopclient, "position()")
      # The following translates the dcop result into the correct int value.
      # The reason for this is because the result is incorrectly interpretted
      # as a list of ascii values as opposed to an int.
      self.position = (toInt(dcopresult) / 1000)
   def chkLength(self):
      dcopresult = dcopCall(self.dcopclient, "length()")
      self.length = toInt(dcopresult) / 1000
   def chkSong(self):
      dcopresult = dcopCall(self.dcopclient, "title()")
      self.song = self.song = toString(dcopresult)
   def seekPrev(self):
      dcopCall(self.dcopclient, "back()")
   def seekNext(self):
      dcopCall(self.dcopclient, "forward()")
   def seekPrevOffset(self, offset):
      seek = (self.position - offset) * 1000
      if seek <= 0:
         seek = 0
      dcopvalue = toChars(seek)
      dcopValCall(self.dcopclient, "noatun", "Noatun", "skipTo(int)", dcopvalue)
   def seekNextOffset(self, offset):
      seek = (self.position + offset) * 1000
      if seek >= (self.length * 1000):
         seek = self.length
      dcopvalue = toChars(seek)
      dcopValCall(self.dcopclient, "noatun", "Noatun", "skipTo(int)", dcopvalue)
   def seekTime(self, seektime):
      dcopvalue = toChars(seektime * 1000)
      dcopValCall(self.dcopclient, "noatun", "Noatun", "skipTo(int)", dcopvalue)
   def cmdPause(self):
      dcopCall(self.dcopclient, "playpause()")
   def cmdStop(self):
      dcopCall(self.dcopclient, "stop()")
   def cmdPlay(self):
      dcopCall(self.dcopclient, "play()")
