#this import statement allows access to the karamba functions
import karamba
import icon
from docklet import Docklet
from docklet_eb import EBDocker
from docklet_xmms import XMMSDocker
import os
import os.path
import string
import glob

dockerPath = "/home/genneth/src/docker/"
picPath = dockerPath + "Pics/"
appPath = dockerPath + "AppLnk/"

######################################################################
# AppLnk
class AppLnk:
	command = ""
	name = ""
	appIcon = 0

	def __init__ (self, widget, name, command, x, y, iconPath):
		self.command = command
		self.name = name
		print "Creating icons for " + name
		self.appIcon = icon.addIcon(widget, x, y, iconPath)

	def run (self, widget):
		os.system(self.command + " &")
		print "Executed: " + self.command
		icon.bounceIcon(widget, self.appIcon)

######################################################################
# Karamba
appLnks = [ ]
docklets = [ ]
bar = [ ]

#this is called when you widget is initialized
def initWidget(widget):
	pass

init = 0
def Initialise(widget):
	global init
	global bar
	global appLnks
	global docklets

	if init == 0:
		# read in the applnks
		names = [ ]
		commands = [ ]
		iconPaths = [ ]
		iconCount = 0

		fileList = glob.glob(appPath+"*")
		fileList.sort()
		for fileName in fileList:
			print fileName
			#if os.path.isfile(fileName) != -1:
			#	continue
			file = open(fileName, "r")
			line = file.readline()
			#if string.count(line, "[Desktop Entry]") < 0:
			#	continue
			for line in file.readlines():
				names.append("")
				commands.append("")
				iconPaths.append("")
				if line[:4] == "Name":
					names[iconCount] = line[string.find(line, "=")+1:-1]
					print "Name=" + names[iconCount]
				if line[:4] == "Exec":
					commands[iconCount] = line[string.find(line, "=")+1:-1]
					print "Command=" + commands[iconCount]
				if line[:4] == "Icon":
					line = string.replace(line, ".png", '')
					rawPath = line[string.find(line, "=")+1:-1]
					if glob.glob(picPath + rawPath + ".png") != []:
						iconPaths[iconCount] = picPath + rawPath + ".png"
					print "Icon=" + iconPaths[iconCount]
			iconCount += 1
			file.close()
			print "----------------------------"

		# number of docklets
		dockletCount = 1

		# create the background bar
		bar.append(karamba.createImage(widget, 0, 20, picPath + "head-left.png"))
		karamba.resizeImage(widget, bar[0], 32, 70)
		bar.append(karamba.createImage(widget, 32, 20, picPath + "middle.png"))
		karamba.resizeImage(widget, bar[1], 64*iconCount, 70)
		bar.append(karamba.createImage(widget, 32+64*iconCount+32+64*dockletCount, 20, picPath + "head-right.png"))
		karamba.resizeImage(widget, bar[2], 32, 70)
		if dockletCount > 0:
			bar.append(karamba.createImage(widget, 32+64*iconCount, 20, picPath + "divider.png"))
			karamba.resizeImage(widget, bar[3], 32, 70)
			bar.append(karamba.createImage(widget, 32+64*iconCount+32, 20, picPath + "middle.png"))
			karamba.resizeImage(widget, bar[4], 64*dockletCount, 70)
		else:
			karamba.moveImage(widget, bar[2], 32+64*iconCount, 10)

		# load docklets
		#docklets.append(Docklet(widget, "Test docklet", 32+iconCount*64+32+0*64, 20, picPath + "kmenu.png"))
		docklets.append(XMMSDocker(widget, 32+iconCount*64+32+0*64, 20, picPath + "noatun.png"))

		# create the applnks
		appLnks = [ ]
		for i in range(iconCount):
			appLnks.append(AppLnk(widget, names[i], commands[i], 32+i*64, 20, iconPaths[i]))

		if len(docklets) > 0:
			widgetWidth = 32+64*len(appLnks)+32+64*len(docklets)+32
		else:
			widgetWidth = 32+64*len(appLnks)+32
		widgetHeight = 70+20+5
		karamba.resizeWidget(widget, widgetWidth, widgetHeight)
		karamba.moveWidget(widget, (1024-widgetWidth)/2, 768-widgetHeight+15)

		init = 1

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
	Initialise(widget)
	pass

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	global appLnks
	global docklets

	if 32 <= x <= 32+len(appLnks)*64 and 20+8 <= y <= 20+8+48:
		appRef = int((x-32) / 64)
		if 0 <= appRef < len(appLnks):
			appLnks[appRef].run(widget)
	elif 32+len(appLnks)*64+32 <= x <= 32+len(appLnks)*64+32+64*len(docklets):
		dockRef = int((x-(32+len(appLnks)*64+32)) / 64)
		if 0 <= dockRef < len(docklets):
			docklets[dockRef].click(widget, x-(32+len(appLnks)*64+32+dockRef*64), y-20, button)

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
	global appLnks

	if 32 <= x <= 32+len(appLnks)*64 and 20+8 <= y <= 20+8+48:
		appRef = int((x-32) / 64)
		if 0 <= appRef < len(appLnks) and icon.currentZoomed != appLnks[appRef].appIcon:
			icon.zoomIcon(widget, appLnks[appRef].appIcon)
	elif icon.currentZoomed > -1:
		icon.zoomIcon(widget, -1)
	pass


# This will be printed when the widget loads.
print "Loaded my python extension!"

