import karamba
import time
from threading import *

smoothZoom = 1

zoomFrames = 5
bounceFrames = 19

zoomAnim = [ ]
bounceAnim = [ ]

currentZoomed = -1

def addIcon(widget, x, y, path):
	global zoomFrames
	global bounceFrames
	global zoomAnim
	global bounceAnim
	global smoothZoom

	this = len(zoomAnim)
	zoomAnim.append([ ])
	bounceAnim.append([ ])
	for frame in range(zoomFrames):
		zoomAnim[this].append(karamba.createImage(widget, x+8-2*frame, y+8-4*frame, path))
		karamba.hideImage(widget, zoomAnim[this][frame])
		karamba.resizeImage(widget, zoomAnim[this][frame], 48+4*frame, 48+4*frame)
	karamba.showImage(widget, zoomAnim[this][0])
	if smoothZoom:
		for frame in range(bounceFrames):
			bounceAnim[this].append(karamba.createImage(widget, x+8, y+8-frame, path))
			karamba.hideImage(widget, bounceAnim[this][frame])
			karamba.resizeImage(widget, bounceAnim[this][frame], 48, 48)
	return this

def zoomIcon(widget, icon):
	global zoomFrames
	global zoomAnim
	global currentZoomed
	global smoothZoom

	for i in range(zoomFrames - 1):
		if currentZoomed > -1:
			karamba.hideImage(widget, zoomAnim[currentZoomed][zoomFrames-1-i])
			karamba.showImage(widget, zoomAnim[currentZoomed][zoomFrames-1-i-1])
		if icon > -1:
			karamba.hideImage(widget, zoomAnim[icon][i])
			karamba.showImage(widget, zoomAnim[icon][i+1])
		karamba.redrawWidget(widget)
		time.sleep(0.02)
	currentZoomed = icon

def getBounceRef(frame):
	if frame < 10:
		return int(36.0/5.0 * frame - 18.0/25.0 * frame * frame)
	elif frame >= 10 and frame < 16:
		return int(-8.0/9.0 * (frame - 10) * (frame - 16))
	elif frame >= 16 and frame <= 19:
		return int(- (frame - 16) * (frame - 19))
	else:
		return -1

def doBounce(widget, icon):
	global zoomFrames
	global zoomAnim
	global bounceFrames
	global bounceAnim
	global currentZoomed
	global smoothZoom

	print "started bouncing icon " + str(icon)

	if currentZoomed == icon:
		zoomIcon(widget, -1)

	if smoothZoom:
		karamba.hideImage(widget, zoomAnim[icon][0])
		karamba.showImage(widget, bounceAnim[icon][0])

		currentFrame = 0
		for frame in range(1000):
			karamba.hideImage(widget, bounceAnim[icon][currentFrame])
			currentFrame = getBounceRef(frame)
			if currentFrame < 0:
				break
			karamba.showImage(widget, bounceAnim[icon][currentFrame])
			karamba.redrawWidget(widget)
			time.sleep(0.05)

		karamba.hideImage(widget, bounceAnim[icon][0])
		karamba.showImage(widget, zoomAnim[icon][0])
		karamba.redrawWidget(widget)
	else:
		zoomIcon(widget, icon)
		zoomIcon(widget, -1)

	print "finished bouncing icon " + str(icon)

def bounceIcon(widget, icon):
	useThreading = 1
	if useThreading:
		bounceHandler = Thread(None, doBounce, None, (widget, icon) )
		bounceHandler.start()
	else:
		doBounce(widget, icon)
