# eye.one-xmms superkaramba theme by ramone@oxibiose.dyndns.org, based on the original xmmsbar by Adam Geitgey, adam@rootnode.org
# tested with superkaramba-0.27
#this import statement allows access to the karamba functions
import karamba
import os

xpos=0

init = 0
entire_playlist = []
display_lines = []
first_displayed_line = 0
last_song = 0

refresh_counter = 0

def getpos():
	fp = os.popen("xmmsctrl getpos")
	output = fp.read()
	output = output.splitlines()
	if (len(output) > 0):
		return int(output[0])-1
	else:
		return 0
def setpos(songnum):
	os.system("xmmsctrl track " + str(songnum+1))
	
def redispPlaylist(widget):
	global entire_playlist
	global first_displayed_line
	global display_lines
	global refresh_counter

	refresh_counter = refresh_counter + 1

	if refresh_counter >= 5:
		print "doing heavy refresh"
		refresh_counter = 0
		entire_playlist = []
		fp = os.popen("xmmsctrl playlist")
		output = fp.read()
		output = output.splitlines()
		i = 0
		for x in output:
			i=i+1
			playlist = x.split()
			songtitle = playlist[1:]
			texttitle = ""
			for word in songtitle:
				texttitle = texttitle + " " + word
			entire_playlist.append(texttitle)

    
	for i in range(33):
		text = display_lines[i]
		karamba.changeText(widget, text, "")

	for i in range(first_displayed_line, len(entire_playlist)):
		if i < (first_displayed_line + 33):
			text = display_lines[i-first_displayed_line]
			texttitle = entire_playlist[i]
		if len(texttitle) > 40:
			texttitle = texttitle[0:39] + "..."
		karamba.changeText(widget, text, texttitle)
		karamba.changeTextFont(widget, text, 'verdana')
		karamba.changeTextColor(widget, text, 255, 255, 255)
		karamba.changeTextSize(widget, text, 9)

	pos = getpos()
	if (first_displayed_line <= pos < (33 + first_displayed_line)):
		karamba.changeTextColor(widget, display_lines[pos-first_displayed_line], 5, 25, 75)
##	karamba.redrawWidget(widget)

#this is called when you widget is initialized
def initWidget(widget):
	
	global m
	global xpos
	
	_xpos=karamba.readConfigEntry(widget,"widgetPosX");
	if (_xpos != None):
		xpos=_xpos
	
	m = 0

	karamba.moveWidget(widget, xpos, -600)
# widget text & mover
	karamba.createBackgroundImage(widget, 0, 0, "pics/back_xmms.png")
	karamba.createBackgroundImage(widget, 0, 600, "pics/mover.png")
	karamba.createImage(widget, 5, 604, "pics/xmmsmover.png")
	karamba.createImage(widget, 10, 566, "pics/xmmstitleback.png")

	headline = karamba.createText(widget, 35, 0, 210, 26, 'xmms control')
	karamba.changeTextFont(widget, headline, 'verdana')
	karamba.changeTextSize(widget, headline, 16)
	karamba.changeTextColor(widget, headline, 255, 255, 255)


# icons & tooltips
	global xmms
	global xmmsback
	global xmmsplay
	global xmmspause
	global xmmsstop
	global xmmsforward
	global xmmsup
	global xmmsdown


	xmms = karamba.createImage(widget, 8, 8, "pics/xmms.png")
	karamba.addImageTooltip(widget, xmms, "Start XMMS")
	xmmsback = karamba.createImage(widget, 0, 30, "pics/xmmsback.png")
   	karamba.addImageTooltip(widget, xmmsback, "back")
	xmmsplay = karamba.createImage(widget, 55, 30, "pics/xmmsplay.png")
    	karamba.addImageTooltip(widget, xmmsplay, "play")
	xmmspause = karamba.createImage(widget, 110, 30, "pics/xmmspause.png")
   	karamba.addImageTooltip(widget, xmmspause, "pause")
	xmmsstop = karamba.createImage(widget, 165, 30, "pics/xmmsstop.png")
	karamba.addImageTooltip(widget, xmmsstop, "stop")
	xmmsforward = karamba.createImage(widget, 220, 30, "pics/xmmsforward.png")
	karamba.addImageTooltip(widget, xmmsforward, "forward")
	xmmsup = karamba.createImage(widget, 120, 504, "pics/xmmsup.png")
	karamba.addImageTooltip(widget, xmmsup, "scroll playlist up")
	xmmsdown = karamba.createImage(widget, 120, 532, "pics/xmmsdown.png")
	karamba.addImageTooltip(widget, xmmsdown, "scroll playlist down")

# the volume thing
	global volumebar
	global hidden
	hidden = 0

	xmmsvolup = karamba.createImage(widget, 140, 504, "pics/xmmsup.png")
	karamba.addImageTooltip(widget, xmmsvolup, "volume +")
	xmmsvoldown = karamba.createImage(widget, 140, 532, "pics/xmmsdown.png")
	karamba.addImageTooltip(widget, xmmsvoldown, "volume -")
	karamba.createImage(widget, 136, 504, "pics/xmmsvolumeback.png")
	volumebar = karamba.createImage(widget, 136, 556, "pics/xmmsvolumebar.png")


# actual title slide display
	global actualtitle

	actualtitle = karamba.createText(widget, 14, 566, 246, 26, "")
	karamba.changeTextFont(widget, actualtitle, 'verdana')
	karamba.changeTextSize(widget, actualtitle, 11)
	karamba.changeTextColor(widget, actualtitle, 255, 255, 255)


#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):

	global init
	global first_displayed_song
	global last_song
	global entire_playlist

	if init == 0:

		init = 1

		havexctrl = os.system("which xmmsctrl")

		if (havexctrl == 0):
			print "\nFound xmmsctrl, so this theme should work."
		else:
			os.system("kdialog --error \"xmmsctrl could not be found!  Please install it to use this theme.  \nVisit:\nhttp://user.it.uu.se/~adavid/utils/\" --title \"XMMS Bar Error\"")
			print "\nCan't find xmmsctrl in your path.  Please install it to make this work.  "

		fp = os.popen("xmmsctrl playlist")
		output = fp.read()
		output = output.splitlines()
		i = 0
		for x in output:
			i=i+1
			playlist = x.split()
			songtitle = playlist[1:]
			texttitle = ""
			for word in songtitle:
				texttitle = texttitle + " " + word
			entire_playlist.append(texttitle)

		for i in range(len(entire_playlist)):
			if i < 33:
				texttitle = entire_playlist[i]
				if len(texttitle) > 40:
					texttitle = texttitle[0:39] + "..."
				text = karamba.createText(widget, 10, (i*13)+65, 0, 0, texttitle)
				display_lines.append(text)
				karamba.changeTextColor(widget, text, 255, 255, 255)
				karamba.changeTextFont(widget, text, 'verdana')
				karamba.changeTextSize(widget, text, 9)
		if len(display_lines) < 33:
			print "padding display_lines"
			lower = len(display_lines)
			for x in range(lower, 34):
				text = karamba.createText(widget, 10, (x*13)+65, 0, 0, (""))
				display_lines.append(text)

		pos = getpos()
		if (0 < pos < 33):
			karamba.changeTextColor(widget, display_lines[pos], 5, 25, 75)
#		karamba.redrawWidget(widget)

	redispPlaylist(widget)

# slide actual title
	global actual
	global actualtitle
	global m

	if ( len(entire_playlist) > 0 ):
		pos = getpos()
		actual = ""
		actual = entire_playlist[pos]
		if ( m == len(actual) ):
			m = 0
		if ( m < len(actual) ):
			actual = actual[( 0 + m ):len(actual)] + "  " + actual + "  " + actual
			m = m + 1
	if ( len(entire_playlist) == 0 ):
		actual = ""
	karamba.changeText(widget, actualtitle, actual)

	global volume
	global volumebar
	global hidden

	if init == 1:
		fv = os.popen("xmmsctrl getvol")
		volume = fv.read()
		print volume
		if ( volume == "" ):
			karamba.hideImage(widget, volumebar)
			hidden = 1
		else:
			if ( hidden == 1 ):
				karamba.showImage(widget, volumebar)
				hidden = 0
			karamba.moveImage(widget, volumebar, 136, (556 - ((52 * int(volume)/100))))
			karamba.resizeImage(widget, volumebar, 4, ((52 * int(volume))/100))

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):


# programm calls
	if (x >= 8) and (x < 25) and (y >= 8) and (y < 25) and (button == 1):
			os.system('xmms &')
	if (x >= 0) and (x < 55) and (y >= 30) and (y < 61) and (button == 1):
			os.system('xmmsctrl previous')
	if (x >= 55) and (x < 110) and (y >= 30) and (y < 61) and (button == 1):
			os.system('xmmsctrl play')
	if (x >= 110) and (x < 165) and (y >= 30) and (y < 61) and (button == 1):
			os.system('xmmsctrl pause')
	if (x >= 165) and (x < 220) and (y >= 30) and (y < 61) and (button == 1):
			os.system('xmmsctrl stop')
	if (x >= 220) and (x < 275) and (y >= 30) and (y < 61) and (button == 1):
			os.system('xmmsctrl next')

	global last_song
	global first_displayed_line

	selected_song = first_displayed_line + (y-65)/13

	if (first_displayed_line <= selected_song < 33+first_displayed_line) and (button == 1):
		last_song = getpos()
		setpos(selected_song)
		redispPlaylist(widget)
		
	if (y > 61) and (y < 504 ) and (button == 4):
		first_displayed_line = first_displayed_line - 5
		if first_displayed_line < 0:
			first_displayed_line = 0
		redispPlaylist(widget)

	if (y > 61) and (y < 504 ) and (button == 5):
		first_displayed_line = first_displayed_line + 5
		if first_displayed_line > len(entire_playlist):
			first_displayed_line = len(entire_playlist)-1
		redispPlaylist(widget)

	if (x >= 120) and (x < 137) and (y >= 504) and (y < 530) and (button == 1):
		first_displayed_line = first_displayed_line - 32
		if first_displayed_line < 0:
			first_displayed_line = 0
		redispPlaylist(widget)

	if (x >= 120) and (x < 137) and (y >= 532) and (y < 563) and (button == 1):
		first_displayed_line = first_displayed_line + 32
		if first_displayed_line < 0:
			first_displayed_line = 0
		redispPlaylist(widget)

	if (x >= 140) and (x < 157) and (y >= 504) and (y < 563) and (button == 4):
			os.system('xmmsctrl vol +10')

	if (x >= 140) and (x < 157) and (y >= 504) and (y < 563) and (button == 5):
			os.system('xmmsctrl vol -10')

	if (x >= 140) and (x < 157) and (y >= 504) and (y < 530) and (button == 1):
			os.system('xmmsctrl vol +10')


	if (x >= 140) and (x < 157) and (y >= 532) and (y < 563) and (button == 1):
			os.system('xmmsctrl vol -10')


# move widget	
	position = karamba.getWidgetPosition(widget)		 
	if (y >= 600) and (position[1] > -600) and (button == 1):
		i = 0
		g = 0
		while g < 601:
			karamba.moveWidget(widget, xpos, i)
			i = i-5
			g = g+5
		
	if (position[1] == -600) and (button == 1):
		i = -600
		g = 0
		while g < 601:
			karamba.moveWidget(widget, xpos, i)
			i = i+5
			g = g+5
			

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
# highlight icons
	global xmms, xmmsback, xmmsplay, xmmspause, xmmsstop, xmmsforward

    	if (x >= 8) and (x < 25) and (y >= 8) and (y < 25):
			karamba.changeImageIntensity(widget, xmms, 0.3) 
	else:
			karamba.removeImageEffects(widget, xmms)
    	if (x >= 0) and (x < 55) and (y >= 30) and (y < 61):
			karamba.changeImageIntensity(widget, xmmsback, 0.5)
	else:			
			karamba.removeImageEffects(widget, xmmsback)
	if (x >= 55) and (x < 110) and (y >= 30) and (y < 61):
			karamba.changeImageIntensity(widget, xmmsplay, 0.5)
	else:			
			karamba.removeImageEffects(widget, xmmsplay)
	if (x >= 110) and (x < 165) and (y >= 30) and (y < 61):
			karamba.changeImageIntensity(widget, xmmspause, 0.5)
	else:			
			karamba.removeImageEffects(widget, xmmspause)
	if (x >= 165) and (x < 220) and (y >= 30) and (y < 61):
			karamba.changeImageIntensity(widget, xmmsstop, 0.5)
	else:			
			karamba.removeImageEffects(widget, xmmsstop)
	if (x >= 220) and (x < 275) and (y >= 30) and (y < 61):
			karamba.changeImageIntensity(widget, xmmsforward, 0.5)
	else:			
			karamba.removeImageEffects(widget, xmmsforward)
# This will be printed when the widget loads.
print ""
print "Loaded eyeon-xmms.theme python extension."
print "Suggestions welcome to ramone@oxibiose.dyndns.org !"
print ""
