#Programmer: Ryan Nickell    ryan_s_nickell@hotmail.com
#Date: 04/17/2004
#Filename: applications.py
#Version: 0.02
#
#
#	Copyright 2004 Ryan Nickell
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##########################################################################
import re, karamba
class Application:
	'Application icon object'
	myVersion = '0.02'
	def __init__(self, nm, anm, wgt):
		self.name = nm #execution name including arguments
		self.altName = anm #display name under icon
		temp = re.split(r'(\s)',nm,1)
		self.icon = temp[0]+'.png' #icon name not including path
		self.iTheme = 'icons/' #icon theme or path to the icon
		self.fullIcon = '' #icon theme or path including the icon
		self.refreshIcon() #recalculates the theme or path
		self.unique = 'No' #flag for if the icon is unique or using the theme
		self.widget =  wgt #reference to the karamba widget
		self.image = -1 #image reference
		self.menu1 = karamba.createMenu(self.widget)
		self.id1 = -1
		self.id2 = -1

	#name of the executable application
	def getName(self):
		return self.name

	def setName(self,newName):
		#this shouldn't really be needed
		# as it should only be set by instantiation
		# it's only for sake of argument
		self.name = newName

	#test that displays for this application
	def getDisplayName(self):
		return self.altName

	def setDisplayName(self,newName):
		self.anm = newName

	#the icon that will be used for this application
	def getIcon(self):
		return self.icon

	def setIcon(self,newIcon):
		self.icon = newIcon

	def getIconTheme(self):
		return self.iTheme

	def setIconTheme(self,newTheme):
		self.iTheme = newTheme

	def showVersion(self):
		print Application.myVersion

	#returns the full path of the icon it is going to use
	def getFullIcon(self):
		return self.fullIcon

	#sets the full path to the icon with argument newFullIcon
	def setFullIcon(self,newFullIcon):
		self.fullIcon = newFullIcon

	#refreshes the full icon path after you use setFullIcon(), setIconTheme() or setIcon()
	def refreshIcon(self):
		self.fullIcon = self.getIconTheme()+self.getIcon()

	#returns if the icon is unique and not using the theme
	def isIconUnique(self):
		return self.unique

	#sets the unique icon and sets the flag for isIconUnique
	# the newIcon parameter must be '<name>.png' probably from kdialog would be easiest
	# be sure to setIconTheme with the preceding path to the '<name>.png' when using this
	def setUniqueIcon(self,newIcon):
		self.unique = 'Yes'
		self.icon = newIcon

	#clears UniqueIcon, and sets to default theme
	def clearUniqueIcon(self):
		self.unique = 'No'
		temp = re.split(r'(\s)',self.name,1)
		self.icon = temp[0]+'.png'

	#creates a popupMenu with the current settings for the icon/application displayed
	def showPopup(self):
		#if self.id1 is -1 and self.id2 is -1:
		#process the popup information everytime b/c this changes if someone
		#changes the icon theme directory
		karamba.removeMenuItem(self.widget,self.menu1,self.id1)
		karamba.removeMenuItem(self.widget,self.menu1,self.id2)
		self.id1 = karamba.addMenuItem(self.widget, self.menu1, self.name, self.icon)
		self.id2 = karamba.addMenuItem(self.widget, self.menu1, self.fullIcon, '')
		karamba.popupMenu(self.widget, self.menu1, 0, 0)

#>>>the below code is experimental and not implemented in iLaunch currently<<<
	#makes a test image
	def showImage(self):
		self.image = karamba.createImage(self.widget,0,0,'up.png')

	#remove the image created in showImage
	def removeImage(self):
		try:
			karamba.deleteImage(self.widget,self.image)
			self.image = -1
		except:
			"No image to remove"

