#!/usr/bin/python2
# This file is part of the pymoontool application
# This file is part of the karmaba_moontool application
# Written by Eric J. Gerney <gerney@att.com>
# Adapted from xmoontool by John Walker
# Distributed under GPL version 2.

# This file defines several constants and other variables used throughout
# the moontool applications.

# Constants
epoch = 2444238.5		# 1980 January 0.0

# Constants describing the Sun's apparent orbit.
elonge = 278.833540		# ecliptic longitude of the Sun at epoch 1980.0
elongp = 282.596403		# ecliptic longitude of the Sun at perigee
eccent = 0.016718		# eccentricity of Earth's orbit
sunsmax = 1.495985e8		# semi-major axis of Earth's orbit, km
sunangsiz = 0.533128		# sun's angular size, degrees, at semi-major axis
				# distance

# Constants describing the Moon's orbit, epoch 1980.0
mmlong = 64.975464		# moon's mean longitude at the epoch
mmlongp = 349.383063		# moon's longitude of the perigee at the epoch
minc = 5.145396			# inclination of the moon's orbit
mecc = 0.054900			# eccentricity of the moon's orbit
mangsiz = 0.5181		# moon's angular size at a distance from Earth
msmax = 384401.0		# semi-major axis of Moon's orbit in km
mparallax = 0.9507		# parallax at a distance from Earth
synmonth = 29.530588668		# synodic monthe (new moon to new moon)
lunatbase = 2423436.0		# base date for E. W. Brown's numbered series of
				# lunations (1923 Jan 16)

# Constants for the Earth
earthrad = 6378.16		# Earth's radius in km

# Mathatical constants
EPSILON = 1e-6

# TRUE/FALSE
TRUE = 0
FALSE = 1

# Months
moname = ['January', 'February', 'March', 'April', 'May', 'June',	\
	  'July', 'August', 'September', 'October', 'November', 'December']
