#!/usr/bin/python2
# This file is part of the pymoontool application
# This file is part of the karmaba_moontool application
# Written by Eric J. Gerney <gerney@att.com>
# Adapted from xmoontool by John Walker
# Distributed under GPL version 2.

# This file defines custom math functions used throughout the moontool
# applications.

# Import math module & our constants
import math
import constants

# Math functions
# Fix Angle
def fixangle(a):
	b = a - 360.0 * math.floor( a / 360.0)
	return b

def torads(d):
	# Convert Degrees to Radians
	return d * math.pi / 180.0

def todegs(r):
	# Convert Radians to Degrees
	return r * 180.0 / math.pi

def dsin(d):
	# Return sin from degrees
	return math.sin(torads(d))

def dcos(d):
	# Return cos from degrees
	return math.cos(torads(d))

def kepler(m, ecc):
	e = m = torads(m)
	while 1:
		delta = e - ecc * math.sin(e) - m
		e = e - (delta / (1 - ecc * math.cos(e)))
		if (math.fabs(delta) > constants.EPSILON):
			break  # This might need to be changed
	return e
