#!/usr/bin/python2
# This file is part of the karmaba_moontool application
# Written by Eric J. Gerney <gerney@att.com>
# Adapted from xmoontool by John Walker
# Distributed under GPL version 2.

# This file creates the moon graphic with the shading for the current phase.

import math, string, os

def drawmoon(ph,moonorig,moonfile,fillvalue):
	print "Updating....." + moonorig + " -> " + moonfile
	WIDTH = 320
	HEIGHT = 320
	RADIUS = 160.0
	IRADIUS = 160
	OFFSET = 160
	CENTER = 160
	coordList = []
	drawstring = ""
	convertbinary = "/usr/bin/convert"

	xscale = math.cos(2 * 3.1415 * ph)

	for i in range(IRADIUS):
		cp = RADIUS * math.cos(math.asin(i/RADIUS))
		if (ph < 0.5):
			rx = CENTER + cp
			lx = CENTER + xscale * cp
			coordList.append([int(lx),OFFSET+i,int(WIDTH-rx),OFFSET+i])
			if (i != 0):
				coordList.append([int(lx),OFFSET-i,int(WIDTH-rx),OFFSET-i])
		else:
			lx = CENTER - cp
			rx = CENTER - xscale * cp
			coordList.append([int(rx),OFFSET+i,int(WIDTH-lx),OFFSET+i])
			if (i != 0):
				coordList.append([int(rx),OFFSET-i,int(WIDTH-lx),OFFSET-i])
	for i in range(len(coordList)):
		drawstring = drawstring + \
			" -draw 'line " + str(coordList[i][0]) + "," + \
			str(coordList[i][1]) + " " + \
			str(coordList[i][2]) + "," + \
			str(coordList[i][3]) + "'"
	cmdstr = convertbinary + " " + moonorig + " -type truecolormatte " \
		+ "-fill '" + fillvalue + "'" + drawstring + " " + moonfile
	#print fillvalue
	#print cmdstr
	os.system(cmdstr)
	#os.system("display moon.png")
