###############################################################################
##  KPopper - v0.60
###############################################################################
##
##  Code by:
##    Jyri Toomessoo <jyrit at artecdesign.ee>
##  Patches:
##    nobody yet
##
##  KPopper is an theme for SuperKaramba to make a KMenu system replacement
##  menu popup
##  I hope it will be good enaugh for use on daily bases
##  It also has a lot of generic design object's that I hope can be reused
##
##  Feel free to email me with comments or suggestions!
##
##  This software is GPL'ed and here by the author asks you to
##  distribute this message in systems that use the code contained here in
##
##  There are things I'd like to implement still on this menu and I intend to
##  do so. If you have any patches to the code I'd be happy to recive them
##  and blend them in here.
###############################################################################


#this import statement allows access to the karamba functions
import karamba
import threading
import commands
import time
import string
import popen2
import os

updateProgress = 0
noMouse = 0
kill = 0
gx = 0
gy = 0
init = 0
parserInst = 0 #directory parser object
c = 0 #configutationHandler object
cnt = 0
kmenu = 0 #menu handler object

###################################
##  Global Configuration  Object ###############################################
###################################
class ConfigHolder:
	def __init__(self):
		#MENU Path configuration
		self.rootDir ="" #will be auto detected
		self.sysDirAlt =['/usr/share/applnk-mdk'] #alternative menu locations
		self.sysDirAlt.append('/usr/share/applnk') #alternative menu locations
		self.sysDirAlt.append('/opt/share/applnk') #alternative menu locations
		self.sysDirAlt.append('~/.kde/share/applnk') #alternative menu locations
		#ICON Path configuration
		self.sysIcoTheme ='crystalsvg' #Case sensitive icon theme directory name you want to use
		self.sysIcoAlt =['/usr/share/icons/mini'] #alternative icon locations
		self.sysIcoAlt.append('/opt/share/icons/mini') #alternative icon locations
		self.sysIcoAlt.append('/usr/share/icons/'+self.sysIcoTheme+'/16x16/apps') #alternative icon locations
		self.sysIcoAlt.append('/usr/share/icons/'+self.sysIcoTheme+'/16x16/filesystems') #alternative icon locations
		self.sysIcoAlt.append('/usr/share/icons/kdeclassic/16x16/apps') #alternative icon locations
		self.sysIcoAlt.append('/usr/share/icons/kdeclassic/16x16/filesystems') #alternative icon locations
		self.sysIcoAlt.append('/opt/share/icons/'+self.sysIcoTheme+'/16x16/apps') #alternative icon locations
		self.sysIcoAlt.append('/opt/share/icons/'+self.sysIcoTheme+'/16x16/filesystems') #alternative icon locations
		self.sysIcoAlt.append('/opt/share/icons/kdeclassic/16x16/apps') #alternative icon locations
		self.sysIcoAlt.append('/opt/share/icons/kdeclassic/16x16/filesystems') #alternative icon locations
		#MINI icon preload conf
		self.iconPathAlt = ['/usr/share/icons/mini','/opt/share/icons/mini'] #alternative mini icon locations
		self.iconPath = '' #will be auto detected
		#SKIN configuration
		self.skinName = '3d_blue' #directory name where images are
		self.topImgPath =self.skinName+'/regular_bar.png' #bg image of menu header 50x200
		self.itemImgPath=self.skinName+'/menu_item.png' #bg imege of menu item 24x200
		self.itemTabPath=self.skinName+'/menu_item_done.png' #bg image of entered directory 24x200
		self.defIcon    =self.skinName+'/def_icon.png' # not used yet
		#GENERAL configuration
		self.showIcons = 1 #Enable icon support (all eyecandy is more work for your CPU on menu access) :)
		self.exitOnWarnings = 0 #you dont want to exit on warning (KPopup will still work)
		self.linkColor = [10,10,225] #color of exec menu link r,g,b
		self.selColor = [10,10,15] #color on mouse over r,g,b
		self.dirColor = [80,80,80] #color of directory item r,g,b
		self.dirPathColor = [255,255,255] #color of entered directory
		self.itemFont = "Urw Gothic l" #define a font for menu if you want
		self.itemFontSize = 11 #text size of all menu texts
		self.FPS = 10.0 #frame rate option Please add .0 to the end allways
		self.holdMenuUp = 1  #seconds(+-updatetime) This will define wait time until auto menu lower
		self.yReso = 480 #vga y will be autodetected (this is fail value)
		self.xReso = 640 #vga x will be autodetected (this is fail value)
		self.menuDispX = 80  #menu displacement from left screen side
		self.menuDispY = 0   #menu displacment ftom bottom 0=bottom of screen
		self.autoResize = 1 #if not in bottom edge of screen then must be true
		self.popupOnEnter = 1 #menu will auto popup if mouse enters (must click if == 0)
		#SYSTEM auto configuration
		self.iconDBRet = ''
		self.iconPathDB = [self.skinName] #for auto fill
		self.iconNameDB = ['def_icon.png'] #for auto fill


	def autoConfigure(self):
		#starting auto configure
		#autodetect directory paths
		for testDir in self.sysDirAlt:
			if os.path.exists(testDir):
				self.rootDir=testDir
				break
		for testDir in self.iconPathAlt:
			if os.path.exists(testDir):
				self.iconPath=testDir
				break
		if self.iconPath=='':
			if self.showIcons:
				print ""
				print "Error: 	Cant find KDE mini icons location"
				print "	Add your $KDE_PATH/icon/mini dir to .py file iconPathAlt"
				print "	Send a note to jyrit(at)artecdesign.ee"
				print ""
				kpopupKill()
			else:
				print "Note:	You will not be able to use showIcons=1"
		if self.rootDir=="":
				print ""
				print "Error: 	Cant find KDE menu location"
				print "	Adding your KDE menu dir to .py file (ConfigHolder.sysDirAlt) helps"
				print ""
				kpopupKill()
		#load mini icon database
		if self.showIcons:
			iconsTmp = commands.getoutput('ls '+self.iconPath)
			iconsTmp = string.split(iconsTmp,"\n")
			#self.iconNameDB = ['']
			#for icon in iconsTmp:
			#	self.iconDB = []
			#self.iconNameDB = iconsTmp
			for name in iconsTmp:
				self.iconPathDB.append(self.iconPath)
				self.iconNameDB.append(name)

		#autodetect screen dimensions
		conf = commands.getoutput('xdpyinfo')
		if string.find(conf,'command not found')>-1:
			print ""
			print "Warning:	Cant detect dimensions."
			print "	bacause there is no [xdpyinfo] command in your system"
			print "	KPopup will set dimension to safe 640x480"
			print "	you can manual set xReso and yReso in .py file class ConfigHolder"
			print ""
			if self.exitOnWarnings:
				kpopupKill()
		conf = string.split(string.lower(conf),"\n")
		dims =""
		for item in conf:
			if string.find(item,'dimensions:')>-1:
				#print item
				dims = dims + item + "\n"
		if not dims=="":
			dims = string.split(dims," ")
			while dims.count(""):
				dims.remove("")
			XandY = dims[1]
			XandY = string.split(XandY,"x")
			#print "Detected screen Dimensions:",XandY
			if len(XandY)==2:
				self.xReso = int(XandY[0])
				self.yReso = int(XandY[1])
			else:
				print ""
				print "Warning:	Cant detect dimensions."
				print "	Screen configutation fail is not parsed correctly"
				print "	Copy the xdpyinfo command output and send to jyrit(at)artecdesign.ee"
				print "	and ask for help or modify the autoconfigure yourself and send a patch"
				print "	KPopup will set dimension to safe 640x480"
				print ""
				if self.exitOnWarnings:
					kpopupKill()
	def loadIconDB(self,widget):
		#print self.sysIcoAlt
		delPaths=''
		if self.showIcons:
			for path in self.sysIcoAlt:
				if not os.path.exists(path):
					delPaths = delPaths +path+';;;'
			delPaths = string.split(delPaths,';;;')
			delPaths.remove('')
			for path in delPaths:
				self.sysIcoAlt.remove(path)
			if len(self.sysIcoAlt)<1:
				print ""
				print "Error: 	Cant find KDE icons locations"
				print "	Add your $KDE_PATH/icon/*/16x16/* dirs to .py file sysIcoAlt"
				print "	Send a note to jyrit(at)artecdesign.ee"
				print ""
				kpopupKill()


	def searchIconDB(self,widget,iconName):
		self.iconDBRet=''
		if self.iconNameDB.count(iconName)>0:
			#print "FND:",iconName,self.iconNameDB.index(iconName) #DEBUG
			self.iconDBRet = self.iconPathDB[self.iconNameDB.index(iconName)]+'/'+iconName
		else:
			for testPath in self.sysIcoAlt:
				if os.path.exists(testPath+'/'+iconName):
					#print "ADD:", iconName #DEBUG
					self.iconDBRet=testPath+'/'+iconName
					self.iconNameDB.append(iconName)
					self.iconPathDB.append(testPath)
					break #so that first found is the best
		if self.iconDBRet=='':
			#print "missing icon",iconName #DEBUG
			self.iconDBRet=self.skinName+'/def_icon.png'





##################################
##  Parser class declaration    ################################################
##################################
class MenuParser:
	def __init__(self):
		self.dirs = 0
		self.comms = 0
		self.icons = 0
		self.isLeaf = 0
		self.conf = 0
	def configure(self,conf):
		self.conf = conf
	def parseDir(self,directory):
		self.dirs = commands.getoutput('ls '+directory)
		#print self.dirs
		self.dirs = string.split(self.dirs,"\n")
		i=0
		dirNWS = ""
		removeItems =[]
		self.isLeaf = ""
		self.comms = ""
		self.icons = ""
		#print self.dirs
		for item in self.dirs:
			if string.count(item,'.desktop'):
				#parse fail for command
				dirNWS = string.replace(directory+'/'+item, "\\","")
				dirNWS = string.replace(dirNWS, " ","\ ")
				dirNWS = string.replace(dirNWS, "(","\(")
				dirNWS = string.replace(dirNWS, ")","\)")
				#print "Parser_corrdir?:",dirNWS
				conf = commands.getoutput('more '+dirNWS)
				#print "||||||||||||||||||||||||||||||||||||||||||||||||||||||||||"
				#print "Command:",'more '+dirNWS
				#print "RawConf:",conf
				origConf = string.split(conf,"\n")
				conf = string.split(string.lower(conf),"\n")
				#print "CONF",item," ",conf
				if string.count(conf,"nodisplay=true"):
					#self.dirs.remove(item)
					removeItems.append(item)
					#print "removing:",item
				else:
					self.isLeaf=self.isLeaf+"1 "
					for name in origConf:
						#print "listitems:",name[0:4]
						if name[0:5]=="Name=":
							self.dirs[i]= name[5:]
						elif name[0:5]=="Exec=":
							self.comms = self.comms+name[5:]+';;;'
						elif name[0:5]=="Icon=":
							self.icons = self.icons+name[5:]+';;;'
							#print "icons",name[5:] #DEBUG
			else:
				self.isLeaf=self.isLeaf+"0 "
				self.comms = self.comms+";;;"
				if self.conf.showIcons:
					dirNWS = ""
					dirNWS = string.replace(directory+'/'+item+'/.directory', "\\","")
					dirNWS = string.replace(dirNWS, " ","\ ")
					dirNWS = string.replace(dirNWS, "(","\(")
					dirNWS = string.replace(dirNWS, ")","\)")
					#print "Parser_corrdir?:",dirNWS #DEBUG
					conf = commands.getoutput('more '+dirNWS)
					origConf = string.split(conf,"\n")
					conf = string.split(string.lower(conf),"\n")
					for name in origConf:
						#print "listitems:",name[0:4]
						if name[0:5]=="Icon=":
							self.icons = self.icons+name[5:]+';;;'
							#print "icons",name[5:] #DEBUG
				else:
					self.icons = self.icons+";;;"
			i=i+1

		for item in removeItems:
			self.dirs.remove(item)
		self.isLeaf = string.split(self.isLeaf," ")
		self.comms = string.split(self.comms,';;;')
		self.icons = string.split(self.icons,';;;')
		#print self.icons
		#print self.comms




##################################
##  Menu  class declaration    ################################################
##################################
class MenuHandler:
	def __init__(self):
		self.menuUp = 0
		self.menuLen = 0
		self.showItems = 0
		#25 items in menu is the max in this implementation
		self.items = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		self.tabs =  [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		self.texts = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		self.icons = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		self.nests =[""]
		self.topImg = 0
		self.rootPath =""
		self.currentPath = ""

	def createMenu(self,widget,menuParser,conf):
		self.rootPath = conf.rootDir
		self.currentPath = conf.rootDir
		self.showItems = 0
		if conf.autoResize==1:
			karamba.resizeWidget(widget, 200, 50+self.showItems*24)
		karamba.redrawWidget(widget)
		karamba.moveWidget(widget,conf.menuDispX,(conf.yReso-50 - conf.menuDispY))
		self.topImg = karamba.createImage(widget,0,1, conf.topImgPath)
		for  i in range (0,25):
			#Tabs must be hidden in beginning
			self.tabs[i]  = karamba.createImage(widget,0,50+i*24, conf.itemTabPath)
			karamba.hideImage(widget, self.tabs[i])
			self.items[i]  = karamba.createImage(widget,0,50+i*24, conf.itemImgPath)
			iconShift = conf.showIcons*(17)
			self.texts[i] = karamba.createText(widget,5+iconShift,2+50+i*24,190,20,"")
			#print menuParser.icons
			karamba.changeTextColor(widget,self.texts[i], conf.dirColor[0], conf.dirColor[1], conf.dirColor[2])
			if len(menuParser.dirs)>i:
				karamba.changeText(widget, self.texts[i], menuParser.dirs[i])
			karamba.changeTextFont(widget,self.texts[i], conf.itemFont)
			karamba.changeTextSize(widget,self.texts[i] , conf.itemFontSize)
			if len(menuParser.dirs)>i and menuParser.isLeaf[i]=='1':
				karamba.changeTextColor(widget,self.texts[i], conf.linkColor[0],conf.linkColor[1],conf.linkColor[2])
		self.menuLen = len(menuParser.dirs)
		self.updateIcons(widget,menuParser,conf)


		
	def updateSelect(self,widget,menuParser,conf,activeID):
		for  i in range (0,25):
			if len(menuParser.dirs)>i:
				if i==activeID:
					karamba.changeTextColor(widget,self.texts[i], conf.selColor[0], conf.selColor[1], conf.selColor[2])
				else:
					if menuParser.isLeaf[i]=='1':
						karamba.changeTextColor(widget,self.texts[i],conf.linkColor[0],conf.linkColor[1],conf.linkColor[2])
					else:
						karamba.changeTextColor(widget,self.texts[i], conf.dirColor[0], conf.dirColor[1], conf.dirColor[2])


	def updateIcons(self,widget,menuParser,conf):
		if conf.showIcons:
			#print i #DEBUG
			#print "icon op:",self.icons
			#print "icon  n:",menuParser.icons
			for  i in range (0,25):
				if (len(menuParser.icons)-1)>i:
					if self.icons[i]:
						karamba.deleteImage(widget,self.icons[i])
						self.icons[i]=0
					conf.searchIconDB(widget,menuParser.icons[i])
					self.icons[i] = karamba.createImage(widget,0+2,50+i*24+2, conf.iconDBRet)
					karamba.resizeImageSmooth(widget, self.icons[i], 20, 20)
				elif (len(menuParser.dirs)+len(self.nests))> i:
					if self.icons[i]:
						karamba.deleteImage(widget,self.icons[i])
						self.icons[i]=0
				#----------end show icons
			#print "icon np:",self.icons

	def updateText(self,widget,menuParser,conf,activeID):
		for  i in range (0,25):
			if len(menuParser.dirs)>i:
				karamba.showImage(widget,self.items[i])
				karamba.hideImage(widget,self.tabs[i])
				#update regular menu items
				#self.updateIcons(widget,menuParser,conf)
				karamba.changeText(widget, self.texts[i], menuParser.dirs[i])
				if menuParser.isLeaf[i]=='1':
					karamba.changeTextColor(widget,self.texts[i], conf.linkColor[0],conf.linkColor[1],conf.linkColor[2])
				else:
					karamba.changeTextColor(widget,self.texts[i], conf.dirColor[0], conf.dirColor[1], conf.dirColor[2])
			elif (len(menuParser.dirs)+len(self.nests)-1)> i:
				#update base dir tabs
				karamba.changeText(widget, self.texts[i], self.nests[i-len(menuParser.dirs)])
				karamba.changeTextColor(widget,self.texts[i], conf.dirPathColor[0], conf.dirPathColor[1], conf.dirPathColor[2])
				karamba.hideImage(widget,self.items[i])
				karamba.showImage(widget,self.tabs[i])
				#self.updateIcons(widget,menuParser,conf)
		karamba.redrawWidget(widget)

	def riseMenu(self,widget,menuParser,conf):
		if self.menuUp == 0:
			self.showItems = self.menuLen
			if conf.autoResize==1:
				karamba.resizeWidget(widget, 200, 50+self.showItems*24)
				karamba.redrawWidget(widget)
			for i in range (0,self.menuLen+1):
				karamba.moveWidget(widget,conf.menuDispX,(conf.yReso-50 - conf.menuDispY)-i*24)
			self.menuUp = 1
			karamba.redrawWidget(widget)


	def lowerMenu(self,widget,menuParser,conf):
		if self.menuUp == 1:
			self.showItems = 0
			if conf.autoResize==1:
				karamba.resizeWidget(widget, 200, 50+self.showItems*24)
				karamba.redrawWidget(widget)
			for i in range (0,self.menuLen+1):
				j=(self.menuLen)-i
				karamba.moveWidget(widget,conf.menuDispX,(conf.yReso-50 - conf.menuDispY)-j*24)
			karamba.redrawWidget(widget)
			self.menuUp = 0


	def modifyMenu(self,widget,menuParser,conf,activeID):
		if activeID > -1: #a item click
			oldMenuLen = len(menuParser.dirs)
			#print activeID
			#print oldMenuLen
			if activeID <= oldMenuLen-1 : #click on dir item
				#if string.count(self.currentPath+"/"+menuParser.dirs[activeID]," "):
				#backshlashing items for conf read
				dirNWS = string.replace(self.currentPath+"/"+menuParser.dirs[activeID], "\\","")
				dirNWS = string.replace(dirNWS, " ","\ ")
				dirNWS = string.replace(dirNWS, "(","\(")
				dirNWS = string.replace(dirNWS, ")","\)")
				#print "corrdir?:",dirNWS
				#else:
				#	dirNWS = self.currentPath+"/"+menuParser.dirs[activeID]
				#if string.count(dirNWS,"\\ "):

				#print ">"+dirNWS+"<"
				self.currentPath = dirNWS
				self.nests.insert(0, menuParser.dirs[activeID])
				#print "Nests:",self.nests
				menuParser.parseDir(self.currentPath)
				#must add base tabs that exist to new menu and menu lenght
				self.menuLen = len(menuParser.dirs)+self.menuLen-oldMenuLen +1
				self.updateText(widget,menuParser,conf,activeID)
				self.updateIcons(widget,menuParser,conf)
				self.menuUp = 0
				self.riseMenu(widget,menuParser,conf)
				#if conf.autoResize==1:
				#	karamba.resizeWidget(widget, 200, 50+self.showItems*24)
				karamba.redrawWidget(widget)
			else: #click on go_Up part of the menu
				nestClicked = activeID - oldMenuLen
				dirLST = self.currentPath
				dirLST = string.replace(dirLST, "\\","")
				dirLST = string.split(dirLST,"/")
				#print "was",dirLST
				dirPressed = self.nests[nestClicked]
				#print dirPressed
				dirPressed = string.replace(dirPressed, "\\","")
				dropFrom = dirLST.index(self.nests[nestClicked])
				dirLST = dirLST[0:dropFrom]
				newCurrentDir = string.join(dirLST,"/")
				newCurrentDir = string.replace(newCurrentDir, " ","\ ")
				newCurrentDir = string.replace(newCurrentDir, "(","\(")
				newCurrentDir = string.replace(newCurrentDir, ")","\)")
				#print "willbe",newCurrentDir
				#seting up new structure
				self.nests = self.nests[nestClicked+1:]
				#print "Pesad:",self.nests
				self.currentPath = newCurrentDir
				menuParser.parseDir(self.currentPath)
				self.menuLen = len(menuParser.dirs) + len(self.nests)-1
				#print "menyypikkus:",self.menuLen
				self.updateText(widget,menuParser,conf,activeID)
				self.updateIcons(widget,menuParser,conf)
				self.menuUp = 0
				self.riseMenu(widget,menuParser,conf)
				#if conf.autoResize==1:
				#	karamba.resizeWidget(widget, 200, 50+self.showItems*24)
				karamba.redrawWidget(widget)







##################################
##  Thread class declaration    ################################################
##################################
class AutoUpdate(threading.Thread):
      def run(self):
        global updateProgress
	global noMouse
	global kill
	global gx
	global gy
	global init
	global c,cnt
	cnt = 0
	killcnt = 0
	lx= gx
	ly= gy
        while(1):
		if kill == 1:
			killcnt=killcnt + 1
			if killcnt > int(2.4*c.FPS):
				break
		else:
			killcnt = 0
		if gx==lx and gy==ly:
			cnt = cnt + 1
		else:
			cnt = 0
			noMouse = 0
		if cnt > int(c.holdMenuUp*c.FPS):
			noMouse = 1
            	updateProgress=1
		lx = gx
		ly = gy
		kill = 1
		time.sleep(1.0/c.FPS) #25 frames per second 1/25=0.04 seconds
		#print 1.0/c.FPS




######################## KARAMBA FUNCS #########################################


def initWidget(widget):
	global parserInst,kmenu,c
	#buggy in current version
	c = ConfigHolder()
	c.autoConfigure()
	updateManager = AutoUpdate()
	updateManager.start()
	parserInst = MenuParser()
	parserInst.configure(c)
	parserInst.parseDir(c.rootDir)
	dirs = parserInst.dirs
	kmenu = MenuHandler()




def widgetUpdated(widget):
    global init
    global noMouse
    global kill
    global gx,gy
    global parserInst,kmenu,c
    kill = 0
    #print "plainUp"
    if (init==0):
	#some skaramba init features
	kmenu.createMenu(widget,parserInst,c)
	if c.showIcons:
		c.loadIconDB(widget)
	init = 1
    if (noMouse == 1 and init==1 and (gx<5 or gx > 195 or gy < 35 or gy>(kmenu.showItems*24+50-1))):
	#update functions when mouse has been quiet and out from widget for while
	kmenu.lowerMenu(widget,parserInst,c)
    else:
    	#funtions that need run on every update
	#activity block code here
    	karamba.redrawWidget(widget)





def widgetClicked(widget, x, y, button):
	global parserInst,kmenu,c,cnt
	cnt=0
	#menuUp = 0
	#print 'Pressed',button,x,y
	if button==1:
		itemPressed=(y-50)/24
		if itemPressed > -1:
			if (len(parserInst.isLeaf)-1) >= itemPressed:
				if parserInst.isLeaf[itemPressed]=='1':
					#print "Exe:",parserInst.comms[itemPressed]
					command = parserInst.comms[itemPressed]
					optKDEStart = string.find(command,'%')
					showName=""
					if string.find(command,'-caption')>-1:
						showName = command[0:string.find(command,'-caption')-1]
					if optKDEStart >-1:
						command = command[0:optKDEStart-1]+"\""+showName+"\""
						#print "cute>",command,"<"
					temp1,temp2,temp3 = popen2.popen3(command)
					temp1.close()
					del temp1
					temp2.close()
					del temp2
					temp3.close()
					del temp3
					kmenu.lowerMenu(widget,parserInst,c)
					kmenu.nests = [""]
					kmenu.currentPath = kmenu.rootPath
					parserInst.parseDir(kmenu.rootPath)
					kmenu.menuLen = len(parserInst.dirs)
					kmenu.updateText(widget,parserInst,c,0)
					kmenu.updateIcons(widget,parserInst,c)
				else:
					kmenu.modifyMenu(widget,parserInst,c,itemPressed)
			else:
				kmenu.modifyMenu(widget,parserInst,c,itemPressed)
		else:
			if kmenu.menuUp==1:
				kmenu.lowerMenu(widget,parserInst,c)
			else:
				kmenu.riseMenu(widget,parserInst,c)





def widgetMouseMoved(widget, x, y, button):
    global updateProgress
    global noMouse
    global gx
    global gy
    global init
    global parserInst,kmenu,c
    cnt=0
    gx = x
    gy = y
    noMuose = 0
    if (init == 1 and updateProgress==1):
	#some heavy calculation stuff 10 frames per second
	#print x,y
	if c.popupOnEnter == 1:
		kmenu.riseMenu(widget,parserInst,c)
	itemSel=(y-50)/24
	kmenu.updateSelect(widget,parserInst,c,itemSel)
	karamba.redrawWidget(widget)

################################## Python funcs ##############################


def kpopupKill():
	conf = commands.getoutput('kill -s SIGKILL 0')
	print conf




# This will be printed when the widget loads.
print "Loaded KPopper menu system coded by jyrit(at)artecdesign.ee"

