#!/bin/bash
#Shell script to rewrite (with different configurations) the MacTopBar theme file
#Licensed under the GNU GPL... you should have a copy of it with your OS, if not, it's at http://www.gnu.org/licenses/gpl.html

function change_xmms {
printf "Please indicate whether you would like the XMMS controls\n\t[1] On\n\t[2] Off\n\t:"
read xmms_ctrl
case $xmms_ctrl in
	1  )	xmms_on=ON
		xmms_hash="";;
	2  )	xmms_on=OFF
		xmms_hash="#";;
esac
printf "You have chosen a setting of $xmms_on\n\n"
return 0
}

function change_date {
printf "Please choose your date display style\n\t[1] UK\n\t[2] US\n\t[3] Inverse UK (year, month, day)\n\t[4] Off\n\t:"
read date
case $date in
	1  )	date_style="UK style"
		date_format="dd/MM/yyyy"
		date_hash="";;
	2  )	date_style="US style"
		date_format="MM/dd/yyyy"
		date_hash="";;
	3  )    date_style="Inverse UK Style"
		date_format="yyyy/MM/dd"
		date_hash="";;
	4  )	date_style=OFF
		date_format="dd/MM/yyyy"
		date_hash="#";;
esac
printf "You have chosen to set the date to $date_style\n\n"
printf "Please indicate whether you would like the day display\n\t[1] On\n\t[2] Off\n\t:"
read day
case $day in
	1  )	day_on=ON
		day_format="ddd";;
	2  )	day_on=OFF
		day_format="";;
esac
printf "You have chosen a setting of $day_on\n\n"
}

function change_clock {
printf "Please indicate whether you would like the clock feature\n\t[1] On\n\t[2] Off\n\t:"
read clock
case $clock in
	1  )	clock_on=ON
		clock_hash="";;
	2  )	clock_on=OFF
		clock_hash="#";;
esac
printf "You have chosen a setting of $clock_on\n\n"
return 0
}

function change_cpu_mtr {
printf "Please indicate whether you would like the CPU meter\n\t[1] On\n\t[2] Off\n\t:"
read cpu_mtr
case $cpu_mtr in
	1  )	cpu_mtr_on=ON
		cpu_mtr_hash="";;
	2  )	cpu_mtr_on=OFF
		cpu_mtr_hash="#";;
esac
printf "You have chosen a setting of $cpu_mtr_on\n\n"
return 0
}

function change_scrsize {
printf "Please enter your screen width:\n\t[a]800\n\t[b]1024\n\t[c]1280\n\t[d]1400\n\t[e]1600\n\t:"
read scr_choice
case $scr_choice in
	a | A  )	scr_width=800;;
	b | B  )	scr_width=1024;;
	c | C  )	scr_width=1280;;
	d | D  )	scr_width=1400;;
	e | E  )	scr_width=1600;;
esac
printf "You have chosen a width of $scr_width\n\n"
return 0
}

function change_style {
printf "Please enter the top bar style you would like, [S]triped or [B]rushed\n\t:"
read style_choice
case $style_choice in
	s* | S* )	barstyle="striped"
			style="Striped (OS X)";;
	b* | B* )	barstyle="brushed"
			style="Brushed Metal";;
esac
printf "You have chosen $style\n\n"
return 0
}

function change_menu {
quit_menu=0
until [ "$quit_menu" = 1 ]; do
printf "\nPlease pick one of the following:\n\t[1] Change bar style (brushed or striped)\n\t[2] Change screen width (800/1024/1280/1400/1600)\n\t[3] Turn on/off CPU meter\n\t[4] Turn on/off clock\n\t[5] Change date display style\n\t[6] Turn on/off XMMS controls\n\t[7] Return to main menu\n\t:"
read change_choice
case $change_choice in
	1) change_style;;
	2) change_scrsize;;
	3) change_cpu_mtr;;
	4) change_clock;;
	5) change_date;;
	6) change_xmms;;
	7) quit_menu=1;;
esac 
done
}

function current_settings {
printf "\nCurrent settings are:\n"
echo "	Style is $style"
echo "	Screen width is $scr_width"
echo "	CPU meter is $cpu_mtr_on"
echo "	Clock is $clock_on"
echo "	Date is $date_style and day is $day_on"
echo "	XMMS control set is $xmms_on"
echo "	========================================="
printf "\n"
return 0
}

#Init XMMS setting
xmms_on=ON
xmms_hash=""

#Init date settings
date_style="UK style"
date_format="dd/MM/yyyy"
date_hash=""

#Init day display setting
day_on=ON
day_format="ddd"

#Init clock setting
clock_on=ON
clock_hash=""

#Init CPU Meter setting
cpu_mtr_on=ON
cpu_mtr_hash=""

#Init screen width setting
scr_width=1024

#Init style setting
barstyle="striped"
style="Striped (OS X)"

echo "Welcome to Rami's Mac Top Bar Theme Configurator!"
current_settings
quit=0
until [ "$quit" = "1" ]; do

echo "You can change however many or few parameters you like. Please enter a choice:"
printf "\t[a] Change every possible thing!\n\t[b] Change screen-width parameters\n\t[c] Change from Striped to Brushed bars\n\t[d] Build my theme file and get me out of here!\n\t:"
read init_choice
case $init_choice in
	'a' | 'A' )	change_menu;;
	'b' | 'B' )	change_scrsize;;
	'c' | 'C' )	change_style;;
	'd' | 'D' )	current_settings
	                echo "Are you sure you wish to generate the theme file and exit [y/n]?"
			read sure_quit
			if [ "$sure_quit" = "y" ] || [ "$sure_quit" = "Y" ]; then
			  quit=1
			else
			  quit=0
			fi;;
	*)		echo "Please enter a valid choice!";;
esac
	
done

rm mactopbar.theme

cat <<- _end.theme_ > mactopbar.theme
	#Copyright BY LUIS MAURAD 
	#modified by Rami Chowdhury
	#Licenced Under GPL	
	
	KARAMBA 	x=0	Y=0 	W=$scr_width H=32 	INTERVAL=500 LOCKED=FALSE	TOPBAR=TRUE  ONTOP=TRUE
	
	IMAGE 		X=0 	 Y=0  	   PATH="pics/$barstyle$scr_width.$xmms_on.png"
	
	#Launch    Kmenu
	CLICKAREA       X=15   Y=0  W=25 H=35 SENSOR=PROGRAM ONCLICK="dcop kicker kicker popupKMenu 0"
	
	#Desktop 1
	CLICKAREA       X=55   Y=0  W=17 H=35 ONCLICK="dcop kwin KWinInterface setCurrentDesktop 1"
	
	#Desktop 2
	CLICKAREA       X=82   Y=0  W=17 H=35 ONCLICK="dcop kwin KWinInterface setCurrentDesktop 2"
	
	#Desktop 3
	CLICKAREA       X=109   Y=0  W=17 H=35 ONCLICK="dcop kwin KWinInterface setCurrentDesktop 3"
	
	#Desktop 4
	CLICKAREA       X=137   Y=0  W=17 H=35 ONCLICK="dcop kwin KWinInterface setCurrentDesktop 4"
	
	#Lock Screen
	CLICKAREA       X=171   Y=0  W=22 H=35 ONCLICK="dcop kdesktop KScreensaverIface lock"
	
	#Exit
	CLICKAREA       X=203   Y=0  W=22 H=35 ONCLICK="dcop ksmserver ksmserver logout 0, 0, 0"
	
	
	#Rewind xmms
	$xmms_hash CLICKAREA       X=$(((scr_width-800)+571))    Y=0  W=10 H=35 SENSOR=PROGRAM ONCLICK="xmms --rew"
	#Pause xmms
	$xmms_hash CLICKAREA       X=$(((scr_width-800)+589))    Y=0  W=15 H=35 SENSOR=PROGRAM ONCLICK="xmms --play-pause"
	
	#Forward xmms
	$xmms_hash CLICKAREA       X=$(((scr_width-800)+611))    Y=0  W=10 H=35 SENSOR=PROGRAM ONCLICK="xmms --fwd"
	
	#Xmmsfind
	$xmms_hash CLICKAREA       X=$(((scr_width-800)+629))    Y=0  W=18 H=35 SENSOR=PROGRAM ONCLICK="xmmsfind_remote"
	
	#Launch    xmms
	$xmms_hash CLICKAREA       X=$(((scr_width-800)+659))    Y=0  W=15 H=35 SENSOR=PROGRAM ONCLICK="xmms"
	
	#Launch    drop down calendar
	CLICKAREA       X=$(((scr_width-800)+733))   Y=0  W=65 H=35 SENSOR=TIME CALWIDTH=60 CALHEIGHT=35
	
	#Time
	<group>
	$clock_hash TEXT X=$(((scr_width-800)+716)) Y=0.5 SENSOR=TIME FONTSIZE=15.5 FONT="Lucida Grande" SHADOW=1 FORMAT="$day_format hh:mm" INTERVAL=5000 COLOR=0,0,0
	$date_hash TEXT X=$(((scr_width-800)+726)) Y=16.5 SENSOR=TIME FONTSIZE=9 FONT="Sans Italic" SHADOW=0 FORMAT="$date_format" INTERVAL=5000 COLOR=0,0,0
	</group>
	
	#Xmms-Song
	$xmms_hash TEXT X=$(((scr_width-800)+571)) Y=16 W=145 H=14 SCROLL=-20 SENSOR=XMMS FONTSIZE=9 FONT="Geneva" SHADOW=0 FORMAT="%title" INTERVAL=1000 COLOR=0,0,0
	
	#CPU-load meter
	<group>
	$cpu_mtr_hash IMAGE X=$(((scr_width-800)+679)) Y=1 W-21 H=14 PATH=pics/cpubar.png
	$cpu_mtr_hash GRAPH X=$(((scr_width-800)+680)) Y=2 W=19 H=12 SENSOR=CPU COLOR=0,0,0 INTERVAL=1000
	</group>
_end.theme_

chmod 775 mactopbar.theme
printf "\nTheme file generated. Have a nice day!\n"
exit 0
