#Copyright by LUIS MARAUD
#modified by Rami Chowdhury
#this import statement allows access to the karamba functions
import karamba
import os

######################################
## Globals
######################################

init = 0
numOfTasks = 0

## Default res
## You don't need to change it.  It should auto-detect.
resX = 1024
resY = 768

## Task display stuff
taskPanels = []
taskText = []

timeText = 0



#this is called when you widget is initialized
def initWidget(widget):
    pass

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    global resX
    global init
    global numOfTasks
    global taskPanels
    global taskText
    global timeText

    if init == 0:

        numOfTasks = (resX - 440)/70


        for i in range(numOfTasks):

	    taskPanels.append(karamba.createImage(widget, 230 + (70*i), 0, "pics/task_new.png"))
	    
	    taskText.append(karamba.createText(widget,  230 + (70*i) + 9, 5, 50, 25,""))

#198
        for text in taskText:
            karamba.changeTextColor(widget,text,0,0,0)
            karamba.changeTextSize(widget,text,11)
            karamba.changeTextShadow(widget, text, 1)

        init = 1


    taskList = karamba.getTaskList(widget)

    for image in taskPanels:
        karamba.hideImage(widget, image)

    for text in taskText:
        karamba.changeText(widget, text, "")
        karamba.changeTextShadow(widget, text, 0)
        karamba.changeTextColor(widget,text,0,0,0)

    length = len(taskList)
    if (numOfTasks < length):
        length = numOfTasks

    for j in range(length):
        taskinfo = karamba.getTaskInfo(widget, taskList[j])

        karamba.showImage(widget, taskPanels[j])
        karamba.changeText(widget, taskText[j], taskinfo[0])

        if (taskinfo[7] == 1):
            karamba.changeTextShadow(widget, taskText[j], 1)
	    karamba.changeTextColor(widget, taskText[j], 30, 30, 30)

        if (taskinfo[5] == 1):
            karamba.changeTextColor(widget,taskText[j],40,40,40)

    karamba.redrawWidget(widget)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    global resX
    global init
    global numOfTasks
    global taskPanels
    global taskText



    taskSelected = (x-230)/70

    ## Make sure its a valid task
    if (0 <= taskSelected < numOfTasks):
	    taskList = karamba.getTaskList(widget)

	    ## perform the task action (see Task API for list of numbers)
	    karamba.performTaskAction(widget, taskList[taskSelected], 8)


    if (taskSelected == numOfTasks):

	    karamba.toggleShowDesktop(widget)

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    global resX
    global init
    global numOfTasks
    global taskPanels
    global taskText

    taskList = karamba.getTaskList(widget)

    for image in taskPanels:
        karamba.hideImage(widget, image)

    for text in taskText:
        karamba.changeText(widget, text, "")
        karamba.changeTextShadow(widget, text, 0)
        karamba.changeTextColor(widget,text,0,0,0)

    length = len(taskList)
    if (numOfTasks < length):
        length = numOfTasks


    for j in range(length):
        taskinfo = karamba.getTaskInfo(widget, taskList[j])

        karamba.showImage(widget, taskPanels[j])
        karamba.changeText(widget, taskText[j], taskinfo[0])


        if (taskinfo[7] == 1):
		karamba.changeTextShadow(widget, taskText[j], 1)
		karamba.changeTextColor(widget, taskText[j], 30, 30, 30)

        if (taskinfo[5] == 1):
            karamba.changeTextColor(widget,taskText[j],40,40,40)


    karamba.redrawWidget(widget)




