#! /usr/bin/perl

###################################################
# metoffice-uk.pl                                 #
# (c) 2003-2004 Nick Glass                        #
# Nick dot Glass at Lycos dot com                 #
###################################################
# metoffice.com uk weather sensor for karamba.    #
# feel free to use this script as you please.     #
###################################################

use HTML::TokeParser;
use LWP::Simple;

# town/city 
# find available towns/cities at
# http://www.metoffice.com/weather/europe/uk/uk.html
my $city = "portsmouth";

# temperature units - uncomment one
my $units = "celcius";
#my $units = "farenheit";
#my $units = "kelvin";

# path to images
my $path = "../metoffice/";

# web page
my $URL  = "http://www.metoffice.com/lib/includes/fsssi/city/$city.html";
my $page = get($URL);


# English days of the week translations
my %days = (
        "Monday"    => "Monday", 
        "Tuesday"   => "Tuesday",
	"Wednesday" => "Wednesday",
	"Thursday"  => "Thursday",
	"Friday"    => "Friday",
	"Saturday"  => "Saturday",
	"Sunday"    => "Sunday"
);


# English forcast text
my @forecast = (
	"Clear Sky","Sunny","Partly Cloudy","Sunny Intervals","Dust",
	"Mist","Fog","Medium-level Cloud","Low-level Cloud","Light Rain Shower",
	"Light Rain Shower","Drizzle","Light Rain","Heavy Rain Shower",
	"Heavy Rain Shower","Heavy Rain","Sleet Shower","Sleet Shower","Sleet",
	"Hail Shower","Hail Shower","Hail","Light Snow Shower",
	"Light Snow Shower","Light Snow","Heavy Snow Shower","Heavy Snow Shower",
	"Heavy Snow","Thundery Shower","Thundery Shower",
	"Thunder Storm","Tropical Storm"
);


#extract title
$page =~ /<title>Met Office: (.*) 5 Day Forecast<\/title>/;
print $1,"\n";

#trim page
$page =~ s/.*<!-- <! Data added here. > -->(.*)<!-- start AdLink banner ad -->.*/$1/s;

my $p = HTML::TokeParser->new(\$page);
while ( my $token = $p->get_token  ) {
	if ( $token->[0] eq "T" ) {
		# extract days
		$_ = $token->[1];
		if ( /(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)/ ) {
			print $days{$1},"\n";
		}
	
	
		# extract temperatures
		$_ = $token->[1];
		if ( /(-?\d+)&deg;C.*/ ) {
			if ( $units eq "kelvin" ) {
				print ($1+273,"K\n");
			} elsif ( $units eq "farenheit" ) {					
				printf ("%d%s",($1*1.8)+32,"F\n");
			} else {
				print ($1,"C\n");
			}
		}
	}	
	
	
	# extract weather and wind symbols
	if ( $token->[0] eq "S" ){
		if ( $token->[1] eq "img") {
			$_ = $token->[2]{src};
			if ( /(images\/w)(\d*)x15.gif/ ) {
				print ($path,$1,$2,"x15.gif\n");
				print (@forecast[$2],"\n");
			}
			if ( /(images\/windsym.*)/ ) {
				print ($path,$1,"\n");
			}			
		}
	}		
}

print "Weather data provided by www.metoffice.com (c) Crown copyright\n";
