#! /usr/bin/perl

###################################################
# metoffice-world.pl                              #
# (c) 2003-2004 Nick Glass                        #
# Nick dot Glass at Lycos dot com                 #
###################################################
# metoffice.com world weather sensor for karamba. #
# feel free to use this script as you please.     #
###################################################

use HTML::TokeParser;
use LWP::Simple;

# world city
# find available cities at:
# http://www.metoffice.com/weather/index.html
my $city = "newyork";

# temperature units - uncomment one
#my $units = "celcius";
my $units = "farenheit";
#my $units = "kelvin";

# path to images
my $path = "../metoffice/";

# web page
my $URL  = "http://www.metoffice.com/worldcity/$city.html";
my $page = get($URL);


# English days of the week translations
my %days = (
        "Mon" => "Monday", 
        "Tue" => "Tuesday",
	"Wed" => "Wednesday",
	"Thu" => "Thursday",
	"Fri" => "Friday",
	"Sat" => "Saturday",
	"Sun" => "Sunday"
);


# English forcast text
my @forecast = (
	"Clear Sky","Sunny","Partly Cloudy","Sunny Intervals","Dust",
	"Mist","Fog","Medium-level Cloud","Low-level Cloud","Light Rain Shower",
	"Light Rain Shower","Drizzle","Light Rain","Heavy Rain Shower",
	"Heavy Rain Shower","Heavy Rain","Sleet Shower","Sleet Shower","Sleet",
	"Hail Shower","Hail Shower","Hail","Light Snow Shower",
	"Light Snow Shower","Light Snow","Heavy Snow Shower","Heavy Snow Shower",
	"Heavy Snow","Thundery Shower","Thundery Shower",
	"Thunder Storm","Tropical Storm"
);

#extract title
$page =~ s/<!-- begin pagetitle -->(.*) 5.*<!-- end pagetitle -->/$1/s;
print $1,"\n";

#trim page
$page =~ s/.*<!-- <! Data added here. > -->(.*)<!-- start AdLink banner ad -->.*/$1/s;

my $p = HTML::TokeParser->new(\$page);
while ( my $token = $p->get_token  ) {
	if ( $token->[0] eq "T" ) {
		# extract days
		$_ = $token->[1];
		if ( /(Mon|Tue|Wed|Thu|Fri|Sat|Sun)/ ) {
			print $days{$1},"\n";
		}	
	}	
	
	
	if ( $token->[0] eq "S" ){		
		if ( $token->[1] eq "img") {
			# weather symbols
			$_ = $token->[2]{src};
			if ( /.*(images\/w)(\d*)x15.gif/ ) {
				print ($path,$1,$2,"x15.gif\n");
				print (@forecast[$2],"\n");
			} 
			
			# temperatures
			if ( /.*images\/t(m?)(\d+)ws?.gif/ ) {
				$temp=$2;
				if ($1 eq "m") {
					$temp=-$2;
				}
				if ( $units eq "kelvin" ) {
					print ($temp+273,"K\n");
				} elsif ( $units eq "farenheit" ) {					
					printf ("%d%s",($temp*1.8)+32,"F\n");
				} else {
					print ($temp,"C\n");
				}				
			}			
		}
	}		
}

print "Weather data provided by www.metoffice.com (c) Crown copyright\n";
