#multi-news superkaramba theme
#this import statement allows access to the karamba functions
import karamba
import time
import os
import string
import rssparser

def prettyText(widget, size, font, colour, shadow, textname):
	r = 0
	g = 0
	b = 0
	if colour == "grey":
		r = 240
		g = 240
		b = 240
	elif colour == "white":
		r = 255
		g = 255
		b = 255
	karamba.changeTextSize(widget, textname, size)
	karamba.changeTextFont(widget, textname, font)
	karamba.changeTextColor(widget, textname, r, g, b)
	karamba.changeTextShadow(widget, textname, shadow)

#this lays out the news (only used when the theme starts)
def layoutNews(widget):
	global chunksh, headlines, headlineUrls, hlinePos, start_url, start_label, headtext, newstext, newsreminder, firstupdate, headimage, headdescription, headtextUrl
	newsreminder = []
	newstext = []
	getNews(widget, start_url)
	hlinePos = [38, 50, 62, 74, 86, 98, 110, 122, 134, 146]
	headtext = karamba.createText(widget, 30, 5, 250, 20, start_label)
	karamba.attachClickArea(widget, headtext)
	headimage = karamba.createImage(widget, 30, 5, "pics/title_tooltip.png")
	karamba.addImageTooltip(widget, headimage, headdescription)

	prettyText(widget, 12, "arial black", "grey", 1, headtext)
	for i in range(0, chunksh):
		newstext = karamba.createText(widget, 45, hlinePos[i], 230, 12, headlines[i])
		karamba.attachClickArea(widget, newstext)
		prettyText(widget, 9, "verdana", "white", 1, newstext)
		newsreminder.append(newstext)

def getMenu(widget):
	global sitemenu, labels, urls, length, chunks, pathtosites
	os.chdir(pathtosites)
	sitesfile = open("files/sites", 'r')
	lines = sitesfile.readlines()
	length = len(lines)
	chunks = length/3#this is why it's important to only have 3 lines per site in your sites file
	for i in range(0,length):
		lines[i] = lines[i].strip("\n")
	labels = []
	urls = []
	start = 1
	for i in range(0,chunks):
		labels.append(lines[start])
		start = start+3
	start = 2
	for i in range(0,chunks):
		urls.append(lines[start])
		start = start+3

#this reads the news headlines and urls into list variables
def getNews(widget, currentsite):
	global headlines, headlineUrls, chunksh, headtextUrl, pathtosites, chunksold, firstupdate, star_url, headdescription
	data = rssparser.parse(start_url)
	channel = data['channel']
	items = data['items']
	headtextUrl = channel['link']
	headdescription = channel['description']
	headlines = []
	for item in items:
		headlines.append(item['title'])
	headlineUrls = []
	for item in items:
		headlineUrls.append(item['link'])
	chunksh = len(headlines)
	if chunksh > 10:
		chunksh = 10
	if firstupdate == 0:
		chunksold = chunksh

#this changes the news when the widget is updated, and the site changed via popupmenu
def changeNews(widget):
	global newsreminder, headlines, hlinePos, start_url, start_label, chunksh, headtext, firstupdate, chunksold, headdescription, headimage
	getNews(widget, start_url)
	if firstupdate == 0:
		karamba.deleteImage(widget, headimage)
		headimage = karamba.createImage(widget, 30, 5, "pics/title_tooltip.png")
		karamba.addImageTooltip(widget, headimage, headdescription)
		karamba.changeText(widget, headtext, start_label)
	else:
		print "chunksold: " + str(chunksold)
		for i in range(0,chunksold):
			karamba.deleteText(widget, newsreminder[i])
		karamba.deleteImage(widget, headimage)
		headimage = karamba.createImage(widget, 30, 5, "pics/title_tooltip.png")
		karamba.addImageTooltip(widget, headimage, headdescription)
		karamba.deleteText(widget, headtext)
		headtext = karamba.createText(widget, 30, 5, 250, 20, start_label)
		layoutNews(widget)
		karamba.redrawWidget(widget)

def deleteNews(widget):
	global newsreminder, headlines, hlinePos, start_url, start_label, chunksh, headtext, firstupdate, chunksold, headdescription, headimage
	for i in range(chunksold):
		karamba.deleteText(widget, newsreminder[i])
	karamba.deleteText(widget, headtext)
	karamba.deleteImage(widget, headimage)

#this is called when you widget is initialized
def initWidget(widget):
#set up initial variables
	global widgetpos, handle, startflag, background, sitemenu, labels, urls, length, chunks, start_url, start_label, menuid, haveXD, addbutton, removebutton, menubutton, pathtosites, firstupdate, chunksold, headimage, loadingon
	loadingon =0
	chunksold = 10
	firstupdate = 0
	basepathtosites = karamba.getThemePath(widget)
	pathtosites = basepathtosites + "/"
	os.chdir(pathtosites)
	#change 'widgetpos' if you want to move the theme further down the screen
	widgetpos = 60
	haveXD = os.system("which Xdialog")
	if haveXD == 0:
		pass
	else:
		haveXD = 1
	startflag = 0
	#start_url and start_label should be the same as the first url and
	#label in your sites file
	start_url = "http://www.osnews.com/files/recent.rdf"
	start_label = "osnews"
	background = karamba.createImage(widget, 0, 0, "pics/news_sites.png")
	handle = karamba.createImage(widget, 280, 40, "pics/handleh.png")
	karamba.attachClickArea(widget, handle)
	addbutton = karamba.createImage(widget, 7, 94, "pics/filenew.png")
	karamba.attachClickArea(widget, addbutton)
	removebutton = karamba.createImage(widget, 7, 124, "pics/fileclose.png")
	karamba.attachClickArea(widget, removebutton)
	menubutton = karamba.createImage(widget, 7, 64, "pics/showmenu.png")
	karamba.attachClickArea(widget, menubutton)
	sitemenu = karamba.createMenu(widget)

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):

	global startflag, chunksh, chunksold, haveXD, addbutton, removebutton, menubutton, firstupdate, loadingon, headtext
	if startflag == 0:
		karamba.addImageTooltip(widget, addbutton, "Add a new feed")
		karamba.addImageTooltip(widget, removebutton, "Remove a feed")
		karamba.addImageTooltip(widget, menubutton, "Select a different feed")
		if loadingon == 1:
			print "deleting loadgingtxt"
			karamba.deleteText(widget, headtext)
			karamba.redrawWidget(widget)
		getMenu(widget)
		layoutNews(widget)
		karamba.redrawWidget(widget)
		if haveXD != 0:
			karamba.hideImage(widget, addbutton)
			karamba.hideImage(widget, removebutton)
		karamba.redrawWidget(widget)

	if startflag == 1:
		print "updating"
		changeNews(widget)
		karamba.redrawWidget(widget)
	karamba.redrawWidget(widget)
	startflag = 1
	firstupdate = 0
	loadingon = 0
	chunksold = chunksh
	positionu = karamba.getWidgetPosition(widget)
	handlewu = karamba.getImageWidth(widget, handle)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	pass

def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
	global handle, widgetpos
	position = karamba.getWidgetPosition(widget)
	handlew = karamba.getImageWidth(widget, handle)
	if position[0] == -280:
		i = -280
		while i < 1:
			karamba.moveWidget(widget, i, widgetpos)
			karamba.redrawWidget(widget)
			i = i+10

def menuItemClicked(widget, menu, id):
	global selection, firstupdate, start_url, start_label, newsreminder, startflag, loadingon, headtext
	index = id * -1
	start_url = urls[selection[index]]
	start_label = labels[selection[index]]
	print "MenuPressed"
	startflag = 0
	firstupdate = 1
	karamba.redrawWidget(widget)
	deleteNews(widget)
	karamba.redrawWidget(widget)
	headtext = karamba.createText(widget, 30, 5, 250, 20, ("Loading: " + start_label + " ..."))
	prettyText(widget, 12, "arial black", "grey", 1, headtext)
	karamba.redrawWidget(widget)
	loadingon = 1
	karamba.redrawWidget(widget)
	karamba.redrawWidget(widget)
	widgetUpdated(widget)

def meterClicked(widget, meter, button):
	global headtextUrl, headlineUrls, chunksh, headtext, newsreminder, menubutton, sitemenu, labels, selection
	selection = {}
	if (meter == headtext) and (button == 1):
		prettyText(widget, 12, "arial black", "black", 0, headtext)
		karamba.redrawWidget(widget)
		os.system("galeon --new-tab '%s' &" %(headtextUrl))
		prettyText(widget, 12, "arial black", "grey", 1, headtext)
		karamba.redrawWidget(widget)
	elif (meter == menubutton) and (button == 1):
		karamba.deleteMenu(widget, sitemenu)
		sitemenu = karamba.createMenu(widget)
		for i in range(0,chunks):
			item = karamba.addMenuItem(widget, sitemenu, labels[i], "")
			#sorts out the id of the item clicked so it's useful
			#id seems to be negative value, convert to positive
			if item < 0:
				item = item * -1
			selection[item] = i
		karamba.popupMenu(widget, sitemenu, 10, 10)
	elif (meter == addbutton) and (button == 1):
		os.system("files/addsites")
		getMenu(widget)
	elif (meter == removebutton) and (button == 1):
		os.system("files/removesites")
		getMenu(widget)
	elif (meter == handle) and (button == 1):
		i = 0
		while i > -281:
			karamba.moveWidget(widget, i, widgetpos)
			karamba.redrawWidget(widget)
			i = i-10
	else:
		for i in range(0,chunksh):
			if (meter == newsreminder[i]) and (button == 1):
				prettyText(widget, 9, "verdana", "black", 0, newsreminder[i])
				karamba.redrawWidget(widget)
				os.system("galeon --new-tab '%s' &" %(headlineUrls[i]))
				prettyText(widget, 9, "verdana", "white", 1, newsreminder[i])
				karamba.redrawWidget(widget)
				break

# This will be printed when the widget loads.
print "Loaded my python extension!"

