#this import statement allows access to the karamba functions
import karamba
import glob
import string
import os
import os.path


#kWinModule = KWinModule()

#############
# settings #
#############

# blink on click
blink = 1

# how many desktops
# you can set the number of desktops here
desktopsCount = 8

# use smoothzoom?
smoothZoom = 0


# your home
home = os.getenv("HOME")

#Path to your favorite iconset and to the standard icon path
iconTheme = home+"/.kde/share/icons/Aqua/"
klogoTheme = home+"/.kde/share/icons/crystal/"

#Path to the link files
#In this directory are all items for the bar
#Just create it and add your items with konqueror
#like you do it on the desktop
filesPath = "/home/petros/.kde/share/apps/karamba/sbluebar/Files/"

# lenghts

# the virtual desktops part
# you can set your own length if you want
#leftPart = 140
if desktopsCount > 4:
	leftPart = ((desktopsCount / 2) * 24) + 40
else:
	leftPart = (desktopsCount * 24) + 40

spaceL = leftPart
rightPart = 380


###################################################################

bar = [ ]

names = [ ]
icons = [ ]
iconsBig = [ ]
iconsZoom52 = [ ]
iconsZoom56 = [ ]
iconsZoom60 = [ ]
commands = [ ]
desktops = [ ]
currDesktop = 0
currDesktopNr = 0

iconCount = 0

iconZoomed = -1

dirState = 0

init = 0
#########################################################

############################
#Autodetect the resolution #
############################
xwin = os.system("which xwininfo")

if (xwin == 0):
	pass
else:
	print "\nCan't find xwininfo in your path."

fp = os.popen("xwininfo -root -stats")
output = fp.read()
output = output.splitlines()
i = 0
for x in output:
	param = x.split()
	if (len(param) > 1):
		if param[0].find("Width:") != -1:
			resX = int(param[1])
		if param[0].find("Height:") != -1:
			resY = int(param[1])
#######################################################

##############
# Initialize #
##############

def Initialize(widget):
	global iconTheme
	global iconPath
	global kickerPath
	global resX
	global resY
	global bar
	global names
	global icons
	global iconsBig
	global iconsZoom52
	global iconsZoom56
	global iconsZoom60
	global commands
	global iconCount
	global xmmsBar
	global dirState
	global init
	global desktops
	global desktopsCount

	iconPath = iconTheme

	if init == 0:

		#hide images
		for i in range(iconCount):
			karamba.hideImage(widget, icons[i])
			karamba.hideImage(widget, iconsBig[i])

		names = [ ]
		icons = [ ]
		iconsBig = [ ]
		iconsZoom52 = [ ]
		iconsZoom56 = [ ]
		iconsZoom60 = [ ]
		commands = [ ]
		iconCount = 0
		iconZoomed = -1

		# add the kmenu button
		names.append("")
		commands.append("dcop kicker kicker popupKMenu 0")
		icons.append(klogoTheme+"48x48/apps/kmenu.png")
		iconsBig.append(klogoTheme+"64x64/apps/kmenu.png")
		iconCount +=1

		fileList = glob.glob(filesPath+"*")
		fileList.sort() # Thanks to genneth
		for fileName in fileList:
			if os.path.isfile(fileName) != 1:
				continue
			file = open(fileName, 'r')
			line = file.readline()
			if string.count(line, "[Desktop Entry]"):
				for line in file.readlines():
					names.append("")
					icons.append("")
					iconsBig.append("")
					commands.append("")
					if line[:4] == "Name":
						strPos = string.find(line, "=") + 1
						names[iconCount] = line[strPos:-1]
					if line[:4] == "Exec":
						strPos = string.find(line, "=") + 1
						commands[iconCount] = line[strPos:-1]
					if line[:4] == "Icon":
						line = string.replace(line, ".png", '')
						strPos = string.find(line, '=') + 1
						if glob.glob(line[strPos:-1]+".png") != []:
							icons[iconCount] = line[strPos:-1]+".png"
							iconsBig[iconCount] = line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/apps/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/apps/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/apps/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/apps/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/apps/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/apps/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/devices/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/devices/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/devices/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/devices/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/devices/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/devices/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/actions/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/actions/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/actions/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/actions/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/actions/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/actions/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/filesystems/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/filesystems/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/filesystems/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"48x48/mimetypes/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"48x48/mimetypes/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png"
						elif glob.glob(iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png") != []:
							icons[iconCount] = iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconTheme+"64x64/mimetypes/"+line[strPos:-1]+".png"
						else:
							icons[iconCount] = iconPath+"48x48/apps/"+line[strPos:-1]+".png"
							iconsBig[iconCount] = iconPath+"64x64/apps/"+line[strPos:-1]+".png"
				iconCount += 1


		# add all icons to the bar
		for i in range(iconCount):
			iconsZoom52.append(iconsBig[i])
			iconsZoom56.append(iconsBig[i])
			iconsZoom60.append(iconsBig[i])

			icons[i] = karamba.createImage(widget, spaceL + (i*64)+8, 40, icons[i])
			karamba.resizeImage(widget, icons[i], 48, 48)
			iconsBig[i] = karamba.createImage(widget,spaceL + (i*64), 32, iconsBig[i])
			karamba.hideImage(widget, iconsBig[i])
			karamba.resizeImage(widget, iconsBig[i], 64, 64)

			iconsZoom52[i] = karamba.createImage(widget, spaceL + (i*64)+6, 38, iconsZoom52[i])
			karamba.hideImage(widget, iconsZoom52[i])
			karamba.resizeImage(widget, iconsZoom52[i], 52, 52)

			iconsZoom56[i] = karamba.createImage(widget, spaceL + (i*64)+4, 36, iconsZoom56[i])
			karamba.hideImage(widget, iconsZoom56[i])
			karamba.resizeImage(widget, iconsZoom56[i], 56, 56)

			iconsZoom60[i] = karamba.createImage(widget, spaceL + (i*64)+2, 34, iconsZoom60[i])
			karamba.hideImage(widget, iconsZoom60[i])
			karamba.resizeImage(widget, iconsZoom60[i], 60, 60)

			karamba.addImageTooltip(widget, icons[i], names[i])



		# virtaul desktops
		nn = 0
		for i in range(desktopsCount):
			if i < (desktopsCount/2) and desktopsCount > 4:
				desktops.append(karamba.createImage(widget, 10+(i*24)+5,  35, "pics/virtual_desktop.png"))
				karamba.createClickArea(widget, 10+(i*24)+5, 35, 24, 21, "dcop kwin KWinInterface setCurrentDesktop "+str((i+1)))
			else:
				desktops.append(karamba.createImage(widget, 10+(nn*24)+5,  60, "pics/virtual_desktop.png"))
				karamba.createClickArea(widget, 10+(nn*24)+5, 60, 24, 21, "dcop kwin KWinInterface setCurrentDesktop "+str((i+1)))
				nn+=1
			karamba.resizeImage(widget, desktops[i], 24, 21)

		karamba.resizeWidget(widget, resX, 103)
		karamba.moveWidget(widget, 0, resY-103)

		karamba.redrawWidget(widget)

		dirState = glob.glob(filesPath+"*")

		init = 1

######################################################
# End Initialize                                     #
######################################################


#this is called when your widget is initialized
def initWidget(widget):
	global resX
	global resY
	global leftPart
	global rightPart
	global desktopsCount
	global kdeConfigFile

	left = karamba.createImage(widget, 0, 0, "pics/left.png")
	karamba.resizeImage(widget, left, leftPart, 103)
	karamba.moveImage(widget, left, 0, 0)

	middle = karamba.createImage(widget, 0, 0, "pics/middle.png")
	karamba.resizeImage(widget, middle, (resX-leftPart-rightPart), 103)
	karamba.moveImage(widget, middle, leftPart, 0)


	pass

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
	global filesPath
	global dirState
	global iconsBig
	global smoothZoom
	global init
	global kWinModule
	global currDesktop
	global currDesktopNr

	if dirState != glob.glob(filesPath+"*"):
		init = 0
	Initialize(widget)

	#pp = os.popen("dcop kwin KWinInterface currentDesktop", "r")
	#desk = pp.read()

	#if desk != currDesktopNr:
	#	print "create.."
	#	karamba.deleteText(widget, currDesktop)
	#	currDesktop = karamba.createText(widget, 10, 20, 100, 10, "Desktop: "+str(desk))
	#	currDesktopNr = desk
	#	for task in karamba.getTaskList(widget):
	#		taskInfo = karamba.getTaskInfo(widget, task)
	#		if taskInfo[3] == int(currDesktopNr):
	#			print "Tasks: "+taskInfo[0]
	
	pass

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	global iconCount
	global spaceL
	global commands
	global blinks
	global icons
	global iconsBig
	global iconsZoom52
	global iconsZoom56
	global iconsZoom60
	global smoothZoom

	if button == 2:
		os.system("kstart konqueror "+filesPath)
	elif button == 1 and spaceL <= x <= spaceL+(iconCount*64)+8 and 40 <= y <= 88:
		icon = (x-spaceL) / 64
		if 0 <= icon < iconCount:
			os.system(commands[icon]+" &")
			for i in range(blink):
				karamba.hideImage(widget, iconsBig[icon])
				if smoothZoom:
					karamba.showImage(widget, iconsZoom60[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsBig[icon])
					karamba.showImage(widget, iconsZoom60[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom60[icon])
					karamba.showImage(widget, iconsZoom56[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom56[icon])
					karamba.showImage(widget, iconsZoom52[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom52[icon])
				karamba.showImage(widget, icons[icon])
				karamba.redrawWidget(widget)

				karamba.hideImage(widget, icons[icon])

				if smoothZoom:
					karamba.showImage(widget, iconsZoom52[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom52[icon])
					karamba.showImage(widget, iconsZoom56[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom56[icon])
					karamba.showImage(widget, iconsZoom60[icon])
					karamba.redrawWidget(widget)

					karamba.hideImage(widget, iconsZoom60[icon])

				karamba.showImage(widget, iconsBig[icon])
				karamba.redrawWidget(widget)
	pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
	#Warning:  Don't do anything too intensive here
	#You don't want to run some complex piece of code everytime the mouse moves
	global iconZoomed
	global Kicon
	global KiconBig
	global icons
	global iconsBig
	global iconsZoom52
	global iconsZoom56
	global iconsZoom60
	global smoothZoom
	global xmmsBar

	if  spaceL <= x <= spaceL+(iconCount*64)+8 and 40 <= y <= 88:
		icon = (x-spaceL) / 64
		if 0 <= icon < iconCount and icon != iconZoomed:
			if iconZoomed > -1:
				karamba.hideImage(widget, iconsBig[iconZoomed])
			karamba.hideImage(widget, icons[icon])
			if smoothZoom:
				if iconZoomed > -1:
					karamba.showImage(widget, iconsZoom60[iconZoomed])
				karamba.showImage(widget, iconsZoom52[icon])
				karamba.redrawWidget(widget)

				if iconZoomed > -1:
					karamba.hideImage(widget, iconsZoom60[iconZoomed])
					karamba.showImage(widget, iconsZoom56[iconZoomed])
				karamba.hideImage(widget, iconsZoom52[icon])
				karamba.showImage(widget, iconsZoom56[icon])
				karamba.redrawWidget(widget)

				if iconZoomed > -1:
					karamba.hideImage(widget, iconsZoom56[iconZoomed])
					karamba.showImage(widget, iconsZoom52[iconZoomed])
				karamba.hideImage(widget, iconsZoom56[icon])
				karamba.showImage(widget, iconsZoom60[icon])
				karamba.redrawWidget(widget)

				if iconZoomed > -1:
					karamba.hideImage(widget, iconsZoom52[iconZoomed])
				karamba.hideImage(widget, iconsZoom60[icon])

			if iconZoomed > -1:
				karamba.showImage(widget, icons[iconZoomed])
			karamba.showImage(widget, iconsBig[icon])
			karamba.redrawWidget(widget)

			iconZoomed = icon
	elif iconZoomed > -1:
		karamba.hideImage(widget, iconsBig[iconZoomed])
		if smoothZoom:
			karamba.showImage(widget, iconsZoom60[iconZoomed])
			karamba.redrawWidget(widget)

			karamba.hideImage(widget, iconsZoom60[iconZoomed])
			karamba.showImage(widget, iconsZoom56[iconZoomed])
			karamba.redrawWidget(widget)

			karamba.hideImage(widget, iconsZoom56[iconZoomed])
			karamba.showImage(widget, iconsZoom52[iconZoomed])
			karamba.redrawWidget(widget)

			karamba.hideImage(widget, iconsZoom52[iconZoomed])
		karamba.showImage(widget, icons[iconZoomed])
		karamba.redrawWidget(widget)
		iconZoomed = -1
	pass



# This will be printed when the widget loads.
print "Loaded my python extension!"

