/*************************************** 
*  Programma di monitoraggio dati SETI * 
****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mylib.h"


char   path_read_state  [MAXPATH];
char   path_read_outfile[MAXPATH];
char   path_read_work   [MAXPATH];
char   path_read_user   [MAXPATH];

char path_write       [MAXPATH]= "test/seti.test";
char path_write_target[MAXPATH]= "target.theme";

/***** Programma MAIN *****/
int main(void)
{
  /* Puntatori file */
  FILE *fp_out;
  FILE *fp_path;
  
  /* Definizione variabili */
  double n_prog;    /* contiene il valore 'prog' convertito in double*/

  int    n_gau=0; /* contiene il valore convertito in int */
  int    n_spk=0;
  int    n_trp=0;
  int    n_pls=0;  

  double st_ra;     
  double st_dec;    
  double end_ra;    
  double end_dec;  
  double ang_range; 
  double stra_m;
  double endra_m;
  double stdec_m;
  double enddec_m;

  int    stra_hour;    
  int    endra_hour;    
  int    stdec_hour;    
  int    enddec_hour;    
  int    stra_min;    
  int    endra_min;    
  int    stdec_min;    
  int    enddec_min;    


  double x_target=0.; 
  double y_target=0.; 

  double pack_now;    
  double pack_tot;  
  double pack_left; 
  double packt_h;
  double packt_m;
  int    packt_hour;
  int    packt_min;
  double packl_h;
  double packl_m;
  int    packl_hour;
  int    packl_min;

  double nresult;
  double cpu_time;
  double cpu_h;
  double cpu_m;
  double cpu_s;
  int    cpu_hour;
  int    cpu_min;
  int    cpu_sec;

  char   time_rec [MAXLINE];  /* recorded packet time */
  char   name     [MAXLINE];
  char   country  [MAXLINE];
  char   reg_time [MAXLINE];
  char   last_time[MAXLINE];

  char   path_seti[MAXPATH];

  
  /* Configurazione path Seti */
  
  fp_path = fopen("/tmp/seti_path.txt","r");
  
  while (fgets(path_seti,MAXPATH,fp_path) != NULL);

  ChiudiFile(fp_path);

  strcpy (path_read_state,path_seti); 
  strcpy (path_read_outfile,path_seti); 
  strcpy (path_read_work,path_seti); 
  strcpy (path_read_user,path_seti); 

  strcat(path_read_state,"state.sah");
  strcat(path_read_outfile,"outfile.sah");
  strcat(path_read_work,"work_unit.sah");
  strcat(path_read_user,"user_info.sah");

  /*  printf("\n%s\n",path_read_state);
  printf("\n%s\n",path_read_outfile);
  printf("\n%s\n",path_read_work);
  printf("\n%s\n",path_read_user);*/

  /* Lettura ed Elaborazione Dati file 'state.sah' */

  n_prog=SetiState("prog=",path_read_state); /* barra progressiva */ 
  n_prog*=100.0; /* moltiplico per 100 */
  printf("%.1f\n",n_prog); 

  pack_now=SetiState("cpu=", path_read_state); /*tempo tot elab */ 
  pack_tot=(pack_now)/((SetiState("prog=",path_read_state))+0.00001); 
  pack_left=pack_tot-pack_now ; /* tempo rimanente pacchetto */ 

  packt_h   =pack_tot/3600.0;
  packt_hour=(int)packt_h;
  packt_m   =(packt_h-(double)packt_hour)*60;
  packt_min =(int)packt_m;

  packl_h   =pack_left/3600.0;
  packl_hour=(int)packl_h;
  packl_m   =(packl_h-(double)packl_hour)*60;
  packl_min =(int)packl_m;




  /* Lettura ed Elaborazione Dati file 'outfile.sah' */

  n_gau+=SetiOutfile("gaussian",path_read_outfile); 
  n_spk+=SetiOutfile("spike",path_read_outfile); 
  n_trp+=SetiOutfile("triplet",path_read_outfile); 
  n_pls+=SetiOutfile("pulse",path_read_outfile); 
  
  printf("%d\n",n_gau*12); /* stampa su schermo il valore ottenuto */
  printf("%d\n",n_spk*12); 
  printf("%d\n",n_trp*12); 
  printf("%d\n",n_pls*12); 


  /* Lettura ed Elaborazione Dati file 'work_unit.sah' */
  st_ra=    SetiState   ("start_ra=",path_read_work); 
  st_dec=   SetiState   ("start_dec=",path_read_work); 
  end_ra=   SetiState   ("end_ra=",path_read_work); 
  end_dec=  SetiState   ("end_dec=",path_read_work); 
  ang_range=SetiState   ("angle_range=",path_read_work); 
            SetiWork    ("time_recorded=",path_read_work,time_rec);


  /* Routine per visualizzare mirino su Sky Map */

  if (((st_ra+end_ra)/2.0)>= 12.0 && (((st_ra+end_ra)/2.0) < 24.0))
    {
      x_target= 29.2*(((st_ra+end_ra)/2.0)-12.0); /* convers ore<->pixel */
    }
  else if (((st_ra+end_ra)/2.0) >= 0. && ((st_ra+end_ra)/2.0) < 12.0)
    {
      x_target=29.2*((st_ra+end_ra)/2.0);
    }
  else
    ;

  x_target+=470.5 ; /* centramento ascisse */


  if (((st_ra+end_ra)/2.0) >= 12.0 && ((st_ra+end_ra)/2.0) < 24.0)
    {
      x_target=x_target+(350.5-(2.0*(29.2*(((st_ra+end_ra)/2.0)-12.0))));
      y_target= -1.9666667*(st_dec+end_dec)/2.0; /* convers angolo<->pixel */
      y_target+=355.0;                           /* centramento ordinate */
    }
    else if (((st_ra+end_ra)/2.0) >= 0. && ((st_ra+end_ra)/2.0) < 12.0)
    {
      x_target-=2.0*(x_target-470.5);
      y_target= -1.9666667*(st_dec+end_dec)/2.0; 
      y_target+=355.0;                           
    }
  else
    {
      x_target=470.5;
      y_target+=355.0;                           
    }
   
  /* Trasformazione coord celesti in h e min */ 

  TimeConvHour(st_ra,&stra_hour,&stra_min);
  TimeConvHour(end_ra,&endra_hour,&endra_min);
  TimeConvHour(st_dec,&stdec_hour,&stdec_min);
  TimeConvHour(end_dec,&enddec_hour,&enddec_min);


  /* Lettura ed Elaborazione Dati file 'user_info.sah' */
  
  SetiUser   ("name=",path_read_user,name); 
  SetiUser   ("country=",path_read_user,country); 
  SetiWork   ("register_time=",path_read_user,reg_time);
  SetiWork   ("last_result_time=",path_read_user,last_time);
  
  nresult =  SetiState ("nresults=",path_read_user); 
 
  cpu_time=  SetiState ("total_cpu=",path_read_user);

  /* Conversione in h,min,sec */
  TimeConvSec(cpu_time,&cpu_hour,&cpu_min,&cpu_sec);

  

  /* Apre il file in scrittura */
  fp_out = fopen(path_write,"w");

  fprintf(fp_out,"%.1f",n_prog);  /* stampa perc del pacchetto (state.sah) */
  fputs("%\n",fp_out); 

  fprintf(fp_out,"%d\n",n_gau);   /* stampa n. segnali trovati (outfile.sah) */
  fprintf(fp_out,"%d\n",n_spk);
  fprintf(fp_out,"%d\n",n_trp);
  fprintf(fp_out,"%d\n",n_pls);

  fprintf(fp_out,"%d h. %d'  R.a.\n",stra_hour,stra_min); /*(work_unit.sah)*/
  fprintf(fp_out,"%d h. %d'  Dec.\n",stdec_hour,stdec_min); 
  fprintf(fp_out,"%d h. %d'  R.a.\n",endra_hour,endra_min); 
  fprintf(fp_out,"%d h. %d'  Dec.\n",enddec_hour,enddec_min);
  fprintf(fp_out,"%6.1f\n",ang_range);
  fprintf(fp_out,"- Time Recorded:\n%.24s\n",time_rec); 
  
  fprintf(fp_out,"- User Name:\n%s\n",name); /* info su (info_user.sah)*/
  fprintf(fp_out,"- Country:\n%s\n",country); 
  fprintf(fp_out,"- Seti Registration Date:\n%.24s\n",reg_time); 
  fprintf(fp_out,"- Last Result Date:\n%.24s\n",last_time); 
  fprintf(fp_out,"- Results Returned: %.0f\n",nresult); 
  fprintf(fp_out,"- Total CPU time:\n%.6f\n",cpu_time); 
  fprintf(fp_out,"%d h. %d' %d\"\n",cpu_hour,cpu_min,cpu_sec); 
  

  fprintf(fp_out,"%d h. %d' \n",packt_hour,packt_min); /* info tempo ana pac */
  fprintf(fp_out,"%d h. %d' \n",packl_hour,packl_min);

  /* Chiude il file in scrittura */  
  ChiudiFile(fp_out);
  
  /* Apre il file in scrittura */
  fp_out = fopen(path_write_target,"w");

  fprintf(fp_out,"karamba x=%f y=%f w=20 h=20 locked=true interval=30000\n",x_target,y_target);
  fprintf(fp_out,"image x=0 y=0 PATH=\"pics/frame1.png\"\n");
  fprintf(fp_out,"image x=5 y=5 PATH=\"pics/target.png\"\n");
  /* Chiude il file in scrittura */  
  ChiudiFile(fp_out);


}

  /********* FINE MAIN *********/
  
  
