# SuperKaramba Glas-Bar Theme v0.2 by GeniusR13
# designed on KDE 3.0.2 and still unfinished :-D
#
# The theme is mostly configured in the .theme file as it's adopted from my very first
# karamba theme. Python is used only for the taskbar and pager stuff.
# Beware: this is my first try in python programming (oooops :-)

import karamba
import os
import string
import time
import xmms.control

debug=1

#----- start customizing area -----
pager_12_x = 445                               # y/x coordinates where the pager should appear
pager_34_x = 720
pager_y = 15
pager_h = 34                               # h/w size of the pager
pager_w = 104                     
#pager_mainpic = "Glas/pager-"              # pager picture generic name (i.e. Glas/pager-1.png)

task_x = 833                               # y/x coordinates where the taskbar should appear
task_y = 13 
task_h = 36                                # h/w size of the taskbar
task_w = 397
task_bg_pic = "Glas/taskframe2.png"         # Background pic for task list (looks ugly without)

xmms_title_x = 760                               # y/x coordinates where the xmmsbar should appear
xmms_ctrl_x = 425
xmms_y = 57
xmms_h = 32                                # h/w size of the xmmsbar
xmms_w = 355

#----- end customizing area -----

twidth = 0                                 # width of a task frame pic
theight = 0                                # height of a task frame pic
task_list = []                             # list of current running tasks
task_oldtextlist = []                      # list of displayed task text widgets
task_frametextlist = []                    # list of frame pics
#pager_pic = 0                              # currently displayed pager picture object



#This is called when you widget is initialized
def initWidget(widget):
   
#   global pager_pic
#   global pager_mainpic
#   global pager_12_x
#   global pager_y
   
   #pager_pic = SetPager(widget, pager_pic, pager_mainpic, pager_x, pager_y, 1)
   #xmms_pic = karamba.createImage(widget, xmms_title_x, xmms_y)

   check_xmms(widget)
   karamba.acceptDrops(widget)
   karamba.addMenuConfigOption(widget, "shadow", "Display Shadows")
   create_display(widget)
   check_playing(widget)

   pass



#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
   global task_list
   global task_oldtextlist
   global task_frametextlist
   global task_x
   global task_y
   global task_h
   global task_w
   global task_bg_pic
   global twidth
   global theight
#   global pager_pic
#   global pager_mainpic
#   global pager_12_x
#   global pager_34_x
#   global pager_y

   for this_task in task_oldtextlist:                         # cleanup all displayed tasks
      karamba.deleteText(widget, this_task)

   for this_task in task_frametextlist:                       # cleanup corresponding task pics
      karamba.deleteImage(widget, this_task)

   task_oldtextlist = []                                      # remove deleted elements from list
   task_frametextlist = []

   task_list = karamba.getTaskList(widget)                    # list of all running tasks

   taskcount = len(task_list) + (len(task_list) % 2)          # count of vert. fields
   twidth = task_w / (taskcount / 2)                          # width of a textfield
   theight = task_h / 2                                       # heigt of a textfield
   tx = task_x
   ty = task_y
   istop = 1

   for this_task in task_list:                                # display tasks
      task_info = karamba.getTaskInfo(widget,this_task)       # get info of task

      this_frame = karamba.createImage(widget, tx, ty, task_bg_pic) # build display frame
      karamba.resizeImage(widget,this_frame,twidth-1,theight-1)         # adjust frame size
      task_frametextlist.append(this_frame)

      this_text = karamba.createText(widget, tx+4, ty, twidth-4, theight, task_info[0])
      karamba.changeTextColor(widget, this_text, 64, 64, 64)
      karamba.changeTextSize(widget, this_text, 12)
      karamba.changeTextFont(widget, this_text, "Blue Highway")
      task_oldtextlist.append(this_text)

      if( istop == 1 ):                                       # calc coordinates for next task
         istop = 0
         ty = ty + theight
      else:
         istop = 1
         ty = task_y
         tx = tx + twidth

   #pager_pic = SetPager(widget, pager_pic, pager_mainpic, pager_x, pager_y, 0)
   
   update_title(widget)
   check_playing(widget)   
   
   pass

def widgetClicked(widget, x, y, button):
   global task_list
   global task_x
   global task_y
   global task_h
   global task_w
   global twidth
   global theight
   
   global pager_12_x
   global pager_34_x
   global pager_y
   global pager_h
   global pager_w
   
   global xmms_title_x                               # y/x coordinates where the xmmsbar should appear
   global xmms_ctrl_x
   global xmms_y
   global xmms_h                                # h/w size of the xmmsbar
   global xmms_w

   # only taskbar clicks
   if( (button == 1) and (task_x <= x <= (task_x+task_w)) and (task_y <= y <= (task_y+task_h)) ):  
      tx = x - task_x                    # find the selected (clicked) task by x/y position
      ty = y - task_y
      listnum = (tx / twidth) * 2
      if( ty > theight ):
         listnum = listnum + 1

      karamba.performTaskAction(widget, task_list[listnum], 8)  # execute "smart focus"

   # only pager clicks
   if( (button == 1) and (pager_12_x <= x <= (pager_12_x+pager_w)) and (pager_y <= y <= (pager_y+pager_h)) ):
      if( x < (pager_12_x + (pager_w/2)) ):
            os.system("dcop kwin KWinInterface setCurrentDesktop 1")
      else:
            os.system("dcop kwin KWinInterface setCurrentDesktop 2")

   if( (button == 1) and (pager_34_x <= x <= (pager_34_x+pager_w)) and (pager_y <= y <= (pager_y+pager_h)) ):
      if( x < (pager_34_x + (pager_w/2)) ):
            os.system("dcop kwin KWinInterface setCurrentDesktop 3")
      else:
            os.system("dcop kwin KWinInterface setCurrentDesktop 4")
	    
   if( (button == 1) and (xmms_ctrl_x <= x <= (xmms_ctrl_x + 116)) and (xmms_y <= y <= (xmms_y + 20)) ):
         if (xmms_ctrl_x < x < (xmms_ctrl_x + 20)) and (xmms_y < y < (xmms_y + 20)):
                check_xmms(widget)
                xmms.control.playlist_prev()
		time.sleep(0.1)
		update_title(widget)
         if ((xmms_ctrl_x + 24) < x < (xmms_ctrl_x + 44)) and (xmms_y < y < (xmms_y + 20)):
                check_xmms(widget)
                xmms.control.stop()
		time.sleep(0.1)
		check_playing(widget)
         if ((xmms_ctrl_x + 48) < x < (xmms_ctrl_x + 68)) and (xmms_y < y < (xmms_y + 20)):
                check_xmms(widget)
		xmms.control.play_pause()
		time.sleep(0.1)
		check_playing(widget)
         if ((xmms_ctrl_x + 72) < x < (xmms_ctrl_x + 92)) and (xmms_y < y < (xmms_y + 20)):
                check_xmms(widget)
                xmms.control.playlist_next()
		time.sleep(0.1)
		update_title(widget)
         if ((xmms_ctrl_x + 96) < x < (xmms_ctrl_x + 116)) and (xmms_y < y < (xmms_y + 20)):
                karamba.popupMenu(widget, menu, 475, 10)
		#karamba.execute("kfmclient openProfile audio")
		#xmms.control.playlist_clear()
         if (xmms_title_x < x < (xmms_title_x + xmms_w)) and (xmms_y < y < (xmms_y + 20)):
	        xmms.control.pl_win_toggle(1)

   pass


#def SetPager(widget, pager_pic, pager_mainpic, pager_x, pager_y, isnew):
#   temp = os.popen("dcop kwin KWinInterface currentDesktop")
#   this_desk = temp.read()                                    # get current desktop from dcop
#   this_desk = this_desk.splitlines()
#   this_desk = this_desk[0]
#   temp.close()

#   pager_file = pager_mainpic + str(this_desk) + ".png"       # build filename

#   if( isnew == 0 ):                                          # if not new, remove old object
#      karamba.deleteImage(widget, pager_pic)
#   pager_pic = karamba.createImage(widget, pager_x, pager_y, pager_file) # create pager pic

#   return pager_pic                                           # return the new pic object


# this checks if XMMS is already running and launches it, if not so
# aditionally it hides all XMMS windows. The dealy is needed so XMMS
# can initialize its RPC interface
def check_xmms(widget):
    if not xmms.control.is_running():
        karamba.executeInteractive(widget, ["xmms"])
        time.sleep(1)
        xmms.control.main_win_toggle(0)
        xmms.control.pl_win_toggle(0)
        xmms.control.eq_win_toggle(0)

# this checks if XMMS is playing and displays the appropriate image
def check_playing(widget):
    if xmms.control.is_playing() and not xmms.control.is_paused():
    	karamba.hideImage(widget, play)
	karamba.showImage(widget, pause)
    else:
    	karamba.hideImage(widget, pause)
	karamba.showImage(widget, play)

# this gets the current title for diplay
def update_title(widget):
    trackname = "Now Playing: "+xmms.control.get_playlist_title(xmms.control.get_playlist_pos())
    karamba.changeText(widget, title, trackname)

def create_display(widget):
    global title
    global pause
    global play
    global menu
    global menu_clear
    global menu_open

    trackname = "Now Playing: "+xmms.control.get_playlist_title(xmms.control.get_playlist_pos())
    title=karamba.createText(widget, xmms_title_x, xmms_y, xmms_w, xmms_h, trackname)
    karamba.changeTextColor(widget, title, 64, 64, 64)
    karamba.changeTextSize(widget, title, 13)
    karamba.changeTextFont(widget, title, "Blue Highway")

    if karamba.readMenuConfigOption(widget, "shadow") == 1:
    	karamba.changeTextShadow(widget, title, 1)
    	img="_shadow"
    else:
    	karamba.changeTextShadow(widget, title, 0)
    	img=""

#    pause=karamba.createImage(widget, (xmms_ctrl_x + 77), (xmms_y + 10), "custom_xmms/images/xmms_pause" + img + ".png")
    #play=karamba.createImage(widget, (xmms_ctrl_x + 76), (xmms_y + 11), "custom_xmms/images/xmms_play" + img + ".png")

    menu=karamba.createMenu(widget)
    menu_clear=karamba.addMenuItem(widget, menu, "Clear Playlist", "fileclose")
    menu_open=karamba.addMenuItem(widget, menu, "Open Browser", "fileopen")


#---------------- XMMS -----------------------------------#
    
#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
    check_xmms(widget)
    line = string.split(dropText, "\r\n")
    xmms.control.playlist_add(line)

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass

#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    if id == menu_clear:
        xmms.control.playlist_clear()
    if id == menu_open:
        karamba.execute("kfmclient openProfile audio")

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
     pass

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    pass

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    pass

#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass


# This will be printed when the widget loads.
print "Loaded my python extension!"

