#By Adam Geitgey <adam@rootnode.org>
#web page:  netdragon.sf.net
#Released under the GPL, version 2
#(Except airport.png graphic, which belongs to original author


#this import statement allows access to the karamba functions
import karamba

ifaceText = 0
strengthText = 0

def initWidget(widget):
    global ifaceText
    global strengthText
    
    karamba.addMenuConfigOption(widget, "showtext", "Display Connection Strength Text")
    
    ifaceText = karamba.getThemeText(widget, "iface")
    strengthText = karamba.getThemeText(widget, "strength")

    value = karamba.readMenuConfigOption(widget, "showtext")
    
    if value:
        karamba.showText(widget, ifaceText)
        karamba.showText(widget, strengthText)
    else:
        karamba.hideText(widget, ifaceText)
        karamba.hideText(widget, strengthText)
    karamba.redrawWidget(widget)

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    pass

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    global ifaceText
    global strengthText

    if value:
        karamba.showText(widget, ifaceText)
        karamba.showText(widget, strengthText)
    else:
        karamba.hideText(widget, ifaceText)
        karamba.hideText(widget, strengthText)
    karamba.redrawWidget(widget)
        
#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.  
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    pass

# This will be printed when the widget loads.
print "Loaded my python extension!"

