#This file Copyright 2003, Adam Geitgey 
#Released under the GPL

import os
import karamba

init = 0
entire_playlist = []
display_lines = []
first_displayed_line = 0
last_song = 0

hidden = 0
counter = 0

refresh_counter = 0

def getpos():
    fp = os.popen("xmmsctrl getpos")
    output = fp.read()
    output = output.splitlines()
    if (len(output) > 0):
        return int(output[0])-1
    else:
        return 0
        
def setpos(songnum):
    os.system("xmmsctrl track " + str(songnum+1))

def redispPlaylist(widget):
    global entire_playlist
    global first_displayed_line
    global display_lines
    global refresh_counter

    refresh_counter = refresh_counter + 1

    if refresh_counter >= 5:
        print "doing heavy refresh"
        refresh_counter = 0
        entire_playlist = []
        fp = os.popen("xmmsctrl playlist")
        output = fp.read()
        output = output.splitlines()
        i = 0
        for x in output:
            i=i+1
            playlist = x.split()
            songtitle = playlist[1:]
            texttitle = ""
            for word in songtitle:
                texttitle = texttitle + " " + word
            entire_playlist.append(str(texttitle))

    
    for i in range(51):
            text = display_lines[i]
            karamba.changeText(widget, text, "")

    for i in range(first_displayed_line, len(entire_playlist)):
        if i < (first_displayed_line + 51):
            text = display_lines[i-first_displayed_line]
            texttitle = entire_playlist[i]
            if len(texttitle) > 37:
                texttitle = texttitle[0:38] + "..."
            texttitle = str(i+1) + ". " + texttitle
            karamba.changeText(widget, text, str(texttitle))

            karamba.changeTextColor(widget, text, 255, 255, 255)
            karamba.changeTextSize(widget, text, 9)

    pos = getpos()
    if (first_displayed_line <= pos < (51 + first_displayed_line)):
        karamba.changeTextColor(widget, display_lines[pos-first_displayed_line], 255, 153, 0)
    karamba.redrawWidget(widget)

def initWidget(widget):
    #buggy in current version
    pass

def widgetUpdated(widget):
    global init
    global first_displayed_song
    global last_song
    global hidden
    global counter
    if init == 0:
        init = 1
        hidden = 0
        #karamba.createPopupItem(widget, "fileopen", "Yo h0z!", 4)
        havexctrl = os.system("which xmmsctrl")
        
        if (havexctrl == 0):
            print "\nFound xmmsctrl, excellent!"
        else:
            os.system("kdialog --error \"xmmsctrl could not be found!  Please install it to use this theme.  \nVisit:\nhttp://user.it.uu.se/~adavid/utils/\" --title \"XMMS Bar Error\"")
            print "\nCan't find xmmsctrl in your path.  Please install it to make this work.  "
            #os.system("if xmmsctrl playing; then xmmsctrl pause; else xmmsctrl play; fi")
            #check if xmms open first
            
        fp = os.popen("xmmsctrl playlist")
        output = fp.read()
        output = output.splitlines()
        i = 0
        for x in output:
            i=i+1
            playlist = x.split()
            songtitle = playlist[1:]
            texttitle = ""
            for word in songtitle:
                texttitle = texttitle + " " + word
            entire_playlist.append(str(texttitle))

        for i in range(len(entire_playlist)):
            if i < 51:
                texttitle = entire_playlist[i]
                if len(texttitle) > 37:
                    texttitle = texttitle[0:38] + "..."
                texttitle = str(i+1) + ". " + texttitle

                text = karamba.createText(widget, 10, (i*13)+16, 0, 0, str(texttitle))
                display_lines.append(text)
                karamba.changeTextColor(widget, text, 255, 255, 255)
                karamba.changeTextSize(widget, text, 9)
        if len(display_lines) < 51:
            print "padding display_lines"
            lower = len(display_lines)
            for x in range(lower, 51):
                text = karamba.createText(widget, 10, (x*13)+16, 0, 0, str(""))
                display_lines.append(text)
            
        pos = getpos()
        if (0 < pos < 51):
            karamba.changeTextColor(widget, display_lines[pos], 255, 153, 0)
        karamba.redrawWidget(widget)
    redispPlaylist(widget)
    if hidden == 0:
        counter = counter + 1

    if (counter > 2):
        hidden = 1
        karamba.moveWidget(widget, -273, 0)
            
#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetClicked(widget, x, y, button):
    global last_song
    global first_displayed_line
    global hidden
    global counter
    if (hidden==1):
        karamba.moveWidget(widget, 0, 0)
    hidden = 0
    counter = 0
    selected_song = first_displayed_line + (y-16)/13

    if (first_displayed_line <= selected_song < 51+first_displayed_line) and (button == 1):
        last_song = getpos()
        setpos(selected_song)
        redispPlaylist(widget)
        
    if (button == 4):
        first_displayed_line = first_displayed_line - 5
        if first_displayed_line < 0:
            first_displayed_line = 0
        redispPlaylist(widget)

    if (button == 5):
        first_displayed_line = first_displayed_line + 5
        if first_displayed_line > len(entire_playlist):
            first_displayed_line = len(entire_playlist)-1
        redispPlaylist(widget)
        
#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    global hidden
    global counter
    if (hidden==1):
        karamba.moveWidget(widget, 0, 0)
    hidden = 0
    counter = 0
